//********************************************************
// CameraIso.h: interface for the CameraIso class.
//********************************************************
#ifndef _CAMERAISO_H__
#define _CAMERAISO_H__

#include <iostream>
using namespace std;
#include <GM_Stream.h>

#include <GM_Camera.h>

namespace GM_lib {


class CameraIso : public Camera  
{
	double			_horisontal;
	double			_gh,_gw;			
	void			_reset(GLfloat z=1);	// NB!!! Only for the constructors.
	DisplayObject*	_find(GLuint name);
	void			_drawActivCam();

protected:
	void			_setPerspective();

	void			localDisplay();
	void			localSelect();

public:
	CameraIso(Scene* s);

	CameraIso( const Point<GLfloat,3>&  pos,
			   const Point<GLfloat,3>&  look_at_pos);

	CameraIso( const Point<GLfloat,3>&  pos,
			   const Vector<GLfloat,3>& dir,
			   const Vector<GLfloat,3>& up,
			   GLfloat zoom=1);

	~CameraIso();

	void			lockAtTarget(DisplayObject* obj);
	void			lockAtTarget(const Point<GLfloat,3>& p);
	void			lockAtTarget(double d);
	DisplayObject*	lockAtTargetAtPixel(int,int);
	double			deltaTranslate(LA_DisplayObject *);

	void go(bool stereo=false);	// Running the CameraIso.
	void zoom(GLfloat z);

	void setGrid(double w, double h) { _gw=w; _gh=h; }

	void turn(Angle a) {}
	void tilt(Angle a) {}
	void move(GLfloat d) {}					// Moveing in shooting direction
	void move(const Vector<GLfloat,3>& t) {}// Move in direction t.

	void rotate(Angle, const Vector<GLfloat,3>&) {}
	void rotate(Angle, const Point<GLfloat,3>&,const UnitVector<GLfloat,3>&) {}
	void translate(const Vector<GLfloat,3>& trans_vector) {}

	void rotateGlobal(Angle, const Vector<GLfloat,3>&) {}
	void rotateGlobal(Angle, const Point<GLfloat,3>&,const UnitVector<GLfloat,3>&) {}
	void translateGlobal(const Vector<GLfloat,3>&) {}

	char* identity() { return "CameraIso";}
};


} // end namespace GM_lib

#endif // _CAMERAISO_H__

