#pragma once
#include <GM_DisplayObject.h>


namespace GM_lib {

class CoordinateSystem: public DisplayObject
{
	GL_Color _cx, _cy, _cz;
	GLfloat _x,_y,_z;
	bool _global;

	void _updateSphere() 
	{
		Point3D<GLfloat> s(0,0,0);
		s +=Point3D<GLfloat>(_x,0,0);
		s +=Point3D<GLfloat>(0,_y,0);
		s +=Point3D<GLfloat>(0,0,_z);
		s /= 4.0;
		Sphere<GLfloat,3> sp(Point3D<GLfloat>(0,0,0),(s-Point3D<GLfloat>(0,0,0)).length());
		setSurroundingSphere(sp);
	}
protected:
	void localDisplay()
	{
		Vector3D<GLfloat> x(_x,0,0), y(0,_y,0), z(0,0,_z);

		if(_global)
		{
			GL_Matrix m = _present.inverse2();
			x*=m; y*=m; z*=m;
		}
		GLboolean lg;
		glGetBooleanv(GL_LIGHTING,&lg);
		if(lg) glDisable(GL_LIGHTING);
		glBegin(GL_LINES);
			_cx.glSet(); glVertex3f(0,0,0); glPoint(x);
			_cy.glSet(); glVertex3f(0,0,0); glPoint(y);
			_cz.glSet(); glVertex3f(0,0,0); glPoint(z);
		glEnd();
		if(lg) glEnable(GL_LIGHTING);
	}

public:
	CoordinateSystem(double x=1, double y=1, double z=1, bool global=false):DisplayObject()
	{  
		_x=x; _y=y; _z=z; 
		_global=global;
		setColor();
		_updateSphere(); 
	}

	void setGlobal(bool global=true)					{_global=global;}
	void setLength(double x=1, double y=1, double z=1)	{ _x=x; _y=y; _z=z; _updateSphere(); }
	void setColor(GL_Color cx=Red, GL_Color cy=Green, GL_Color cz=Blue) { _cx = cx; _cy = cy; _cz = cz; }

	// Disable all rotations.
	void rotate(Angle a, const Vector<GLfloat,3>& rot_axel){}
	void rotate(Angle a, const Point<GLfloat,3>& p,const UnitVector<GLfloat,3>& d){}

	void rotateGlobal(Angle a, const Vector<GLfloat,3>& rot_axel){}
	void rotateGlobal(Angle a, const Point<GLfloat,3>& p,const UnitVector<GLfloat,3>& d){}
};

} // End namespace GM_lib