#include <iostream>
using namespace std;

#include <GM_Stream.h>
#include <GM_GlutWindow.h>


using namespace GM_lib;

GM_GlutWindow* GM_GlutWindow::_current = 0;

void GM_GlutWindow::_swapBuffers(void)
{
	glutSwapBuffers(); 
}

GM_GlutWindow::GM_GlutWindow(char* text, int w, int h, int x, int y)
{
	int argc = 1;
	char* argv[1];
	argv[0]	 = text;
	_current = this;

	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
	glutInitWindowSize(w,h);
	glutInitWindowPosition(x,y);
	glutCreateWindow(text);
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutMouseFunc(mouse);
	glutMotionFunc(mouseMotion);
	glutKeyboardFunc(keyboard);
	glutIdleFunc(idle);
	_w = w; _h = h;
	_init();
}


void GM_GlutWindow::mainLoop()
{
	startTime();
	glutMainLoop();
}

void GM_GlutWindow::display()
{
	_current->_display();
}

void GM_GlutWindow::reshape(int w, int h)
{
	_current->_reshape(w,h);
}

void GM_GlutWindow::idle()
{
	glutPostRedisplay();
}

void GM_GlutWindow::mouse(int button, int state, int x, int y)
{
	static Tid tid;
	static bool klick=false;

	double dt = tid.sec();
	if(klick && dt > 0.3) klick=false;

	if(state == GLUT_DOWN)		
	{
		if(klick && dt<0.3) 
		{
			_current->_mouseDoubleClick(button,x,y);	// Dobbel click
			klick = false;
		}
		else
		{
			_current->_mouseButtonDown(button,x,y);
			klick = true; tid.set();
		}
	}
	else if(state == GLUT_UP)
		_current->_mouseButtonUp(button,x,y);
}

void GM_GlutWindow::mouseMotion(int x, int y)
{
	_current->_mouseMotion(x,y);
}


void GM_GlutWindow::keyboard (unsigned char key, int x, int y)
{
	_current->_keyboard(key,x,y);
}
