
#include <GM_Window.h>
using namespace GM_lib;

////////////////////////////////////////////////////////////////////////////
// Implementation of the key definition functions for the windows system. //
//------------------------------------------------------------------------//
///////		You can make your own version of this file!!		////////////
////////////////////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////////////
//************************   Key: +, -  **************************//
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_PLUSS(int x, int y)
{
	if(_viewmode == GM_FLYING)
		_move += Scene::cleanSphere().radius()*0.001;
}

void GM_Window::_keyDef_MINUS(int x, int y)
{
	if(_viewmode == GM_FLYING)
		_move -= Scene::cleanSphere().radius()*0.001;
}

////////////////////////////////////////////////////////////////////
//**************  Key: numbers (0,1,2,3,4,5,6,7,8,9  *************//
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_NULL(int x, int y)
{
	if(_viewmode == GM_FLYING)
		_move = 0.0;
}

////////////////////////////////////////////////////////////////////
//************************   Key: a, A  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_a(int x, int y)
{
	if(_modkey == GM_CONTROL_BUTTON)
	{ 
		_message("Ctrl+a");
		_message("Zoom/Move to all");
		Point3D<GLfloat> pos(Scene::cleanSphere().pos());
		GLfloat rad =  1.7*Scene::cleanSphere().radius();
		pos[2] = pos[2] - rad;
		_camera[_i]->set(pos, Vector3D<GLfloat>(0,0,rad), Vector3D<GLfloat>(0,1,0) );
		_display();
	}
}

void GM_Window::_keyDef_A(int x, int y)
{
	bool on = _camera[_i]->isCoordSysOn();
	if(on)	_message("Axis cross OFF");
	else	_message("Axis cross ON");
	_camera[_i]->coordSys(!on);
	_display();
}

////////////////////////////////////////////////////////////////////
//************************   Key: b, B  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_b(int x, int y)
{
	_message("Pressed: b");
}

void GM_Window::_keyDef_B(int x, int y)
{
	_message("Pressed: B");
}

////////////////////////////////////////////////////////////////////
//************************   Key: c, C  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_c(int x, int y)
{
	_message("Pressed: c");
}

void GM_Window::_keyDef_C(int x, int y)
{
	_message("Pressed: C");
}

////////////////////////////////////////////////////////////////////
//************************   Key: d, D  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_d(int x, int y)
{
	_message("Pressed: d");
}

void GM_Window::_keyDef_D(int x, int y)
{
	_message("Pressed: D");
}

////////////////////////////////////////////////////////////////////
//************************   Key: e, E  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_e(int x, int y)
{
	_message("Pressed: e");
}

void GM_Window::_keyDef_E(int x, int y)
{
	_message("Pressed: E");
}

////////////////////////////////////////////////////////////////////
//************************   Key: f, F  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_f(int x, int y)
{
	_message("Pressed: f");
}

void GM_Window::_keyDef_F(int x, int y)
{
	bool on = _camera[_i]->isFrustrumOn();
	if(on)	_message("Frustrum OFF");
	else	_message("Frustrum ON");
	_camera[_i]->frustrumOn(!on);
	_display();
}


////////////////////////////////////////////////////////////////////
//************************   Key: g, G  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_g(int x, int y)
{
	if(_SelArr.size()>0)
	{
		// Ledig plass
	}
}

void GM_Window::_keyDef_G(int x, int y)
{
	if(_SelArr.size()>0 && _SelArr[0]) 
	{
		if(visible(_SelArr[0]))	_message("Synlig\n");
		else					_message("Ikke synlig\n");
	}
}

////////////////////////////////////////////////////////////////////
//************************   Key: h, H  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_h(int x, int y)
{
	_message("Pressed: h");
}

void GM_Window::_keyDef_H(int x, int y)
{
	_message("Pressed: H");
}

////////////////////////////////////////////////////////////////////
//************************   Key: i, I  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_i(int x, int y)
{
	_message("Pressed: i");
}

void GM_Window::_keyDef_I(int x, int y)
{
	_message("Pressed: I");
}

////////////////////////////////////////////////////////////////////
//************************   Key: j, J  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_j(int x, int y)
{
	_message("Pressed: j");
}

void GM_Window::_keyDef_J(int x, int y)
{
	_message("Pressed: J");
}

////////////////////////////////////////////////////////////////////
//************************   Key: k, K  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_k(int x, int y)
{
	_message("Pressed: k");
}

void GM_Window::_keyDef_K(int x, int y)
{
	_message("Pressed: K");
}

////////////////////////////////////////////////////////////////////
//************************   Key: l, L  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_l(int x, int y)
{
	_camera[_i]->unLockTarget();
	_message("Unlock");
	_display();
}

void GM_Window::_keyDef_L(int x, int y)
{
	_camera[_i]->lockAtTarget(10.0);
	_message("Lock");
	_display();
}

////////////////////////////////////////////////////////////////////
//************************   Key: m, M  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_m(int x, int y)
{
	if(_viewmode<1) _viewmode++;
	else			_viewmode = GM_EXAMINE;

	if(_viewmode == GM_EXAMINE)		_message("EXAMINE!");
	else if(_viewmode == GM_FLYING)	_message("FLYING!");
}

void GM_Window::_keyDef_M(int x, int y)
{
	_message("Pressed: M");
}

////////////////////////////////////////////////////////////////////
//************************   Key: n, N  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_n(int x, int y)
{
	_message("Pressed: n");
}

void GM_Window::_keyDef_N(int x, int y)
{
	_message("Pressed: N");
}

////////////////////////////////////////////////////////////////////
//************************   Key: o, O  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_o(int x, int y)
{
	_message("Pressed: o");
}

void GM_Window::_keyDef_O(int x, int y)
{
	_message("Pressed: O");
}

////////////////////////////////////////////////////////////////////
//************************   Key: p, P  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_p(int x, int y)
{
	_message("Pressed: p");
}

void GM_Window::_keyDef_P(int x, int y)
{
	_message("Pressed: P");
}

////////////////////////////////////////////////////////////////////
//************************   Key: q, Q  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_q(int x, int y)
{
/*	_message("Switch Camera");
	if( _activ[_i] == (_camera.size()-1))	_activ[_i] = 0;
	else									_activ[_i]++;
	_camera[_activ[_i]]->reset();
	_display();*/
	_message("Pressed: q");
}

void GM_Window::_keyDef_Q(int x, int y)
{
	if(_SelArr.size()>0)
	{	
		LA_DisplayObject * tmp=dynamic_cast<LA_DisplayObject *>(_SelArr[0]);
		if (tmp) 
		{
			float dist = _camera[_i]->getDir()*(tmp->getPos()-_camera[_i]->getPos());
			Point3D<float>  p(0.0,0.0,dist);
			Vector3D<float> d(0.0,0.0,-1.0);
			Vector3D<float> u(0.0,1.0,0.0);
			_camera[_i]->set(p,d,u);
		}
	}
}

////////////////////////////////////////////////////////////////////
//************************   Key: r, R  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_r(int x, int y)
{
	_toggleRun();
}

void GM_Window::_keyDef_R(int x, int y)
{
	_message("Pressed: R");
}

////////////////////////////////////////////////////////////////////
//************************   Key: s, S  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_s(int x, int y)
{
	_shaded = !_shaded;
	if(!_shaded)	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	else			glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	_display();
}

void GM_Window::_keyDef_S(int x, int y)
{
	if(stereoToggle())	_message("Stereo on");
	else				_message("Stereo off");
	_display();
}

////////////////////////////////////////////////////////////////////
//************************   Key: t, T  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_t(int x, int y)
{
	_message("Pressed: t");
}

void GM_Window::_keyDef_T(int x, int y)
{
	_message("Pressed: T");
}

////////////////////////////////////////////////////////////////////
//************************   Key: u, U  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_u(int x, int y)
{
	_message("Pressed: u");
}

void GM_Window::_keyDef_U(int x, int y)
{
	_message("Pressed: U");
}

////////////////////////////////////////////////////////////////////
//************************   Key: v, V  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_v(int x, int y)
{
	for(int i=_SelArr.size();i>0;i--)
	{
		_SelArr[i-1]->setSelected(false);
		_SelArr[i-1]->childrenOff();
		_message("Children Off");
		_SelArr.removeIndex(i-1);
	}
	_display();
}

void GM_Window::_keyDef_V(int x, int y)
{
	for(int i=_SelArr.size();i>0;i--)
	{
		_SelArr[i-1]->setSelected(false);
		_SelArr[i-1]->childrenOn();
		_message("Children On");
		_SelArr.removeIndex(i-1);
	}
	_display();
}

////////////////////////////////////////////////////////////////////
//************************   Key: w, W  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_w(int x, int y)
{
	if(_sun)
	{
		if(_sun->isOn()) { _sun->off(); _message("Sun off!"); }
		else			 { _sun->on();  _message("Sun on!"); }
		_display();
	}
}

void GM_Window::_keyDef_W(int x, int y)
{
	_message("Pressed: W");
}

////////////////////////////////////////////////////////////////////
//************************   Key: x, X  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_x(int x, int y)
{
	_message("Pressed: x");
}

void GM_Window::_keyDef_X(int x, int y)
{
	static GLfloat n = 1.0;

	if(n < 10)	n += 1.0;
	else		n = 1.0;
	_camera[_i]->setCutPlane(n, 1000.0);
	_message("switch near-plan");
	_display();
}

////////////////////////////////////////////////////////////////////
//************************   Key: y, Y  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_y(int x, int y)
{
	_message("Pressed: y");
}

void GM_Window::_keyDef_Y(int x, int y)
{
	_message("Pressed: Y");
}

////////////////////////////////////////////////////////////////////
//************************   Key: z, Z  ****************************
////////////////////////////////////////////////////////////////////
void GM_Window::_keyDef_z(int x, int y)
{
	_message("Deselect all");
	for(int i=_SelArr.size();i>0;i--)
	{
		_SelArr[i-1]->setSelected(false);
		_SelArr.removeIndex(i-1);
	}
	_display();
}

void GM_Window::_keyDef_Z(int x, int y)
{
	for(int i=_SelArr.size();i>0;i--)
	{
		_SelArr[i-1]->setSelected(false);
		_SelArr[i-1]->toggleSelector();
		_message("toggleSelector : ");
		_message(_SelArr[i-1]->identity());
		_SelArr.removeIndex(i-1);
	}
	_display();
}



//*********************************************************************
//*********************************************************************
//************             Special keys               *****************
//*********************************************************************
//*********************************************************************

void GM_Window::_keyDef_F1(int x, int y)
{
	_message("Pressed: F1");
}

void GM_Window::_keyDef_F2(int x, int y)
{
	_message("Pressed: F2");
}

void GM_Window::_keyDef_F3(int x, int y)
{
	_message("Pressed: F3");
}

void GM_Window::_keyDef_F4(int x, int y)
{
	_message("Pressed: F4");
}

void GM_Window::_keyDef_F5(int x, int y)
{
	_message("Pressed: F5");
}

void GM_Window::_keyDef_F6(int x, int y)
{
	_message("Pressed: F6");
}

void GM_Window::_keyDef_F7(int x, int y)
{
	_message("Pressed: F7");
}

void GM_Window::_keyDef_F8(int x, int y)
{
	_message("Pressed: F8");
}

void GM_Window::_keyDef_F9(int x, int y)
{
	_message("Pressed: F9");
}

void GM_Window::_keyDef_F10(int x, int y)
{
	_message("Pressed: F10");
}

void GM_Window::_keyDef_F11(int x, int y)
{
	_message("Pressed: F11");
}

void GM_Window::_keyDef_F12(int x, int y)
{
	_message("Pressed: F12");
}

void GM_Window::_keyDef_LEFT(int x, int y)
{
	Angle  deg(1);
	double scale = 0.01;
	if(_camera[_i]->isLocked()) scale *= _camera[_i]->getLockDist();
	else						scale *= Scene::sphere().radius();

	switch(_modkey)
	{
	case GM_CONTROL_BUTTON:
		switch(_viewmode)
		{
		case GM_EXAMINE:
			_message("Turn Scene left");
			_camera[_i]->turn(Angle(-deg));
			break;
		case GM_FLYING:
			_message("Move Camera left");
			_camera[_i]->move('l', scale);
			break;
		default:
			break;
		}	//end switch _viewmode
		break;
	case GM_SHIFT_BUTTON:
//		if(_viewmode == GM_FLYING)
		{
			_message("Roll Camera left");
			_camera[_i]->roll(deg);
		}
		break;
	case GM_NO_BUTTON:
		switch(_viewmode)
		{
		case GM_EXAMINE:
			_message("Move Scene left");
			_camera[_i]->move('r', scale);
			break;
		case GM_FLYING:
			_message("Turn Camera left");
			_camera[_i]->turn(deg);
			break;
		default:
			break;
		}//end switch _viewmode
		break;
	default:
		break;
	}//end switch _modkey

	_display();
}

void GM_Window::_keyDef_UP(int x, int y)
{
	Angle  deg(1);
	double scale = 0.01;
	if(_camera[_i]->isLocked()) scale *= _camera[_i]->getLockDist();
	else						scale *= Scene::sphere().radius();

	switch(_modkey)
	{
	case GM_CONTROL_BUTTON:
		if(_viewmode == GM_EXAMINE || _viewmode == GM_FLYING) _camera[_i]->move(scale); // Move Camera forward
		break;
	case GM_SHIFT_BUTTON:
		if(_viewmode == GM_FLYING)	_camera[_i]->tilt(deg);	// Tilt up
		break;
	case GM_NO_BUTTON:
		switch(_viewmode)
		{
		case GM_EXAMINE:
			_camera[_i]->move('d', scale); // Move Scene Up
			break;
		case GM_FLYING:
			_camera[_i]->move('u', scale); // Move Camera Up
			break;
		default:
			break;
		}//end switch _viewmode
		break;
	default:
		break;
	}//end switch _modkey
	_display();
}


void GM_Window::_keyDef_RIGHT(int x, int y)
{
	Angle  deg(1);
	double scale = 0.01;
	if(_camera[_i]->isLocked()) scale *= _camera[_i]->getLockDist();
	else						scale *= Scene::sphere().radius();

	switch(_modkey)
	{
	case GM_CONTROL_BUTTON:
		switch(_viewmode)
		{
		case GM_EXAMINE:
			_message("Turn Scene right");
			_camera[_i]->turn(deg);
			break;
		case GM_FLYING:
			_message("Move Camera right");
			_camera[_i]->move('r', scale);
			break;
		default:
			break;
		}//end switch _viewmode
		break;
	case GM_SHIFT_BUTTON:
//		if(_viewmode == GM_FLYING)
		{
			_message("Roll right");
			_camera[_i]->roll(-deg);
		}
		break;
	case GM_NO_BUTTON:
		switch(_viewmode)
		{
		case GM_EXAMINE:
			_message("Move Scene right");
			_camera[_i]->move('l', scale);
			break;
		case GM_FLYING:
			_message("Turn Camera right");
			_camera[_i]->turn(-deg);
			break;
		default:
			break;
		}//end switch _viewmode
		break;
	default:
		break;
	}//end switch _modkey
	_display();
}

void GM_Window::_keyDef_DOWN(int x, int y)
{
	Angle  deg(1);
	double scale = 0.01;
	if(_camera[_i]->isLocked()) scale *= _camera[_i]->getLockDist();
	else						scale *= Scene::sphere().radius();

	switch(_modkey)
	{
	case GM_CONTROL_BUTTON:
		if(_viewmode == GM_EXAMINE || _viewmode == GM_FLYING)
		{
			_camera[_i]->move(-scale);
		}
		break;
	case GM_SHIFT_BUTTON:
		if(_viewmode == GM_FLYING)
		{
			_message("Tilt down");
			_camera[_i]->tilt(deg);
		}
		break;
	case GM_NO_BUTTON:
		switch(_viewmode)
		{
		case GM_EXAMINE:
			_message("Move Scene down");
			_camera[_i]->move('u',scale);
			break;
		case GM_FLYING:
			_message("Move Camera down");
			_camera[_i]->move('d',scale);
			break;
		default:
			break;
		}//end switch _viewmode
		break;
	default:
		break;
	}//end switch _modkey
	_display();
}


void GM_Window::_keyDef_PAGE_UP(int x, int y)	// ZOOM IN
{
	_message("Zoomer in");
	_camera[_i]->zoom(1.03);
	_display();
}

void GM_Window::_keyDef_PAGE_DOWN(int x, int y)	// ZOOM OUT
{
	_message("Zoom out");
	_camera[_i]->zoom(1/1.03);
	_display();
}


void GM_Window::_keyDef_HOME(int x, int y)
{
	_message("Pressed: HOME");
}

void GM_Window::_keyDef_END(int x, int y)
{
	_message("Pressed: END");
}

void GM_Window::_keyDef_INSERT(int x, int y)
{
	_message("Pressed: INSERT");
}
