
//////////////////////////////////////////////////////////////////////
// Light.cpp: implementation of the Light class.
//////////////////////////////////////////////////////////////////////
#include <GM_Light.h>

using namespace GM_lib;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Array<GLuint> Light::_free_light(100);
GLuint Light::_next_light = GL_LIGHT0;
GLfloat Light::_min_light_contribution = 100; // equals to  1 / 100

Light::Light()
{
	if(_free_light.size()>0)
	{
		_light_name = _free_light[_free_light.size()-1];
		_free_light.removeLast();
	}
	else			_light_name	= _next_light++;
	setColor();
	cullingOff();
}


Light::Light(	const GL_Color& amb, 
				const GL_Color& dif, 
				const GL_Color& spe)
{
	if(_free_light.size()>0)
	{
		_light_name = _free_light[_free_light.size()-1];
		_free_light.removeLast();
	}
	else			_light_name	= _next_light++;
	setColor(amb,dif,spe);
}


Light::Light(const Light& o)
{
	if(_free_light.size()>0)
	{
		_light_name = _free_light[_free_light.size()-1];
		_free_light.removeLast();
	}
	else			_light_name	= _next_light++;
	setColor(o._ambient,o._diffuse,o._specular);
}


Light::~Light()
{
	_free_light += _light_name;
	glDisable(_light_name);
}
