
//////////////////////////////////////////////////////////////////////
// GM_PSurf.c: implementation of the PSurf class.
//////////////////////////////////////////////////////////////////////
#include "GM_PSurf.h"

using namespace GM_lib;

//////////////////////////////////////////////////////////////////////
// Closest point evaluation
//////////////////////////////////////////////////////////////////////


template <class T, int n>
bool PSurf<T,n>::closestPoint(const Point<T,n>& q, T& u, T& v)
{
	T a11,a12,a21,a22,b1,b2;
	T du,dv,det;

	Point<T,n> p=_present.inverse()*q; //BBang
	for(int i=0; i<20;i++)
	{
		_eval(u, v, 2, 2);
		Vector<T,n> d = p-__p[0];

		a11 = d*__p[3]-__p[1]*__p[1];
		a12 = d*__p[4]-__p[1]*__p[2];
		a21 = a12;
		a22 = d*__p[5]-__p[2]*__p[2];

		b1  = -(d*__p[1]);
		b2  = -(d*__p[2]);

		det = a11*a22-a12*a21;
		du  = (b1*a22-a12*b2)/det;
		dv  = (a11*b2-b1*a21)/det;
//cout << "???"<< du << "--" << dv << endl;
		if(fabs(du)< 1e-6 && fabs(dv) < 1e-6) break;
		u += du;
		v += dv;
	}

	return true;
}

