#include "GM_PathTrack.h"
using namespace GM_lib;


PathTrack::PathTrack(int max_elements, int elementstride, const GL_Color& c)
{
	_color = c;
	_path_full = false;
	_element_stride = elementstride;
	_element =_stride_current_element = 0;
	_recent_path.setSize(max_elements);
	_local_cs = false;									// Plotting in global coordinates.
	setSurroundingSphere(Sphere<GLfloat,3> (Point3D<GLfloat>( 0.0, 0.0, 0.0),100));
	glEnableClientState(GL_VERTEX_ARRAY);
}

void PathTrack::localSimulate(double)
{	
	if (((_stride_current_element++) % _element_stride) == 0) 
	{
		_recent_path[_element++] = centerPos();			//adds the current position to the path.
		if (_element == _recent_path.size()) 
		{
			_recent_path[0] = _recent_path[_element-1]; //first and last are equal.
			_element	= 1;
			_path_full	= true;
		}
	}
}

void PathTrack::localDisplay()
{
	int k =_recent_path.size()-_element;					
	glDisable(GL_LIGHTING);
	_color.glSet();
	glVertexPointer(3,GL_FLOAT,0,_recent_path[0].ptr());
	glDrawArrays(GL_LINE_STRIP,0,_element);
	if (_path_full && k) glDrawArrays(GL_LINE_STRIP,_element,k);
	glEnable(GL_LIGHTING);
}


