#pragma once

#include <GM_LA_DisplayObject.h>

namespace GM_lib {

/*
When this object is attached to another *DisplayObject, it will keep track of
the path of the object. By setting the element size and the stride between 
points one can control the behaviour of the PathTrack object.
*/

class PathTrack: public LA_DisplayObject
{
	Array< Point<GLfloat,3> >   _recent_path; //should be a linked list. containing world coordinates.
	int							_element;
	int							_element_stride;
	int							_stride_current_element;
	bool						_path_full;
	GL_Color					_color;

protected:
	void localSimulate(double);
	void localDisplay();

public:
	PathTrack(int max_elements= 50, int elementstride= 1, const GL_Color& c = GL_Color(155,100,0));

	void setColor(const GL_Color& c) { _color = c; }
};

} // end namespace GM_lib
