
#ifndef _GM_PLAN_H_
#define _GM_PLAN_H_

#include "GM_PSurf.h"

namespace GM_lib{

template <class T, int n>
class Plan : public PSurf<T,n>
{
	void _eval(T u, T v, int d1, int d2);
	
	
protected:
	
	void localDisplay();
	// void localSimulate(double dt);
	T _st_p_u()				{ return T(-1.0); }
	T _end_p_u()			{ return T(1.0); }
	T _st_p_v()				{ return T(-1.0); }
	T _end_p_v()			{ return T(1.0); }

public:
	Plan();
	//Plan(Plan<T,n>& s);
  
	~Plan() {}

	const char* identity() const { return " Plan "  ;}
};
} // GM_lib

using namespace GM_lib;
template <class T, int n>
Plan<T,n>::Plan():PSurf<T,n>()
{
	setSurroundingSphere(Sphere<GLfloat,3>(Point3D<GLfloat>(0.0,0.0,0.0),10.0));
}
template <class T, int n>
void Plan<T,n>::_eval(T u, T v, int d1,int d2)
{

	__p.setDim(d1+1,d2+1);
	__p[0][0][0] = u;
	__p[0][0][1] = v;
	__p[0][0][2] = T(0);

	if(d1) //u				
	{						
		__p[1][0][0] =	T(1);
		__p[1][0][1] =	T(0);
		__p[1][0][2] =	T(0);
	}						
	if(d1>1)//uu			
	{						
		__p[2][0][0] =	T(0);
		__p[2][0][1] =	T(0);
		__p[2][0][2] =	T(0);
	}
	if(d2) //v
	{
		__p[0][1][0] =	T(0);
		__p[0][1][1] =	T(1);	
		__p[0][1][2] =	T(0);	
	}
	if(d2>1) //vv
	{
		__p[0][2][0] =	T(0);	
		__p[0][2][1] =	T(0);	
		__p[0][2][2] =	T(0);	
	}
	if(d1 && d2) //uv
	{
		__p[1][1][0] =	T(0);	
		__p[1][1][1] =	T(0);	
		__p[1][1][2] =	T(0);	
	}
	if(d1>1 && d2)//uuv
	{
		__p[2][1][0] =	T(0);	
		__p[2][1][1] =	T(0);	
		__p[2][1][2] =	T(0);	
	}
	if(d1 && d2>1) //uvv
	{
		__p[1][2][0] =	T(0);	
		__p[1][2][1] =	T(0);	
		__p[1][2][2] =	T(0);	
	}
	if(d1>1 && d2>1) //uuvv
	{
		__p[2][2][0] =	T(0);	
		__p[2][2][1] =	T(0);	
		__p[2][2][2] =	T(0);	
	}

	if(d1>0 && d2>0 && n==3) __n = Vector3D<T>(__p[1][0])^__p[0][1];

}
template <class T, int n>
void Plan<T,n>::localDisplay()
{
	// r_mat.mult();
	PSurf<T,n>::localDisplay();
}
 #endif //_GM_PLAN_H_

