
//********************************************************
// PointLight.h: interface for the PointLight class.
//********************************************************
#ifndef _POINTLIGHT_H__
#define _POINTLIGHT_H__

#include <GM_LA_DisplayObject.h>
#include <GM_Light.h>

namespace GM_lib {

class PointLight : public Light, public LA_DisplayObject  
{
private:
	Sphere<GLfloat,3>	_light_sphere;

protected:
	Point3D<GLfloat>	_pos;
	Point3D<GLfloat>	_attenuation;

	void lighting();
	void _calculateRadius(GLfloat constant, GLfloat linear, GLfloat quadratic);
public:
	PointLight();

	PointLight(	const Point<GLfloat,3>& pos);

	PointLight(	const GL_Color& amb,
				const GL_Color& dif,
				const GL_Color& spe,
				const Point<GLfloat,3>& pos);

	PointLight(	const PointLight& pl);

	virtual ~PointLight();


	void setAttenuation(GLfloat constant, GLfloat linear, GLfloat quadratic);
	void setAttenuation(const GLfloat att[]);

	virtual void culling(const Frustum&);

	const char* identity() const { return "POINTLIGHT";}
};

} // end namespace GM_lib

#endif // _POINTLIGHT_H__
