//////////////////////////////////////////////////////////////////////
// PointLight_G.cpp: implementation of the PointLight_G class.
//////////////////////////////////////////////////////////////////////

#include <GM_PointLight_G.h>
using namespace GM_lib;

GLuint	PointLight_G::_display_list=0;


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PointLight_G::PointLight_G(double rad):PointLight(),_sc(rad)
{
	if(_display_list==0) _makeList();
	setSurroundingSphere(Sphere<GLfloat,3>(Point3D<GLfloat>( 0.0),rad));
}


PointLight_G::PointLight_G(	const Point<GLfloat,3>& pos,
						    double rad):PointLight(pos),_sc(rad)
{
	if(_display_list==0) _makeList();
	setSurroundingSphere(Sphere<GLfloat,3>(Point3D<GLfloat>( 0.0),rad));
}

PointLight_G::PointLight_G(	const GL_Color& amb,
							const GL_Color& dif,
							const GL_Color& spe,
							const Point<GLfloat,3>& pos,
							double rad):PointLight(amb,dif,spe,pos),_sc(rad)
{
	if(_display_list==0) _makeList();
	setSurroundingSphere(Sphere<GLfloat,3>(Point3D<GLfloat>( 0.0),rad));
}

PointLight_G::PointLight_G(	const PointLight_G& pl):PointLight(pl),_sc(pl._sc)
{
	if(_display_list==0) _makeList();
	setSurroundingSphere(Sphere<GLfloat,3>(Point3D<GLfloat>( 0.0),_sc.maxScale()));
}

PointLight_G::PointLight_G(	const PointLight& pl, double rad):PointLight(pl),_sc(rad)
{
	if(_display_list==0) _makeList();
	setSurroundingSphere(Sphere<GLfloat,3>(Point3D<GLfloat>( 0.0),rad));
}

PointLight_G::~PointLight_G()
{
}

void PointLight_G::localDisplay()
{
	GLboolean lg;
	glGetBooleanv(GL_LIGHTING,&lg);
	if(lg) glDisable(GL_LIGHTING);
	_sc.glScaling();
	_getAmbient().glSet();
	glCallList(_display_list);
	if(lg) glEnable(GL_LIGHTING);
}

void PointLight_G::localSelect()
{
	_sc.glScaling();
	glCallList(_display_list);
}

void PointLight_G::_makeList()
{
	Sphere3D sp(1.0,12,8);
	_display_list = glGenLists(1);
	glNewList(_display_list, GL_COMPILE);
		sp.display();
	glEndList();
}