
//********************************************************
// PointLight_G.h: interface for the PointLight_G class.
//********************************************************
#ifndef _POINTLIGHT_G_H__
#define _POINTLIGHT_G_H__

#include <GM_PointLight.h>
#include <GM_Ball.h>

namespace GM_lib {

class PointLight_G : public PointLight//, protected PBall<GLfloat>
{
	static GLuint	_display_list;
	ScaleObj		_sc;
	void			_init();

	void _makeList();
	void localDisplay();
	void localSelect();

public:
	PointLight_G(double rad = 0.5);

	PointLight_G(const Point<GLfloat,3>& pos,
				 double rad = 0.5);

	PointLight_G(const GL_Color& amb,
				 const GL_Color& dif,
				 const GL_Color& spe,
				 const Point<GLfloat,3>& pos,
				 double rad = 0.5);

	PointLight_G(const PointLight_G& pl);
	
	PointLight_G(const PointLight& pl, double rad=0.5);

	virtual ~PointLight_G();

	const char* identity() const { return "POINTLIGHT_G";}
};

} // end namespace GM_lib

#endif // _POINTLIGHT_G_H__
