
//************************************************
//   GM_SelectorGrid.h: draws Controll-polygon
// Every lines in the polygon has to be added.
//************************************************

#ifndef _GM_SELECTOR_GRID_H_
#define _GM_SELECTOR_GRID_H_

#include <GM_Selector.h>

namespace GM_lib{

template <class T, int n>
class SelectorGrid:public Selector<T,n>
{
	Array<Point<T,n>* > _c;

	void localDisplay();
	void localSelect() {}

public:
	SelectorGrid( Point<T,n>& mp, DisplayObject* parent,const GL_Color& c=GL_Color(0.5,0.5,0.9));

	void add(Point<T,n>& p1, Point<T,n>& p2); // add a new line
};


template <class T, int n>
void SelectorGrid<T,n>::localDisplay()
{
	if(_on)
	{
		GLboolean lg;
		glGetBooleanv(GL_LIGHTING,&lg);
		if(lg) glDisable(GL_LIGHTING);
		if(_selected)	_marked.glSet(); 
		else			_default.glSet();
		glBegin(GL_LINES);
			for(int i=0;i<_c.size();i++) glPoint(_c[i]);
		glEnd();
		if(lg) glEnable(GL_LIGHTING);
	}
}

template <class T, int n>
SelectorGrid<T,n>::SelectorGrid( Point<T,n>& mp, DisplayObject* parent,
								 const GL_Color& c):Selector<T,n>(mp,-1,parent)
{
	_type_id	= 11;
	_default	= c;
	_marked		= c.inverse();
	_root		= NULL;
	_scale.reset();
	translate(-mp);
	setSurroundingSphere(Sphere<GLfloat,3>(mp,0.01));
}

template <class T, int n>
inline
void SelectorGrid<T,n>::add(Point<T,n>& p1, Point<T,n>& p2)
{
	_c += &p1;
	_c += &p2;
//	updateSurroundingSphere(p1);
//	updateSurroundingSphere(p2);
}


} // GM_lib

#endif // _GM_SELECTOR_GRID_H_