
//********************************************************
// SpotLight.h: interface for the SpotLight class.
//********************************************************
#ifndef _SPOTLIGHT_H__
#define _SPOTLIGHT_H__

#include <GM_PointLight.h>

namespace GM_lib {

class SpotLight : public PointLight  
{
protected:
	Vector3D<GLfloat>	_dir;
	Angle				_cutoff;
	double				_exp;

	void lighting();

public:
	SpotLight();

	SpotLight(	const Point<GLfloat,3>& pos,
				const Vector<GLfloat,3>& dir,
					  Angle cut_off = 90);

	SpotLight(	const GL_Color& amb,
				const GL_Color& dif,
				const GL_Color& spe,
				const Point<GLfloat,3>& pos,
				const Vector<GLfloat,3>& dir,
					  Angle cut_off = 90);

	SpotLight(	const SpotLight& pl);

	virtual ~SpotLight();
	
	void setCuttoff(const Angle cut_off);
	void setExponent(double exp);

	const char* identity() const { return "SPOTLIGHT";}
};

} // end namespace GM_lib

#endif // _SPOTLIGHT_H__
