
//********************************************************
// SpotLight_G.h: interface for the SpotLight_G class.
//********************************************************
#ifndef _SPOTLIGHT_G_H__
#define _SPOTLIGHT_G_H__


#include <GM_SpotLight.h>

namespace GM_lib {

class SpotLight_G : public SpotLight  
{
	GLuint		_display_list;
	Material	_material;

	void localDisplay();
	void localSelect();

	void _init(const GL_Color&);

public:
	SpotLight_G();

	SpotLight_G(const Point<GLfloat,3>& pos,
				const Vector<GLfloat,3>& dir,
					  Angle cut_off = 90);

	SpotLight_G(const GL_Color& amb,
				const GL_Color& dif,
				const GL_Color& spe,
				const Point<GLfloat,3>& pos,
				const Vector<GLfloat,3>& dir,
					  Angle cut_off = 90);

	SpotLight_G(	const SpotLight& pl);

	virtual ~SpotLight_G();

	void setMaterial(const Material& m) { _material = m; }

	const char* identity() const { return "SPOTLIGHT_G";}
};

} // end namespace GM_lib

#endif // _SPOTLIGHT_G_H__
