#ifndef StlObject_h
#define StlObject_h
#include "GM_DisplayObject.h"
//---------------------------------------------------------------------------
// 23.01.01 BBang
// Makes a DisplayObject from a binary StereoLitographFile 
// NB! pre-alpha version, beware here be bugs?!
//
// Only tested on Microsoft, probably needs byte-swap in 
// getUli(), getFloat(), and getUint() for certain unix platforms
//---------------------------------------------------------------------------
// #include <GL\glut.h>
#include <iostream>
#include <GM_Sphere.h>
#include <GM_PSurf.h>
using namespace std;
using namespace GM_lib;
class StlObject:public DisplayObject
{
private:
	GLint list_name;
	// GLUquadricObj* kule; // used as place holder, for testing purposes. 
	PSphere<float,3>* kule;

	FILE* stl_file;

	unsigned long getUli();  // binary file utility functions
	float getFloat();
	unsigned int getUint();

	Array<Point3D<float> > vertices;     // storage, each three makes a triangle
	Array<UnitVector3D<float> > normals; // with one normal for each triangle
	Box<float,3> bbox;					 // Bounding box, should be an options 
										 // to render it.
	int readSTLbinary(char* filename);	 // 
#ifdef QT
	int readSTLbinaryQT(char* filename, int flip=1);
#endif
    GL_Color CurrentColor;				 // 
	char* fname;						 // I put the filename in here,
										 // for use in idenity()

		void localDisplay()
	{
	   // Moved this here, to be able to update the objects color
	   glColorMaterial(GL_FRONT,GL_AMBIENT_AND_DIFFUSE);
       glEnable(GL_COLOR_MATERIAL);
	   CurrentColor.glSet();
	   if(list_name) glCallList(list_name);
	   	// Reset
	   glDisable(GL_COLOR_MATERIAL);

	}
	void localSelect()
	{
       glCallList(list_name+1);
	}

public:
	StlObject(float r=10);				 // Makes a Sphere, just for debugging
	StlObject(char* filename, GL_Color c=5, int flip=1); // From file, in given color
	~StlObject();

	const char* identity() const { return fname;}
//	void insert(DisplayObject * obj)	{ insertSubObject(obj); }
	void setColor(GL_Color c){CurrentColor=c;}
	Array<Point<float,3> > getVertices()
	{ 
		Array<Point<float,3> > v;
		v.setSize(vertices.size());
		for(int i=0;i<vertices.size();i++)
			v[i]=vertices[i];
		return v; 
	}
	unsigned int getNumPoints() { return vertices.size(); }
	Array<UnitVector3D<float> > getNormals() { return normals; }
};



#endif // StlObject_h
