//********************************************************
// GM_String.h: interface for the GM_String classes.
//********************************************************
#ifndef GM_STRING_H_
#define GM_STRING_H_

#include <stdlib.h>
#include <string>

#include <GM_Point.h>


namespace GM_lib {

//*********************************************************
//****************  The GM_String class  ******************
//************* Tiny and fast exessable string ************
//*********************************************************

class GM_String: public std::string
{
	static char a[32];
	static int _des;

public:
	GM_String(): std::string()							{}
	GM_String(const char* c): std::string(c)			{}
	GM_String(const std::string& s): std::string(s)		{}
	GM_String(int i): std::string()						{ _itoa(i,a,10); *this = a; }
	GM_String(double d): std::string()					{ _gcvt(d,1+int(d/10.0)+_des,a); *this = a; }
	GM_String(const Point<double,2>& d): std::string()	{ *this = GM_String(d(0))+" "+GM_String(d(1)); }
	GM_String(const Point<double,3>& d): std::string()	{ *this = GM_String(d(0))+" "+GM_String(d(1))+" "+GM_String(d(2)); }
	GM_String(const Point<float,2>& d): std::string()	{ *this = GM_String(d(0))+" "+GM_String(d(1)); }
	GM_String(const Point<float,3>& d): std::string()	{ *this = GM_String(d(0))+" "+GM_String(d(1))+" "+GM_String(d(2)); }
	GM_String(const Point<int,2>& d): std::string()		{ *this = GM_String(d(0))+" "+GM_String(d(1)); }
	GM_String(const Point<int,3>& d): std::string()		{ *this = GM_String(d(0))+" "+GM_String(d(1))+" "+GM_String(d(2)); }

//	GM_String& operator<<(const char* c)				{ *this += GM_String(c); return *this; }
//	GM_String& operator<<(const GM_String& c)			{ *this += GM_String(c); return *this; }
//	GM_String& operator<<(int c)						{ *this += GM_String(c); return *this; }
//	GM_String& operator<<(double c)						{ *this += GM_String(c); return *this; }
//	GM_String& operator<<(const Point<double,2>& c)		{ *this += GM_String(c); return *this; }
//	GM_String& operator<<(const Point<double,3>& c)		{ *this += GM_String(c); return *this; }
//	GM_String& operator<<(const Point<float,2>& c)		{ *this += GM_String(c); return *this; }
//	GM_String& operator<<(const Point<float,3>& c)		{ *this += GM_String(c); return *this; }
//	GM_String& operator<<(const Point<int,2>& c)		{ *this += GM_String(c); return *this; }
//	GM_String& operator<<(const Point<int,3>& c)		{ *this += GM_String(c); return *this; }

	void setDes(int d=2) { _des = d; }
};



//*********************************************************
//******  Template iostream operators for GM_String  ******
//*********************************************************

template <class T_Stream>
T_Stream& operator<<(T_Stream& out, const GM_String& v)
{ 
	out << (std::string)v;
	return out;
}

template<class T_Stream>
T_Stream& operator>>(T_Stream& in, GM_String& v)
{ 
	in >> (std::string)v;
	return in;
}

} // end namespace GM_lib

#endif // GM_STRING_H_
