
//********************************************************
// Sun.h: interface for the Sun class.
//********************************************************
#ifndef _SUN_H__
#define _SUN_H__

#include <GM_DisplayObject.h>
#include <GM_Light.h>

namespace GM_lib {

class Sun : public Light, public DisplayObject 
{
	Vector<GLfloat,3>	_dir;
	GL_Color			_global_ambient;

	void _setDayLight(double d);

protected:

	void lighting();

public:

	Sun(const Vector<GLfloat,3>& dir = Vector3D<GLfloat>(1,1,1));

	virtual ~Sun();

	void setDayLight(const GL_Color& amb = GL_Color(0.1,0.1,0.1));
	void scaleDayLight(double d) { _setDayLight(d); }

	char* identity() { return "SUN";}
};

} // end namespace GM_lib

#endif // _SUN_H__
