
//********************************************************
// GM_Tid.h: interface for the Tid class.
//********************************************************
#ifndef GM_TID_H
#define GM_TID_H

#include <sys/timeb.h>

namespace GM_lib {



//**********************************************************************
//****************  The Tid (Time) class  ******************************
//** Tid()			  constructor: Do a set(), se below.
//** set()			  get and set the time from the system to the object (reset time)
//** millisec()		  return the millisecond (int) since the objekt last was set  
//** millisecAndSet() do the same as millisec() but also set the object 
//** sec()			  return the second (double) since the objekt last was set
//** secAndSet()	  do the same as sec() but also set the object 
//**********************************************************************

class Tid {

	timeb  	_tid;

public:

	Tid()		{ ftime(&_tid);}		// Default constructor

	void set()	{ ftime(&_tid);}

	int millisec()
	{
		timeb nytid;
		ftime(&nytid);
		return (nytid.time - _tid.time)*1000 + nytid.millitm - _tid.millitm;
	}

	int millisecAndSet()
	{
		int t;
		timeb nytid;
		ftime(&nytid);
		t	= (nytid.time - _tid.time)*1000 + nytid.millitm - _tid.millitm;
		_tid = nytid;
		return t;
	}

	double sec()		{ return millisec()/1000.0; }

	double secAndSet()	{ return millisecAndSet()/1000.0; }
};

} // end namespace GM_lib

#endif /* GM_TID_H */
