#include "GM_Triangle.h"


namespace GM_lib {


template <class T>
TriangleFacets<T>* TriangleSystem<T>::tv=NULL;




//********************************************************
//*************** destructor of the TriangleFacetss ********
//********************************************************

template <class T>
TriangleFacets<T>::~TriangleFacets()
{
	int k=0,r=0,s=0,p=0;
  int i,j;
	for(i=0; i< _tri_order.dim1(); i++)
	{
		for(j=0; j< _tri_order.dim2(); j++)
		{
			r += _tri_order[i][j].maxSize();
			s += _tri_order[i][j].size();
			k += _tri_order[i][j].maxSize() - _tri_order[i][j].size();
			if(_tri_order[i][j].maxSize() > 20) p++;
		}
	}

	int ptbt=8*_tri_order.dim1()*_tri_order.dim2()+8 + 8*_tri_order.dim1();

	cout << "antall element strre enn 20: " << p << " Av totalt: " 
		 << _tri_order.dim1()*_tri_order.dim2() << endl;

	cout << "Total byte pr element i matrise  : " 
		 << (4*r)/((double)_tri_order.dim1()*_tri_order.dim2()) << endl;

	cout << "Total kbyte bruk i matrise  : " << (4*r + ptbt)/1024 << endl;
	cout << "Minimum kbyte bruk i matrise: " << (4*s + ptbt)/1024 << endl;
	cout << "For mye kbyte bruk i matrise: " << (4*k)/1024  << endl;

	cout << "Total byte pr pkt i matrise  : " << (4*r + ptbt)/((double)size()) << endl;
	cout << "Minimum byte pr pkt i matrise: " << (4*s + ptbt)/((double)size()) << endl;
	cout << "For mye byte pr pkt i matrise: " << (4*k)/((double)size()) << endl;

	for(k=i=0; i< size(); i++) k += 4+8+4*(*this)[i].edges().maxSize();
	for(i=0; i< _edge.size(); i++) k += 4*5;
	for(i=0; i< _triangle.size(); i++) k += 14;


	cout << "Totalt brukt memory :" << (4*r+ptbt+k)/1024 << " kbyte\n";


	for(r=k=i=0; i< size(); i++)
	{
		k += (*this)[i].edges().size();
		r += (*this)[i].edges().maxSize();
	}
	cout << "Antall edger i snitt i Verticene: " << ((double)k)/i << endl;
	cout << "Max edger i snitt i Verticene   : " << ((double)r)/i << endl;

	clear();
}

//********************************************************
//*************** find the surrounding triangle **********
//********************************************************

template <class T>
int TriangleFacets<T>::surroundingTriangle(Triangle<T>*& t, const Vertex<T>& v)// const
{
	int k,s,n = 1 << _d;
	Point<T,2>	nb = v.parameter();

	int i=0,j=0;
  int it;
	for(it=1; it <= _d; it++)
	{
		s = n >> it;
		k = i + s;
		if ( _u(k) < nb[0]) i = k;
		k = j + s;
		if ( _v(k) < nb[1]) j = k;
	}

	k=0;
	for (it=_tri_order[i][j].size()-1; it>=0; it--)
		if ( k=v.isInside(_tri_order[i][j](it))) break;

  	t = (it >= 0 ? _tri_order[i][j](it) : NULL);

	return k;
}



//********************************************************
//************* remove the last vertex in array **********
//********************************************************

template <class T>
bool TriangleFacets<T>::removeLastVertex()
{
	(*this)[size()-1].deleteEdges();   
	return removeIndex(size()-1);

}


//********************************************************
//*** SET -COMPUTE THE TRIANGLE SYSTEM FOR THE VERTEX ****
//*** Go through all vertices and if a vertex is on  *****
//*** an edge split the edge and the two neighbour   *****
//*** triangles, or if the vertex is inside one triangle *
//*** split the triangle into tree treangles.   **********
//********************************************************

template <class T>
void TriangleFacets<T>::set(int i)
{
	Triangle<T>* t;
	int k = surroundingTriangle(t, (*this)[i]);

	if (k < 0)
		t->edges()[-(k+1)]->splitt((*this)[i]);		// Split an edge
	else if (k>0)
		t->splitt((*this)[i]);						// Split a triangle
	else
	{
			// Error vertex outside system or?
	}
}


//********************************************************
//************* insert a vertex in the system ************
//********************************************************


template <class T>
bool TriangleFacets<T>::insertVertex(Vertex<T>& v, bool c)
{
	__e.set(*this);

	bool inserted = true;

	int i = index(v);

	if (i<0)

	{
		alwaysInsert(v);
		i = size()-1;
	}
	else
		inserted = false;

	if (!inserted)	
	{
		(*this)[i].setValues(v);			// Vertex is already a vertex
		return inserted;
	}

	
	if (c)	// NY KODE FOR �GJ�E DEN NYE VERTEXEN CONST 12/9 -2001 (MARTIN)
		(*this)[i].setConst();

	set(i);
		
	return inserted;
}


//********************************************************
//************* remove a vertex from the system **********
//********************************************************

template <class T>
bool TriangleFacets<T>::removeVertex(Vertex<T>& v)
{
	__e.set(*this);

	int id = index(v);
	if(id < 0)	return false;

	v.deleteEdges();

//  N� vi sletter en vertex vil den siste vertexen ta plassen til den som
//  slettes og vi m�derfor srge for at alle edgene som har referanse
//  til den siste vertexen f� oppdatert denne.
	T_Array<Edge<T>*> edg = (*this)[size()-1].edges();
	for (int i=0; i < edg.size(); i++)
		edg[i]->swapVertex((*this)[size() - 1],(*this)[id]);

	return removeIndex(id);
}


//********************************************************
//************* remove a vertex from the system **********
//********************************************************

template <class T>
bool TriangleFacets<T>::removeVertexNew(Vertex<T>& v)
{

//	Finn alle Edger p�randa

	Array<Edge<T>*>   o_edg = v.outerEdges();

	removeVertex(v);

//  Vi har n�et hull omrammet av Edger med Vertexer.
//  Kaller n�en funksjon som tetter et hull.

	return fillPolygon(o_edg);
}

//******************************************************************
//************* triangulate a polygon surrounded by edges **********
//******************************************************************

/****
	NY KODE FOR �FYLLE EN POLYGON (UTEN FEIL) 19/9 -2001 (MARTIN)
 ****/
/*
template <class T>
bool TriangleFacets<T>::fillPolygon(T_Array<Edge<T>*>& e)
{
	int i, index;
	bool stop;


	for(i=0; i< e.size(); i++)
	{
		Triangle<T>* t = e[i]->other(NULL);
		t->turn(e[i]);
		Array<Edge<T>*> edg = t->edges();
		if(e[i]->isFirst(e[i]->commonVertex(*edg[1])))
				e[i]->turn();
	}

	for(i=0; i< e.size()-1; i++)
		for(int j=i+1; j< e.size(); j++)
			if(e[i]->isLast(e[j]->firstVertex())) e.swap(i+1,j);


	Edge<T> *a = e[0];
	Edge<T> *b = e[1];

	while(e.size() > 3)
	{
		Array<Vertex<T>*> vA;
		Array<Vertex<T>*> vert;
		Array<Point<T,2> > aPoint;

		Vector2D<T>		v = a->vector2D();
		UnitVector2D<T>	u = v + b->vector2D();
		Vector2D<T>		w = v + b->vector2D();
		Edge<T>			*c= b->next();

		vert.insert(a->firstVertex());
		vert.insert(a->lastVertex());
		vert.insert(b->lastVertex());

		for (i=0; i<3; i++)
			aPoint += vert[2-i]->parameter();

		for (i = 0; i < e.size(); i++)
		{
			vA.insert(e[i]->firstVertex());
			vA.insert(e[i]->lastVertex());
		}

		for (i = 0; i < 3; i++)
			vA.remove(vert[i]);

		stop = false;
		for (i = 0; i < vA.size(); i++)
		{
			Point2D<T> p = vA[i]->pos();
			if (p.isInside(aPoint) != 0)
				stop = true;
		}

		if((u^v) > POS_TOLERANCE && stop == false)
		{
			Edge<T> *ne = new Edge<T>(*(a->firstVertex()),*(b->lastVertex()));
			Triangle<T> *nt = new Triangle<T>(ne,b,a);
			a->swapTriangle(NULL,nt);
			b->swapTriangle(NULL,nt);
			ne->setTriangle(nt,NULL);
			_edge += ne;
			insertTriangle(nt);
			e.remove(a);
			e.remove(b);
			e.insert(ne);

			a = ne;
			index = e.index(a) + 1;
			if (index >= e.size())
				index = 0;
			b = e[index];

			for(i=0; i< e.size(); i++)
			{
				Triangle<T>* t = e[i]->other(NULL);
				t->turn(e[i]);
				Array<Edge<T>*> edg = t->edges();
				if(e[i]->isFirst(e[i]->commonVertex(*edg[1])))
						e[i]->turn();
			}

			for(i=0; i< e.size()-1; i++)
				for(int j=i+1; j< e.size(); j++)
					if(e[i]->isLast(e[j]->firstVertex())) e.swap(i+1,j);
		}
		else
		{
			index = e.index(a) + 1;
			if (index >= e.size())
				index = 0;
			a = e[index];
			if ((index+1) >= e.size())
				b = e[0];
			else
				b = e[index+1];
		}
	}

	Triangle<T> *nt = new Triangle<T>(e[2],e[1],e[0]);
	e[0]->swapTriangle(NULL,nt);
	e[1]->swapTriangle(NULL,nt);
	e[2]->swapTriangle(NULL,nt);
	insertTriangle(nt);

	return 1;
}
*/
template <class T>
bool TriangleFacets<T>::fillPolygon(Array<Edge<T>*>& e)
{
	int i, index;
	bool stop;

/****/ //sorterer og orienterer arrayen av edger

	for(i=0; i< e.size(); i++) // Orienterer alle edgene slik at vertexene kommer i rett rekkeflge
	{
		Triangle<T>* t = e[i]->other(NULL); // Triangelet i denne edgen er n�t.
		t->turn(e[i]);						// Denne edgen er n�frst i edgelista til triangelet
		Array<Edge<T>*> edg = t->edges();	// Vi henter s�alle edgene i triangelet
		if(e[i]->isFirst(e[i]->commonVertex(*edg[1]))) // Vi srger s�for at denne edgen er riktig orientert
				e[i]->turn();
	}

	for(i=0; i< e.size()-1; i++)
		for(int j=i+1; j< e.size(); j++)
			if(e[i]->isLast(e[j]->firstVertex())) e.swap(i+1,j); // sorterer arrayen slik at edgene kommer i rekkeflge.
/****/

	Edge<T> *a = e[0];
	Edge<T> *b = e[1];
	int k0,k1,k2;

	while(e.size() > 3)		// Vi tar edge for edge
	{
		// Angle ang;
		Array<Angle> ang;
		Array<int> index;

		for(i=0 ;i<e.size(); i++) // finne den minste vinkelen
		{
			a = i==0? e[e.size()-1] : e[i-1];
			b = e[i];
			ang += (b->vector2D()).angle(-(a->vector2D()));
		}

		index=ang.sortArray();

		for(i=index.size()-1; i>=0; i--)// hoppe over der det er punkt inne i triangelet.
		{
			k1 = index[i];
			k0 = k1==0 ? e.size()-1 : k1-1;
			k2 = k1==e.size()-1 ? 0 : k1+1;
			for (j=0;  j< e.size(); j++)
			{
				if(j==k0 || j==k1 || j==k2) continue;

				if(e[j]->firstVertex()->parameter().isInside(e[k0]->firstVertex()->parameter(),
															 e[k1]->firstVertex()->parameter(),
															 e[k2]->firstVertex()->parameter()))
															 break;
			}
			if(j==e.size()) break;
		}

		if(i<0) ;//error
		else	// Lag triangel av de to edgene e[index[i-1]] og e[index[i]] 
		{
			a = e[k0];
			b = e[k1];

			Edge<T> *ne = new Edge<T>(*(a->firstVertex()),*(b->lastVertex()));
			Triangle<T> *nt = new Triangle<T>(ne,b,a);
			a->swapTriangle(NULL,nt);
			b->swapTriangle(NULL,nt);
			ne->setTriangle(nt,NULL);
			_edge += ne;
			insertTriangle(nt);
			e[k0] = ne;
			e.remove(b);
		}
	}

	Triangle<T> *nt = new Triangle<T>(e[2],e[1],e[0]);
	e[0]->swapTriangle(NULL,nt);
	e[1]->swapTriangle(NULL,nt);
	e[2]->swapTriangle(NULL,nt);
	insertTriangle(nt);

	return 1;
}
//********************************************************
//*************** Compute normals for all vertices *******
//********************************************************

template <class T>
void TriangleFacets<T>::computeNormals()
{
	for(int i=0;i<size();i++) 
		(*this)[i].setNormal();
}


//********************************************************
//************ find the vertex with given point **********
//********************************************************

template <class T>
Vertex<T>* TriangleFacets<T>::find(const Point<T,3>& p) const
{
int i;
	for(i=0; i<size(); i++)
		if(elem(i).position() == p) break;

	if (i < size()) return &(elem(i));
	else			return NULL;
}


//********************************************************
//************ find the edge with given points  **********
//********************************************************

template <class T>
Edge<T>* TriangleFacets<T>::find(const Point<T,3>& p1, const Point<T,3>& p2) const
{
int i;
	for(i=0; i<_edge.size(); i++)
		if(_edge(i)->hasPoints(p1,p2)) break;

	if (i < _edge.size()) return _edge(i);
	else			return NULL;
}



//**********************************************************
//****** compute delanou triangulation from point set ******
//**********************************************************

template <class T>
void TriangleFacets<T>::delaunayTriangulate() 
{
	__e.set(*this);

	int i,j;

	if(size() < 3) return;

	LX_Array<Vertex<T> >& vertex = *this;

	// Set the size of edge and triangle array to the upper bound.
	// Remember that there is only 3 outer edges.

	_edge.setMax(3*size()+3);
	_triangle.setMax(2*size()+1);

	// Make surrounding box and tree new vertices

	_box.reset(vertex[0].position());

	for (i=1; i<vertex.size(); i++)
		_box += vertex[i].position();

	double dx	  = _box.delta(0);
	double dy	  = _box.delta(1);
	double delta  = dx>dy?dx:dy;

	Vertex<T> p1(_box.minValue(0) - delta,   _box.minValue(1) - delta);
	Vertex<T> p2(_box.maxValue(0) + 3*delta, _box.minValue(1) - delta);
	Vertex<T> p3(_box.minValue(0) - delta,   _box.maxValue(1) + 3*delta);

	vertex += p1;
	vertex += p2;
	vertex += p3;

	// Make tree Edges.

	_edge += new Edge<T>(vertex[vertex.size()-3], vertex[vertex.size()-2]);
	_edge += new Edge<T>(vertex[vertex.size()-2], vertex[vertex.size()-1]);
	_edge += new Edge<T>(vertex[vertex.size()-1], vertex[vertex.size()-3]);

	// Make a triangle.

	_triangle += new Triangle<T>(_edge[0],_edge[1],_edge[2]);

	_edge[0]->setTriangle(_triangle[0],NULL);
	_edge[1]->setTriangle(_triangle[0],NULL);
	_edge[2]->setTriangle(_triangle[0],NULL);

	//**********************************************************************
	// Here we constuct the dervided structure for speeding up the algoritm
	//**********************************************************************

	if(size() < 200)			_d = 2;
	else if(size() < 800)		_d = 3;
	else if(size() < 3200)		_d = 4;
	else if(size() < 12800)		_d = 5;
	else if(size() < 51200)		_d = 6;
	else if(size() < 204800)	_d = 7;
	else						_d = 8;

	int n = 1 << _d;

	_tri_order.setDim(n,n);
	_u.setMax(n+1);
	_v.setMax(n+1);

	for(i=0; i<= n; i++)
	{
		_u += _box.minValue(0) + i*_box.delta(0)/n;
		_v += _box.minValue(1) + i*_box.delta(1)/n;
	}

	for(i=0; i< n; i++)
		for(j=0; j< n; j++)
		{
			_tri_order[i][j].setMax(20);//,10);
			_tri_order[i][j] += _triangle[0];
		}

	//*****************************************************
	// End dervided structure for speeding up the algoritm
	//*****************************************************


	// Go through all vertices and if a vertex is on an edge split the edge
	// and the two neighbour triangles, or if the vertex is inside one triangle
	// split the triangle into tree treangles.

	for (i=0; i < vertex.size()-3; i++)	set(i);	

	// remove constructed outer triangles

	removeLastVertex();
	removeLastVertex();
	removeLastVertex();

	// Insert Edges and Triangles to make a convecs boundary

	int n_bound=0;
	for(i=0; i< _edge.size(); i++)
		if(_edge[i]->boundary())
		{
			n_bound++;
			Triangle<T>* t = _edge[i]->other(NULL);
			t->turn(_edge[i]);
			Array<Edge<T>*> edg = t->edges();
			if(_edge[i]->isFirst(_edge[i]->commonVertex(*edg[1])))
				_edge[i]->turn();
		}

	for(i=0; i< _edge.size(); i++)
		if(_edge[i]->boundary()) break;
	Edge<T> *a = _edge[i];
	Edge<T> *b = a->next();


	for(i=0; i<n_bound;i++)
	{
		Vector2D<T>		v = a->vector2D();
		UnitVector2D<T>	u = v + b->vector2D();
		if((u^v) > POS_TOLERANCE)
		{
			Edge<T> *ne = new Edge<T>(*(a->firstVertex()),*(b->lastVertex()));
			Triangle<T> *nt = new Triangle<T>(ne,b,a);
			a->swapTriangle(NULL,nt);
			b->swapTriangle(NULL,nt);
			ne->setTriangle(nt,NULL);
			_edge += ne;
			insertTriangle(nt);
			a = ne;
			b = a->next();
			i--;
		}
		else
		{
			a = b;
			b = a->next();
		}
	}
}


//********************************************************
//******* Insert a PWVLine into the triangulation ********
//********************************************************

template <class T>
void TriangleFacets<T>::insertPwl(PWVLine<T>& pwl)
{
	__e.set(*this);

	bool next;
	int i,j,k,m;
	T s,t,tt;

	for(i=0; i<pwl.size()-1; i++)
	{
		insertVertex(pwl[i]);
		j = index(pwl[i]);
		Point2D<T> p  = (*this)[j].parameter();		// current point
		Point2D<T> np = pwl[i+1].parameter();		// next new point

		T_Array<Edge<T>*> edg = (*this)[j].edges();

		Array<Point2D<T> > pt;						// Find all neighbour points
		for(k=0; k<edg.size(); k++) 
			pt += edg[k]->otherVertex((*this)[j])->parameter();
		p.setTestType(3,p,Point2D<T>(0,1));
		pt.sort();									// All points sorted in a circle
		tt = 0;

		do
		{
			UnitVector2D<T> v;
			Vector2D<T> v1 = np - p;

			for(k=0; k<pt.size(); k++)				// If the next point is equal one of
				if(np == pt[k]) break;				// the neighbour points continue to
			if(k<pt.size()) break;					// the top and insert the new point.

			for(k=0; k<pt.size(); k++)				// If the next point is on one of
			{										// the neighbour edges continue to
				m = (k == (pt.size()-1))? 0:k+1;	// the top and insert the new point.
				v  = pt[m] - p[k];	
				if(fabs(v^(np-pt[k])) < POS_TOLERANCE ) break;
			}
			if(k<pt.size()) break;

			next = true;

			for(k=0; k<pt.size(); k++)			
			{
				m = (k == (pt.size()-1))? 0:k+1;
				t = 2;

				Vector2D<T> v2 = pt[k] - pt[m];
				Vector2D<T> v3 = pt[k] - p;

				T det = v1^v2;
				if (fabs(det) < 1e-15) continue;
				
				det = 1/det;

				t = -det*(v2.normal()*v3);
				s = det*(v1.normal()*v3);

				if (t>0 && s>=0 && s<=1)
				{
					v = v2;
					break;
				}
			}
			if (t<1)
				if((v^(np-pt[m])) > POS_TOLERANCE)	// outside all triangles
				{
					tt = tt +(1-tt)*t;
					Vertex<T> vt = pwl.interpolate(i,tt);///FEILLLL
					vt.setConst();
					insertVertex(vt);
					j = index(vt);
					p  = (*this)[j].parameter();	

					edg = (*this)[j].edges();
					pt.clear();						// Find all neighbour points
					for(k=0; k<edg.size(); k++) 
						pt += edg[k]->otherVertex((*this)[j])->parameter();
					p.setTestType(3,p,Point2D<T>(0,1));
					pt.sort();						// All points sorted in a circle

					next = false;
				}

		}while(!next);
	}
	insertVertex(pwl[pwl.size()-1]);
}


//********************************************************
//*************** find z-value inside triangle ***********
//********************************************************

/* TAGIT VEK CONST 13/9 (MARTIN */
template <class T>
T TriangleFacets<T>::evalZ(const Point2D<T>& p, int deg) //const
{
	T z=0;
	Triangle<T>* t;
	int idx=surroundingTriangle(t,Vertex<T>(p));
	if (idx) z=t->evalZ(p,deg);
	return z;
}


//********************************************************
//*************** Clear: remove all data *****************
//********************************************************

template <class T>
void TriangleFacets<T>::clear(int d)
{
	__e.set(*this);
	while(_triangle.size()>0)	delete _triangle[0];
	while(_edge.size()>0)		delete _edge[0];
	_triangle.clear();
	_edge.clear();

	((LX_Array<Vertex<T> >*)this)->clear();

	if (d >= 0)
		_d = d;
}


//********************************************************
//*************** Insert a triangle to the system ********
//********************************************************

template <class T>
void TriangleFacets<T>::insertTriangle(Triangle<T>* t)
{
	_triangle += t;

	t->updateBox(_u, _v, _d);

	Box<unsigned char,2> b	= t->box();

	for(int i=b.p(0,0); i<=b.p(1,0); i++)
		for(int j=b.p(0,1); j<=b.p(1,1); j++)
			_tri_order[i][j] += t;
}


//********************************************************
//*************** Remove a triangle from the system ******
//********************************************************

template <class T>
void TriangleFacets<T>::removeTriangle(Triangle<T> *t)
{ 
	_triangle.remove(t);

	Box<unsigned char,2> b	= t->box();

	for(int i=b.p(0,0); i<=b.p(1,0); i++)
		for(int j=b.p(0,1); j<=b.p(1,1); j++)
			_tri_order[i][j].remove(t);
}


//********************************************************
//*************** corrigate the box of an triangle *******
//********************************************************

template <class T>
void TriangleFacets<T>::corrigateTriangle(Triangle<T>* t, bool wider)
{
	int i,j;
	Box<unsigned char,2> b	= t->box();
	t->updateBox(_u, _v, _d);
	Box<unsigned char,2> a	= t->box();

	for(i=b.p(0,0); i<=b.p(1,0); i++)
		for(j=b.p(0,1); j<=b.p(1,1); j++)
			if(i<a.p(0,0) || i>a.p(1,0))		_tri_order[i][j].remove(t);
			else if(j<a.p(0,1) || j>a.p(1,1))	_tri_order[i][j].remove(t);
	if(wider)
		for(i=a.p(0,0); i<=a.p(1,0); i++)
			for(j=a.p(0,1); j<=a.p(1,1); j++)
				if(i<b.p(0,0) || i>b.p(1,0))		_tri_order[i][j] += t;
				else if(j<b.p(0,1) || j>b.p(1,1))	_tri_order[i][j] += t;
}


//*****************************************************************
//*********** compute the index of the box to the triangle ********
//*****************************************************************

template <class T>
void Triangle<T>::updateBox(T_Array<T>& u,T_Array<T>& v, int d)
{
	int k,s,n = 1 << d;
	int i0=0, i1=n, j0=0, j1=n;
	Array<Vertex<T>*>  ve = vertices();
	Box<T,2>		   b(ve[0]->parameter(),ve[1]->parameter(),ve[2]->parameter());

	for(int i=1; i <= d; i++)
	{
		s = n >> i;
		k = i0 + s;
		if ( u[k] < b.minValue(0)) i0 = k;
		k = i1 - s;
		if ( u[k] > b.maxValue(0)) i1 = k;
		k = j0 + s;
		if ( v[k] < b.minValue(1)) j0 = k;
		k = j1 - s;
		if ( v[k] > b.maxValue(1)) j1 = k;
	}
	_box.reset(Point2D<unsigned char>((unsigned char)i0,(unsigned char)j0));
	_box.insert(Point2D<unsigned char>((unsigned char)(i1-1),(unsigned char)(j1-1)));
}


//*****************************************************
//***************** Triangle destructor ***************
//*****************************************************

template <class T>
Triangle<T>::~Triangle()
{
	if(_edge[0])
	{
		_edge[0]->removeTriangle(this);
		if(_edge[1]) _edge[1]->removeTriangle(this);
		if(_edge[2]) _edge[2]->removeTriangle(this);

		remove(this);
	}
}


//*****************************************************************
//*********** return the tree vertices in the triangle ************
//*****************************************************************

template <class T>
Array<Vertex<T>*> Triangle<T>::vertices() const
{
	Array<Vertex<T>*> r;
	r.setSize(3);

	r[1] = _edge[0]->commonVertex(*(_edge[1]));
	r[2] = _edge[1]->commonVertex(*(_edge[2]));
	r[0] = _edge[2]->commonVertex(*(_edge[0]));

	return r;
}

//*****************************************************************
//*********** return the normal of the triangle *******************
//*****************************************************************

template <class T>
UnitVector<T,3> Triangle<T>::normal() const
{
	Array<Vertex<T>*> v=vertices();
	return (Vector3D<T>(v[1]->position()-v[0]->position()))^
								(v[2]->position()-v[1]->position());
}


//********************************************************
//*************** find z-value inside triangle ***********
//********************************************************

template <class T>
T Triangle<T>::evalZ(const Point2D<T>& p, int deg) const
{
	Array<Vertex<T>*> ve=vertices();
	Point2D<T> par[3];
	Point<T,3> pos[3];
	int i,j,k;

	for(i=0; i<3; i++) par[i] = pos[i] = ve[i]->position();

	T a = p^par[0];
	T b = p^par[1];
	T c = p^par[2];
	T d = par[0]^par[1];
	T e = par[0]^par[2];
	T f = par[1]^par[2];
	T det = d-e+f;
	T u = (b-c+f)/det;
	T v = (-a+c-e)/det;
	T w = (a-b+d)/det;

	if (deg == 1)
		return u*pos[0](2) +v*pos[1](2) + w*pos[2](2);

	T pt[7];
	pt[6] = 0;

	for(i=0; i<3; i++)
	{
		if(i==2)	j = 0;
		else		j = i+1;
		k = 2*i;

		Vector3D<T>		vec = pos[j] - pos[i];
		vec[2] = 0;
		UnitVector3D<T> uv  = vec;
		T		   vec2 = 0.33333333333333333333*(vec*vec);

		Vector3D<T> vv	= ve[i]->normal()[2]*uv;
		vv[2]		   -= ve[i]->normal()*uv;
		pt[k]			= pos[i][2] + vec2/(vv*vec)*vv[2];

		vv				= ve[j]->normal()[2]*uv;
		vv[2]          -= ve[j]->normal()*uv;
		pt[k+1]			= pos[j][2] - vec2/(vv*vec)*vv[2];

		pt[6]		   += pt[k] + pt[k+1];
	}

	pt[6] /= 6;

	a = u*u;
	b = v*v;
	c = w*w;
	return a*u*pos[0](2) +   3*a*v*pt[0] + 3*u*b*pt[1] + b*v*pos[1](2) +
		  3*a*w*pt[5]    + 6*u*v*w*pt[6] + 3*b*w*pt[2] +
		  3*u*c*pt[4]    +   3*v*c*pt[3] + 
		   c*w*pos[2](2);
}


//*****************************************************************
//******** turn the edges such that the given edge is first *******
//*****************************************************************

template <class T>
bool Triangle<T>::turn(Edge<T>* a)
{
	int i,j;

	if(a == _edge[0])	return true;
	else if(a == _edge[1]) i = 1;
	else if(a == _edge[2]) i = 2;
	else			return false;

	j = (i==1? 2:1);

	Edge<T> *tmp = _edge[0];
	_edge[0] = _edge[i];
	_edge[i] = _edge[j];
	_edge[j] = tmp;

	return true;
}


//*****************************************************
//*************** splitt an triangle into 3 ***********
//*****************************************************

template <class T>
bool Triangle<T>::splitt(Vertex<T>& p)
{
	Edge<T>* edg1 = new Edge<T>(p,*(_edge[0]->commonVertex(*(_edge[1]))));
	Edge<T>* edg2 = new Edge<T>(p,*(_edge[1]->commonVertex(*(_edge[2]))));
	Edge<T>* edg3 = new Edge<T>(p,*(_edge[2]->commonVertex(*(_edge[0]))));

	Triangle<T>* t2 = new Triangle<T>(edg1,_edge[1],edg2);
	Triangle<T>* t3 = new Triangle<T>(edg2,_edge[2],edg3);

	edg1->setTriangle(this,t2);
	edg2->setTriangle(t2,t3);
	edg3->setTriangle(t3,this);

	_edge[1]->setTriangle(_edge[1]->other(this),t2);
	_edge[2]->setTriangle(_edge[2]->other(this),t3);

	insert(edg1);
	insert(edg2);
	insert(edg3);

	edg2 = _edge[1];
	_edge[1] = edg1;
	edg1 = _edge[2];
	_edge[2] = edg3;

	insert(t2);
	insert(t3);

	corrigate(this);

	_edge[0]->okDelaunay();
	edg1->okDelaunay();
	edg2->okDelaunay();

	return true;
}

//**************************************************************
//********** makes an edge const (if exists)             *******
//**************************************************************

/* NY KODE FOR �GJ�E EN EDGE CONST 12/9 -2001 (MARTIN)*/
template <class T>
bool TriangleFacets<T>::setConstEdge(Vertex<T> v1, Vertex<T> v2)
{
	int i;

	for (i=0; i < numEdges(); i++)
	{
		if ((*(edge(i)->_vertex[0]) == v1 && (*edge(i)->_vertex[1]) == v2) ||
			(*(edge(i)->_vertex[0]) == v2 && (*edge(i)->_vertex[1]) == v1))
		{
			edge(i)->setConst();
			return true;
		}
	}
	
	return false;
}


//*****************************************************
//***************** Edge destructor *******************
//*****************************************************

template <class T>
Edge<T>::~Edge()
{
	if(_triang[0] != NULL)		delete _triang[0];
	if(_triang[1] != NULL)		delete _triang[1];
	if(_vertex[0] != NULL)  _vertex[0]->removeEdge(this);
	if(_vertex[1] != NULL)  _vertex[1]->removeEdge(this);

	remove(this);
}


//*****************************************************
//*********** swap a vertex in the edge edge **********
//*****************************************************

template <class T>
bool Edge<T>::swapVertex(Vertex<T>& is_v,Vertex<T>& new_v)
{
	bool ret = false;

	if (_vertex[0] == &is_v) 
	{
		_vertex[0] = &new_v;
		ret = true;
	}
	if (_vertex[1] == &is_v) 
	{
		_vertex[1] = &new_v;
		ret = true;
	}

	if (_vertex[0]->getConst() && _vertex[1]->getConst()) _const = true; 

	return ret;
}


//*****************************************************
//*********** remove a triangle from the edge *********
//*****************************************************

template <class T>
bool Edge<T>::removeTriangle(Triangle<T>* t)
{
	if		(_triang[0]==t) _triang[0] = NULL;
	else if (_triang[1]==t) _triang[1] = NULL;
	else return false;
	return true;
}


//*****************************************************
//*************** return the other triangle ***********
//*****************************************************

template <class T>
Triangle<T>*  Edge<T>::other(Triangle<T>* t)
{
	if(t == _triang[0])		 return _triang[1];
	else if(t == _triang[1]) return _triang[0];
	else return NULL;
}


//*****************************************************
//********** return the next edge on boundary *********
//*****************************************************

template <class T>
Edge<T>*  Edge<T>::next()
{
	T_Array<Edge<T>*> edg = _vertex[1]->edges();
	edg.remove(this);

	if(boundary())
		for(int i=0; i<edg.size(); i++)
			if(edg[i]->boundary())
				if(_vertex[1] == commonVertex(*(edg[i])))
					return edg[i];

	return NULL;
}


//*****************************************************
//*************** return the other triangle ***********
//*****************************************************

template <class T>
bool  Edge<T>::swapTriangle(Triangle<T>* ot, Triangle<T>* nt)
{
	if(ot == _triang[0])		{_triang[0] = nt;	return true;}
	else if(ot == _triang[1])	{_triang[1] = nt;	return true;}
	else return false;
}


//*****************************************************
//************ make legal edge by delaunay ************
//*****************************************************

template <class T>
void  Edge<T>::okDelaunay()
{
	if (_vertex[0]->getConst() && _vertex[1]->getConst())
	{
		setConst();
	}

	if(_const || _triang[0] == NULL || _triang[1] == NULL)
		return;

	Array<Vertex<T>*> a = _triang[0]->vertices();

	a.insert(_triang[1]->vertices());

	a.remove(_vertex[0]);
	a.remove(_vertex[1]);

	Point2D<T> pt = a[0]->parameter();

	if(pt.isInsideCircle(_vertex[0]->parameter(),
							   a[1]->parameter(),
						 _vertex[1]->parameter()) == 1)	swap();
}


//************************************************
//*************** swap an edge if legal **********
//************************************************

template <class T>
bool Edge<T>::swap()
{

	if(_const || _triang[0] == NULL || _triang[1] == NULL) return false;

	_triang[0]->turn(this);
	_triang[1]->turn(this);

	Array<Edge<T>*> edg1 = _triang[0]->edges();
	Array<Edge<T>*> edg2 = _triang[1]->edges();

	_vertex[0]->removeEdge(this);
	_vertex[1]->removeEdge(this);

	_vertex[0] = edg1[1]->commonVertex(*(edg1[2]));
	_vertex[1] = edg2[1]->commonVertex(*(edg2[2]));

	_vertex[0]->insertEdge(this);
	_vertex[1]->insertEdge(this);

	_triang[0]->setEdges(this,edg1[2],edg2[1]);
	_triang[1]->setEdges(this,edg2[2],edg1[1]);

	edg1[1]->setTriangle(edg1[1]->other(_triang[0]),_triang[1]);
	edg2[1]->setTriangle(edg2[1]->other(_triang[1]),_triang[0]);

	corrigate(_triang[0],true);
	corrigate(_triang[1],true);

	edg1[1]->okDelaunay();
	edg1[2]->okDelaunay();
	edg2[1]->okDelaunay();
	edg2[2]->okDelaunay();

	return true;
}



//**************************************************************
//********** return a common vertex between two Edges  *********
//**************************************************************

template <class T>
Vertex<T>* Edge<T>::commonVertex(const Edge<T>& e) const
{
	if(_vertex[0] == e._vertex[0] || _vertex[0] == e._vertex[1])	  return _vertex[0];
	else if(_vertex[1] == e._vertex[0] || _vertex[1] == e._vertex[1]) return _vertex[1];

	return NULL;
}



//**************************************************************
//********** return the other vertex in the Edges  *************
//**************************************************************

template <class T>
Vertex<T>* Edge<T>::otherVertex(const Vertex<T>& e) const
{
	if((*_vertex[0]) == e)			return _vertex[1];
	else if((*_vertex[1]) == e)		return _vertex[0];
	else							return NULL;
}



//**************************************************************
//********** return the other vertex in the Edges  *************
//**************************************************************

template <class T>
bool Edge<T>::hasPoints(const Point<T,3>& p1, const Point<T,3>& p2) const
{
	Vertex<T> * v1 = find(p1);
	T_Array<Edge<T>*> edges = v1->edges();
	for (int i = 0; i < edges.size(); i++)
		if (edges[i]->otherVertex(v1)->pos() == p2)
			return true;
	return false;
/*
	Vertex<T> * v2 = find(p2);
	if(_vertex[0] == v1 && _vertex[1] == v2)		return true;
	else if(_vertex[1] == v1 && _vertex[0] == v2)	return true;
	else											return false;
*/
}

//**************************************************************
//********** return the triangles the edge is a part of  *******
//**************************************************************

template <class T>
Array<Triangle<T>*>  Edge<T>::getTriangle()
{
	Array<Triangle<T>*> arr;
	if(_triang[0] != NULL) arr.insert(_triang[0]);
	if(_triang[1] != NULL) arr.insert(_triang[1]);
	return arr;
}


//**************************************************************
//*********** split an edge and the belonging triangles ********
//**************************************************************

/****
	NY KODE FOR �KUNNE SPLITTE YTTRE KANTER 1/9 -2001 (MARTIN)
 ****/

template <class T>
bool Edge<T>::splitt(Vertex<T>& p)
{
	Vertex<T>* v = NULL;
	Edge<T>*   e = NULL;
	Triangle<T> *t1 = NULL, *t2 = NULL;

	if (_triang[0] != NULL)
		_triang[0]->turn(this);
	if (_triang[1] != NULL)
		_triang[1]->turn(this);

	Array<Edge<T>*> edg1 = _triang[0] == NULL ? NULL : _triang[0]->edges();
	Array<Edge<T>*> edg2 = _triang[1] == NULL ? NULL : _triang[1]->edges();

	if (_triang[0] != NULL)
	{
		if(_vertex[0] == commonVertex(*(edg1[1])))	// swap triangles, 
		{											// _triang[0] should be on left
			Triangle<T>* st = _triang[0];
			_triang[0] = _triang[1];
			_triang[1] = st;
			edg1 = _triang[0] == NULL ? NULL : _triang[0]->edges();
			edg2 = _triang[1] == NULL ? NULL : _triang[1]->edges();
		}
	}
	else
	{
		if(_vertex[0] != commonVertex(*(edg2[1])))	// swap triangles, 
		{											// _triang[0] should be on left
			Triangle<T>* st = _triang[0];
			_triang[0] = _triang[1];
			_triang[1] = st;
			edg1 = _triang[0] == NULL ? NULL : _triang[0]->edges();
			edg2 = _triang[1] == NULL ? NULL : _triang[1]->edges();
		}
  }


	// Splitt edge in two
	Edge<T>* e1 = this;
	Edge<T>* e2 = new Edge<T>(*(_vertex[1]),p);		
	_vertex[1]->removeEdge(this);
	_vertex[1] = &p; 	
	p.insertEdge(this);
	e2->setConst(_const);
	insert(e2);

	// Splitt triangle 0
	if (_triang[0] != NULL)
	{
		v = edg1[1]->commonVertex(*(edg1[2]));
		e = new Edge<T>(p,*v);

		t1 = new Triangle<T>(e2,edg1[1],e);
		_triang[0]->setEdges(e1,e,edg1[2]);
		e->setTriangle(t1,_triang[0]);
		edg1[1]->swapTriangle(_triang[0], t1);

		insert(e);
		insert(t1);

		corrigate(_triang[0]);
	}

	// Splitt triangle 1
	if (_triang[1] != NULL)
	{
		v = edg2[1]->commonVertex(*(edg2[2]));
		e = new Edge<T>(p,*v);

		t2 = new Triangle<T>(e2,e,edg2[2]);
		_triang[1]->setEdges(e1,edg2[1],e);
		e->setTriangle(t2,_triang[1]);

		e2->setTriangle(t1,t2);
		edg2[2]->swapTriangle(_triang[1], t2);

		insert(e);
		insert(t2);

		corrigate(_triang[1]);
	}

	if (_triang[0] != NULL)
	{
		edg1[1]->okDelaunay();
		edg1[2]->okDelaunay();
	}

	if (_triang[1] != NULL)
	{
		edg2[1]->okDelaunay();
		edg2[2]->okDelaunay();
	}

	return true;
}


//*****************************************************
//***************** Vertex destructor *****************
//*****************************************************

template <class T>
Vertex<T>::~Vertex()
{
	edg.clear();
}
   
   
   
//************************************************
//*************** is inside a triangle  **********
//************************************************

template <class T>
int Vertex<T>::isInside(Triangle<T>* t) const
{
	Array<Vertex<T>*> v = t->vertices();
	Array<Point<T,2> > a;

	for (int i=0; i<3; i++)
		a += v[i]->parameter();

	Point2D<T> p = pos();

	return p.isInside(a);
}


//************************************************
//*************** delete all edges      **********
//************************************************

template <class T>
void Vertex<T>::deleteEdges()
{
	while(edg.size() > 0)
		delete edg[0];
	edg.clear();
}



//************************************************
//******* All outer_edges to this vertex  ********
//************************************************

template <class T>
Array<Edge<T>*> Vertex<T>::outerEdges() const
{
	Array<Triangle<T>*> tris  = triangles();
	Array<Edge<T>*>		s_edg = edges();
	Array<Edge<T>*>		o_edg(s_edg.size());

	for(i=0; i<tris.size(); i++)
	{
		Array<Edge<T>*>	ee = tris[i]->edges();
		for(j=0; j<ee.size(); j++)
				if(!s_edg.exist(ee[j]))  o_edg += ee[j];
	}

	return o_edg;
}


//************************************************
//***** All triangles sharing this vertex ********
//************************************************

template <class T>
Array<Triangle<T>*> Vertex<T>::triangles() const
{
	Array<Triangle<T>*> tris;
	for(int i=0; i<edg.size();i++)
		tris.insert(edg(i)->getTriangle());
	return tris;
}


//************************************************
//***** compute the normal by all triangles ******
//************************************************

template <class T>
void Vertex<T>::setNormal()
{
	Array<Triangle<T>*> tris = triangles();
	Point<T,3> nor;
	for(int i=0;i<tris.size();i++)
		nor += tris[i]->normal();
	nor /= tris.size();
	setDir(nor);
}



//************************************************
//************        operator=         **********
//************************************************

/* NY KODE  20/9 -2001 (MARTIN)*/
template <class T>							
Vertex<T>& Vertex<T>::operator=(const Vertex<T>& t)
{
	edg		= t.edg;
	_const	= t._const;
	setValues(t.position(),	t.normal());

	return (*this);
}


//************************************************
//*************** interpolate      **********
//************************************************

template <class T>							
Vertex<T> PWVLine<T>::interpolate(int i, double t) const
{
	if(i<0 || i>size()-2)
	{
		// Errormessage for debug purpose
	}
	Point<T,3> pos = (1-t)*((*this)(i).position())+t*((*this)(i+1).position());
	Point<T,3> nor = (1-t)*((*this)(i).normal())+t*((*this)(i+1).normal());

	return Vertex<T>(pos,nor);
}


//*******************************************
//*************** set z-verdi      **********
//*******************************************

/* NY KODE FOR �ENDRE Z-VERDI 1/9 -2001 (MARTIN)*/
template <class T>							
void Vertex<T>::setZ(T z)
{
	setPos(Point3D<T>(pos()[0], pos()[1], z));
}


}// end namespace GM_lib
