#pragma once

#include <GM_PCurve.h>
#include <GM_Point.h>

template < class T, int n >
class MyLine : public GM_lib::PCurve< T, n >
{
	public:
		
		MyLine( GM_lib::Point< T, n > _start, GM_lib::Point< T, n > _end ) : start( _start ), end( _end )
		{		
//			__line_width = 1.5;
			resetPlot(51,true);
			_data.setSize(1); // empty, for display test
		}

//		MyLine( input data array here) : start( _start ), end( _end )
//		{		
//			__line_width = 1.5;
//			resetPlot(51,true);
//			_data.setSize(1); // empty, for display test
//		}


		

		virtual ~MyLine(void)
		{
		}

		MyLine( const MyLine< T, n >& right ) : start( right.start ), end( right.end )
		{
		}
		
		MyLine< T, n >& operator=( const MyLine< T, n >& right )
		{
			if( this != &right )
			{
				start = right.start;
				end = right.end;
			}

			return *this;
		}	


		virtual void _eval( T t, int d )
		{
			__p.setDim( d + 1 );
			__p[ 0 ] = start * t + end * ( 1 - t );
			for( int i = 1; i <= d; i++ )
			{
				__p[ i ] = start * t + end * ( 1 - t );
			}
		}

		virtual T _st_p()
		{ 
			return 0;
		}

		virtual T _end_p()
		{ 
			return 1;
		}


	private:

//		GL_Color st, en;
		GM_lib::Point< T, n > start;
		GM_lib::Point< T, n > end;
		GM_lib::Array<GM_lib::Point<T,n> >  _data;
		
		void localDisplay()
		{
			if(_data.size()>3)
			{
			 glBegin(GL_LINE_STRIP);
             for(int i=0; i<_data.size(); i++) glVertex(_data[i]);
//			 st.interpolateHSV(x,en);
//			 st.glSet();
			 glEnd();
			}
			PCurve<T,n>::localDisplay();
		}
};
