//#pragma once
#ifndef BEYLKINFILTER_H
#define BEYLKINFILTER_H

#include <OrthoFilters.h>
#include <assert.h> 

#include <iostream>
using namespace std;

#include <GM_Array.h>
#include <GM_DVector.h>
#include <GM_DMatrix.h>
using namespace GM_lib;

namespace Wave_lib {

	template<class T>
	class BeylkinFilter : public OrthoFilters<T> {
			
			void _init();					
			void calcFilterCoefs(double dim, FilterCoefs<T> &dbn);		
		
	public:
			BeylkinFilter();
			~BeylkinFilter();
	};



	// ************************************************************************
	// **************************   Constructors   ****************************
	// ************************************************************************
	
	template<class T>
	inline BeylkinFilter<T>::BeylkinFilter() : OrthoFilters<T>() 
	{
		_init();
	}


	// ************************************************************************
	// **************************    Destructors    ***************************
	// ************************************************************************

	template<class T>
	BeylkinFilter<T>::~BeylkinFilter() 
	{}

	// ************************************************************************
	// **************************   private func   ****************************
	// ************************************************************************

	template<class T>
	void BeylkinFilter<T>::_init() 
	{

		FilterCoefs<T>	temp;
		DVector<T>		Coefs;

		temp.values.setSize(1);
		temp.dim = 1;
		Coefs.setDim(18);
		Coefs[0] = T(0.099306);
		Coefs[1] = T(0.42422);
		Coefs[2] = T(0.69983);
		Coefs[3] = T(0.44972);
		Coefs[4] = T(-0.11093);
		Coefs[5] = T(-0.2645);
		Coefs[6] = T(0.0269);
		Coefs[7] = T(0.15554);
		Coefs[8] = T(-0.017521);
		Coefs[9] = T(-0.088544);
		Coefs[10] = T(0.01968);
		Coefs[11] = T(0.042916);
		Coefs[12] = T(-0.01746);
		Coefs[13] = T(-0.014366);
		Coefs[14] = T(0.01004);
		Coefs[15] = T(0.0014842);
		Coefs[16] = T(-0.002736);
		Coefs[17] = T(0.00064049);
		temp.values[0] = Coefs;
		_filter.alwaysInsert(temp);
	}

	template<class T>
	void BeylkinFilter<T>::calcFilterCoefs(double _dim, FilterCoefs<T> &f) {}

}//end namespace Wave_lib

#endif 