#include <iostream>
using namespace std;

#include "graphcurve.h"

GraphCurve::GraphCurve(char *name,int width,int height)
{
	init();
	curve_name = new char[strlen(name)+1];
	strcpy(curve_name,name);
	this->height = height;
	this->width = width;
}

GraphCurve::~GraphCurve(void)
{
}
void GraphCurve::setColor(float r,float g,float b)
{
	rgb[0] = r;
	rgb[1] = g;
	rgb[2] = b;
}

void GraphCurve::setData(DVector<double> data)
{
	this->curve_data = data;
	min = max = data[0];
	for (int i=0;i<data.dim();i++)
	{
		if (data[i] > max) 
			max = data[i];
		if (data[i] < min) 
			min = data[i];
	}
	
	dx = (float)width / (float)curve_data.dim();
	dy = (float)height / (float)(max-min);
	setScale(dx,dy);



}
void GraphCurve::setSibling(GraphCurve *sibling)
{
	this->sibling = sibling;
}

void GraphCurve::setData(int i,double data)
{
	curve_data[i] = data;

	if (data > max) 
		max = data;
	if (data < min) 
		min = data;
	dx = (float)width / (float)curve_data.dim();
	dy = (float)height / (float)(max-min);

	setScale(dx,dy);

}


void GraphCurve::init()
{
	curve_name = "No name";
	rgb[0] = 1;
	rgb[1] = 0;
	rgb[2] = 0;
	dx= dy = 1.0;
	dy = 10.0;
	sibling = 0;
}

void GraphCurve::setScale(float dx,float dy)
{
	this->dx = dx;
	this->dy = dy;
	if (sibling)
		sibling->setScale(dx,dy);
}

void GraphCurve::display()
{
	glColor3fv(&rgb[0]);
	glBegin(GL_LINE_STRIP);
	for(int i=0;i<curve_data.dim();i++)
	{
		glVertex2f(i*dx,(curve_data[i]*dy));
	}
	glEnd();
}