
//#pragma once
#ifndef MEYERFILTER_H
#define MEYERFILTER_H

#include <OrthoFilters.h>
#include <assert.h> 

#include <iostream>
using namespace std;

#include <GM_Array.h>
#include <GM_DVector.h>
#include <GM_DMatrix.h>
using namespace GM_lib;

namespace Wave_lib {

	template<class T>
	class MeyerFilter : public OrthoFilters<T> {
			
			void _init();					
			void calcFilterCoefs(double dim, FilterCoefs<T> &dbn);		
		
	public:
			MeyerFilter();
			~MeyerFilter();
	};



	// ************************************************************************
	// **************************   Constructors   ****************************
	// ************************************************************************
	
	template<class T>
	inline MeyerFilter<T>::MeyerFilter() : OrthoFilters<T>() 
	{
		_init();
	}


	// ************************************************************************
	// **************************    Destructors    ***************************
	// ************************************************************************

	template<class T>
	MeyerFilter<T>::~MeyerFilter() 
	{}

	// ************************************************************************
	// **************************   private func   ****************************
	// ************************************************************************

	template<class T>
	void MeyerFilter<T>::_init() 
	{

		FilterCoefs<T>	temp;
		DVector<T>		Coefs;

		temp.values.setSize(1);
		temp.dim = 1;
		Coefs.setDim(32);
		Coefs[0] = T(-0.00060115023435);
		Coefs[1] = T(-0.00270467212464);
		Coefs[2] = T(0.00220253410091);
		Coefs[3] = T(0.00604581409732);
		Coefs[4] = T(-0.00638771831850);
		Coefs[5] = T(-0.01106149639251);
		Coefs[6] = T(0.01527001513093);
		Coefs[7] = T(0.01742343410373);
		Coefs[8] = T(-0.03213079399021);
		Coefs[9] = T(-0.02434874590608);
		Coefs[10] = T(0.06373902432280);
		Coefs[11] = T(0.03065509196082);
		Coefs[12] = T(-0.13284520043623);
		Coefs[13] = T(-0.03508755565626);
		Coefs[14] = T(0.44459300275758);
		Coefs[15] = T(0.74458559231881);
		Coefs[16] = T(0.44459300275758);
		Coefs[17] = T(-0.03508755565626);
		Coefs[18] = T(-0.13284520043623);
		Coefs[19] = T(0.03065509196082);
		Coefs[20] = T(0.06373902432280);
		Coefs[21] = T(-0.02434874590608);
		Coefs[22] = T(-0.03213079399021);
		Coefs[23] = T(0.01742343410373);
		Coefs[24] = T(0.01527001513093);
		Coefs[25] = T(-0.01106149639251);
		Coefs[26] = T(-0.00638771831850);
		Coefs[27] = T(0.00604581409732);
		Coefs[28] = T(0.00220253410091);
		Coefs[29] = T(-0.00270467212464);
		Coefs[30] = T(-0.00060115023435);
		Coefs[31] = T(0.00006554305931);
		temp.values[0] = Coefs;
		_filter.alwaysInsert(temp);
	}

	template<class T>
	void MeyerFilter<T>::calcFilterCoefs(double _dim, FilterCoefs<T> &f) {}

}//end namespace Wave_lib

#endif 