// *********************************************************************************************
//
//
//
//
//
// *********************************************************************************************

#ifndef __OrthoFilters__
#define __OrthoFilters__

#include <Filter.h>

namespace Wave_lib {

	template<class T>
	class OrthoFilters : public Filters<T> {

			virtual void calcFilterCoefs(double dim, FilterCoefs<T> &dbn) = 0;	// must be overloaded by f.eks.	DaubN, CoifN, ....
			void calcFilters(FilterCoefs<T> &f, int p=0);						// calculates Orthogonal HighPass and LowPass filters
		public:
			OrthoFilters() : Filters<T>() {}

	};



	// ************************************************************************
	// **************************   Constructors   ****************************
	// ************************************************************************


	// ************************************************************************
	// **************************    Destructors    ***************************
	// ************************************************************************


	// ************************************************************************
	// **************************   private func   ****************************
	// ************************************************************************

	

	template<class T>
	void OrthoFilters<T>::calcFilters(FilterCoefs<T> &f, int p) {

		// if filters is calculated before skip
		if (!f.Lo_D.size()) {
			// makeing room for decomposition filters
			f.Lo_D.setSize(1);	f.Hi_D.setSize(1);
			// makeing room for reconstruction filters
			f.Lo_R.setSize(1);  f.Hi_R.setSize(1);

			// Normalize filter sum.
			f.Lo_R[0] = f.values[0]*((T(1)/ f.values[0].sum())*(T)sqrt(T(2)));
			_qmt(f.Lo_R[0], f.Hi_R[0], p);

// No function reverse
// Is it right????
			f.Hi_D[0] = f.Hi_R[0].getReversed();
			f.Lo_D[0] = f.Lo_R[0].getReversed();

// Old code
//			f.Hi_D[0] = f.Hi_R[0].reverse();
//			f.Lo_D[0] = f.Lo_R[0].reverse();
		}

	}

	
} // namespace Wave_lib 


#endif // __OrthoFilters__