#pragma once

/********************************************************************************
Endringer gjort av Joakim Gundersen:
10.02.04:	Lagt til funksjonen getErrorCurve(), returnerer input-output
*********************************************************************************/

#include <ColorPoint.h>

#include "DisplayObject.h"
#include <GM_Array.h>
#include <GM_DVector.h>
using namespace GM_lib;

#include <ColorGradient.h>
#include <GraphCurve.h>
#include <WaveDWT.h>
using namespace Wave_lib;

class Scalagram : public DisplayObject
{
public:
	Scalagram(int width,int height,WaveDWT<double> *wavelet);
	~Scalagram(void);
	void generateData(DVector<double> &coefs,DVector<int> &longs);
	void addMax(float d);
	void addMin(float d);
	void changeColor(ColorPoint *point,float dv);
	DVector<double> getCoifisients();
	DVector<int> &getLongs();
	GraphCurve *getOutCurve();
	GraphCurve *getErrorCurve();
	GraphCurve *getScalingFunction();
	//void setWavelet(WaveDWT<double> *wavelet);

protected:
	void localDisplay();
	void localSelect();
	void localSimulate(double dt);

	void init();
	WaveDWT<double> *wavelet;


	void drawBorders();
	void drawPoints();
	Array<ColorPoint *> points;
	GLuint listID1;
	GLuint colortableid;
	int xpos,ypos;
	int windowwidth;
	int windowheight;
	double scaling;

	DVector<double> coefs;
	DVector<int> longs;
	ColorGradient *colorgradient;
	GraphCurve *scalingfuntion;
	DVector<double> _outdata;
	GraphCurve *outcurve;
	DVector<double> _errordata;
	GraphCurve *errorcurve;

private:
	int height;
	int width;
};
