/***************************************************************************
OBS!!! WaveDWT.c includeres p slutten av denne fila -> exclude build 
properties for WaveDWT.c m derfor settes til yes!!
***************************************************************************/
#pragma once
#include <assert.h> //For feil rapportering....

#include <GM_DVector.h>
#include <GM_DMatrix.h>
#include <Definitions.h>
#include <Filter.h>

using namespace GM_lib;

namespace Wave_lib
{
	template<class T>
	class WaveDWT {
		public:
			WaveDWT(Filters<T> *filter,double dim,DWT_MODES mode = ZPD);
			 
			virtual DVector<T> reconstruction(DVector<T> &_coefs,DVector<int> &_longs);
			virtual void decomposition(DVector<T> x, const int n,DVector<T> &c, DVector<int> &l);
			~WaveDWT();
			virtual void setFilterIndex(double filterindex);

			DVector<T> getInData() {return _indata;}
		private:

			DVector<T> _indata;
			//Used for wave_decomposition
			void dwt(DVector<T> x,DVector<T> &a, DVector<T> &d);
			//DVector<T> wextend(DVector<T> x,int l, int mode=MODE_ZPD, int loc=LOC_BOTH_SIDES);
//			DVector<T> wextend(DVector<T> x,int l, DWT_MODES mode  = ZPD, int loc = LOC_BOTH_SIDES);
			DVector<T> wextend(DVector<T> x,int l, DWT_MODES mode  = ZPD, LOC loc = LOC_BOTH_SIDES);
			DVector<T> dyaddown(DVector<T> x, int EvenOdd = 0);
			DVector<T> convdown(DVector<T> x, DVector<T> f, int lenKEPT, int shift);


			//Used for wave_reconstructon
			DVector<T> appcoef(int s=0);
			DVector<T> *detcoef(DVector<int> levels);
			DVector<T> idwt(DVector<T>a,DVector<T>d,int l=0);
			DVector<T> dyadic_upsampling(DVector<T> x,int odd=EVEN);
			DVector<int> cumulative_sum(DVector<int>x);
			DVector<T> convolution(DVector<T> x,DVector<T> F);
			//void convolution(DVector<T> x,DVector<T> F,DVector<T> &ret);	
			DVector<T> wkeep(DVector<T> x,int length,int type=CENTER,int test=0);
			DVector<T> upsaconv(DVector<T> x,DVector<T> f,int s);

			void init();
		protected:
			
			Filters<T> *_filter;
			DVector<T> data;
			DVector<T> lo_r;
			DVector<T> hi_r;
			DVector<T> lo_d;
			DVector<T> hi_d;
			DWT_MODES mode;
			DVector<int> shift;


			DVector<T> coefs;
			DVector<int> longs;
			DVector<T> signal;
			double filterindex;
	};
} //namespace Wave_lib
#include "WaveDWT.c"