/***************************************************************************
OBS!!! WaveDWT2D.c includeres p slutten av denne fila -> exclude build 
properties for WaveDWT2D.c m derfor settes til yes!!
***************************************************************************/
#pragma once

#include <assert.h> //For feil rapportering....

#include <GM_DVector.h>
#include <GM_DMatrix.h>
#include <Definitions.h>
#include <CoifFilter.h>
#include <Filter.h>

using namespace GM_lib;


namespace Wave_lib
{

	template<class T>
	class WaveDWT2D
	{
		public:
			
			WaveDWT2D(Filters<T> *filter,DWT_MODES mode = ZPD);

			DMatrix<T> reconstructon(DVector<T> &_coefs,DMatrix<int> &_longs);
			void decomposition(DMatrix<T> mat, const int n,DVector<T> &c, DMatrix<int> &s);

			~WaveDWT2D(void);
		protected:
			Filters<T> *_filter;
			
			DVector<T> lo_r;
			DVector<T> hi_r;
			
			DVector<T> lo_d;
			DVector<T> hi_d;
			
			DWT_MODES mode;

			DVector<int> shift;

			DVector<T> coefs;
			DMatrix<int> longs;
			
			int filterindex;
		private:
			void setFilterIndex(int filterindex);
			void dwt(DMatrix<T> mat, DMatrix<T> &ca, DMatrix<T> &ch, DMatrix<T> &cv, DMatrix<T> &cd);
			DMatrix<T> wextend(DMatrix<T> m,int l,int loc=LOC_BOTH_SIDES,int mode=ZPD);
			DMatrix<T> convdown(DMatrix<T> mat, DVector<T> f, DVector<int> sizeKEPT, int shift1, int shift2);
			DMatrix<T> dyaddown(DMatrix<T> mat, int Type, int EvenOdd = 0);

			////////////////////////////////////////////////////////////////////////////
			DMatrix<T> appcoef(DVector<T> c,DMatrix<int> l,int s=0);
			DMatrix<T> idwt(DMatrix<T>a,DMatrix<T>h,DMatrix<T>v,DMatrix<T>d,DVector<int> s);
			void detcoef(DETCOEF mode,DVector<T> coefs,DMatrix<int> longs,int levels,DMatrix<T> &c1,DMatrix<T> &c2,DMatrix<T> &c3);
			DMatrix<T> upsaconv(DMatrix<T>a,DVector<T>f1,DVector<T>f2,DVector<int>s);
			DMatrix<T> dyadic_upsampling(DMatrix<T> x,int type,int odd=0);
			
			DMatrix<T> convolution2(DMatrix<T> x, DVector<T> F,int type=ROW);
			
			DMatrix<T> wkeep(DMatrix<T> m,int length_column,int length_row,int type=CENTER);
	};

} //namespace Wave_lib
#include "WaveDWT2D.c"