/***************************************************************************
OBS!!! WaveDWT.c includeres p slutten av denne fila -> exclude build 
properties for WaveDWT.c m derfor settes til yes!!
***************************************************************************/
#pragma once
#include <assert.h> //For feil rapportering....

#include "GM_DVector.h"
#include <GM_DArrayN.h>
#include <Definitions.h>
#include <Filter.h>

using namespace GM_lib;

namespace Wave_lib
{

	template<class T, int n>
	class WaveDWTnD {

		public:
			WaveDWTnD(Filters<T> *filter,double fdegree,DWT_MODES mode = ZPD);
			~WaveDWTnD();

			virtual void decomposition(DArrayN<T,n> mat, const int level,Array<DArrayN<T,n>* > &c, Array<DVector<int>* > &l);
			virtual DArrayN<T,n> reconstruction(Array<DArrayN<T,n>*> c, Array<DVector<int>* > l);

			DArrayN<T,1>	cascade1d(int type, int iter);
			DArrayN<T,2>	cascade2d(int type, int iter);
		
			

			//Verkty funksjoner
			void					printDArray(DArrayN<T,n> arr, QString fname);
			void					printDArray(DArrayN<Point3D<T>,n> arr, QString fname);
			void					printArrayDArray(Array<DArrayN<T,n>* > arrarr, QString fname);
			void					printArrVector(Array<DVector<int>*> arrvec, QString fname);
        
		protected:
			Filters<T> *_filter;
			
			DVector<T> lo_r;
			DVector<T> hi_r;
			
			DVector<T> lo_d;
			DVector<T> hi_d;
			
			DWT_MODES mode;

			DVector<int> shift;

			DVector<T> coefs;
			DMatrix<int> longs;
			
			double fdegree;

			DArrayN<T,n> A;

		private:
			void			getFilterCoefs(double fd);
			void			dwt(DArrayN<T,n>* mat, Array<DArrayN<T,n>*> &c);
			DArrayN<T,n>	idwt(Array<DArrayN<T,n>*> c, DVector<int> sizeKEEP);
			DArrayN<T,n>	convdown(DArrayN<T,n>* mat, Array<DVector<T>*> F, DVector<int> shift, DVector<int> sizeKEEP);
			DArrayN<T,1>	upsaconv1d(DArrayN<T,1>* mat, Array<DVector<T>*> F,DVector<int> sizeKEEP);
			DArrayN<T,n>	upsaconv(DArrayN<T,n>* mat, Array<DVector<T>*> F,DVector<int> sizeKEEP);
			DArrayN<T,n>	wextend(DArrayN<T,n> m,DVector<int> lenEXT,int loc=LOC_BOTH_SIDES,int mode=ZPD);
			DArrayN<T,1>	wkeep1d(DArrayN<T,1> m, DVector<int> length, int type=CENTER);
			DArrayN<T,n>	wkeep(DArrayN<T,n> m, DVector<int> length, int type=CENTER);

			
			DArrayN<T,1>	upCoef(DArrayN<T,1>* arr, Array<DVector<T>*>F, int iter);
			void			testinit();

	
			
			

	};
} //namespace Wave_lib
#include "WaveDWTnD.c"