
#include <assert.h> 

#include <GM_DVector.h>
#include <GM_DMatrix.h>
#include <GM_DArrayN.h>
#include <wave_lib/Definitions.h>
#include <wave_lib/Filter.h>

using namespace GM_lib;

namespace Wave_lib
{

	template<class T, int n>
	class WaveFLWTnD {

		public:
			WaveFLWTnD(Filters<T> *filter,double fdegree);
			~WaveFLWTnD();

			virtual void decomposition(DArrayN<T,n> mat, const int level,Array<DArrayN<T,n>* > &c, Array<DVector<int>* > &l);
			virtual DArrayN<T,n> reconstruction(Array<DArrayN<T,n>*> c, Array<DVector<int>* > l);
        
		protected:
			Filters<T> *_filter;
			
			DVector<T> lo_r;
			DVector<T> hi_r;
			
			DVector<T> lo_d;
			DVector<T> hi_d;

			double fdegree;
			DArrayN<T,n> A;

		private:
			void			getFilterCoefs(double fd);
			void			flwt(DArrayN<T,n>* mat, Array<DArrayN<T,n>*> &c);
			DArrayN<T,n>	iflwt(Array<DArrayN<T,n>*> c, DVector<int> sizeKEEP);		

	};
} //namespace Wave_lib