#pragma once
#include <GM_Sphere.h>
#include <GM_Material.h>

template <class T, int n>
class earth : public PSphere<T,n>
{
protected:
	// start and end parameters must fit the spherical angles for the texture 
	T _st_p_u()				{ return T(-M_PI_2); }
	T _end_p_u()			{ return T(2*M_PI-M_PI_2); }
	T _st_p_v()				{ return T(-M_PI_2); }
	T _end_p_v()			{ return T(M_PI_2); }

	void localSimulate(double dt)
	 {
	   rotateGlobal(dt,Vector3D<T>(0.0,0.0,1.0));
	 }

public:

	earth(T radius=637.8140):PSphere<T,n>(radius)
	{
	  Texture  myMap;
	  int txn=myMap.LoadGLSphereMap("earthmap1k.jpg");
	  Material myMat;
	  GL_Color sc(88,88,200);
	  myMat.set(sc,sc,sc,20,txn);
	  setMaterial(myMat);
	  
	  // scale, not quite sure that this is in the correct direction, it could hardly be visible
	 // Point3D<T> flattening(1.0,1.0,1.0-1.0/293.0); // at least approximate to wgs-84 coord-system
	 // scale(flattening);
	  translate(Vector3D<T>(-radius,-radius,0));
	  resetPlot(32,32,false);
	}

	virtual ~earth(void)
	{
	}
};
