
/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
//4100;4189;4244;4305

#include <vector>
#include <fstream>

#include <qfiledialog.h>
#include <qlistview.h>

#include <qinputdialog.h>
#include <GM_DisplayObject.h>
#include <GM_CameraIso.h>
#include <GM_Texture.h>
#include <GM_Material.h>
#include <GM_ExpoRationalCurve.h>
#include <GM_Sphere.h>
#include <GM_PointLight_G.h>
#include <GM_SpotLight_G.h>

#include <GM_Text3D.h>
#include "materialselect.h"
#include "materialcurvature.h"
#include "curvature.h"

#include <Quadrature.h>

#include <earth.h>

#include "modeltree.h"
#include "gl2ps.h"
#include "getPoint.h"

#include <GM_3DsObject.h>
#include <GM_BSplineCurve.h>
#include <GM_BSplineSurf.h>
#include <GM_Point.h>

#include <Line.h>
#include "Random.h"

#include <GM_DVectorN.h>
#include <WaveDWTnD.h>
#include <Filter.h>
#include <DaubFilter.h>

#include <limits>

LA_DisplayObject* activ;

ModelTree* mdlt;
int myCounter;


///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
// My Variables
///////////////////////////////////////////////////////////////////////////////////////////////////

static const int number_of_windows = 4;
int active_window;
bool is_fullscreen;

Random random;

int last_dimension;


Camera* camera[ number_of_windows ];
GM_QtWindow* window[ number_of_windows ];

MyLine< double, 3 >* ox[ number_of_windows ];
MyLine< double, 3 >* oy[ number_of_windows ];
MyLine< double, 3 >* oz[ number_of_windows ];

		Material material = Snow;
		Texture texture;

int bspline_degree;

int j_1_1d;
int levels_1d;	
int long_levels_1d;	

int data_size_1d;
int long_data_size_1d;
DArrayN< long double, 1 > data_1d;
DArrayN< long double, 1 > psi_jk_1d;
DArrayN< long double, 1 > long_data_1d;
DArrayN< long double, 1 > noisy_data_1d;
DArrayN< long double, 1 > reconstructed_data_1d;

Array< float > knots_1d[ number_of_windows ];
Array< Point< float, 3 > > points_1d[ number_of_windows ];

BSplineCurve< float,3 >* mycurve[ number_of_windows ];


int j_1_2d;
int levels_2d;	
int long_levels_2d;	

int data_size_2d;
int long_data_size_2d;
DArrayN< long double, 2 > data_2d;
DArrayN< long double, 2 > psi_jk_2d;
DArrayN< long double, 2 > long_data_2d;
DArrayN< long double, 2 > noisy_data_2d;
DArrayN< long double, 2 > reconstructed_data_2d;

DVector< float > knots_2d_u[ number_of_windows ];
DVector< float > knots_2d_v[ number_of_windows ];
DMatrix< Point< float, 3 > > points_2d[ number_of_windows ];

BSplineSurf< float, 3 >* mysurf[ number_of_windows ];

QImage image[ number_of_windows ];


long double p;
long double q;
long double s;
long double etha;
long double sigma;
long double lambda;
std::vector< long double > v;

std::vector< LA_DisplayObject** > display_objects[ number_of_windows ];

Wave_lib::Filters< long double >* filter;


int zero_count;
int experiment_size;

long double min_t_1d;
long double max_t_1d;
std::vector< long double > file_data_1d;

long double min_u_2d;
long double max_u_2d;
long double min_v_2d;
long double max_v_2d;
std::vector< std::vector< long double > > file_data_2d;

long double LambdaTear( long double t );
long double Random1D( long double t );
long double FileData1D( long double t );
long double LambdaTearXLambdaTear( long double u, long double v );
long double Random2D( long double u, long double v );
long double FileData2D( long double u, long double v );

enum ExperimentType{ Experiment_V, Experiment_V_j, Experiment_Norm, Experiment_Norm_j } experiment_type;

///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////


void mainWindow::init()
{
//	random = Random( 0.25 / 3.0 );
	random = Random( 0.01 / 3.0 );

	last_dimension = 0;

	window[ 0 ] = gM_QtWindow5;
	window[ 1 ] = gM_QtWindow6;
	window[ 2 ] = gM_QtWindow7;
	window[ 3 ] = gM_QtWindow8;

	active_window = 0;
	is_fullscreen = false;

	for( int i = 0; i < number_of_windows; ++i )
	{
//		camera[ i ] = window[ i ] -> getDefaultCamera();

		Point3D< float > pos( 20, 20, 20 );
		Vector3D< float > dir( 0, 0, 0 );
		Vector3D< float > up( 0, 1, 0 );
		camera[ i ] = new Camera( pos, dir - pos, up );
		camera[ i ] -> setCutPlane( 0.1, 5000.0 );
		camera[ i ] -> setVisible( false );
		camera[ i ] -> coordSys( false );
		camera[ i ] -> zoom( 1 );
		window[ i ] -> insertCamera( camera[ i ], false );
		window[ i ] -> insertSun();

		ox[ i ] = NULL;
		oy[ i ] = NULL;
		mycurve[ i ] = NULL;
		mysurf[ i ] = NULL;

		display_objects[ i ].push_back( (LA_DisplayObject**) &ox[ i ] );
		display_objects[ i ].push_back( (LA_DisplayObject**) &oy[ i ] );
		display_objects[ i ].push_back( (LA_DisplayObject**) &oz[ i ] );
		display_objects[ i ].push_back( (LA_DisplayObject**) &mycurve[ i ] );
		display_objects[ i ].push_back( (LA_DisplayObject**) &mysurf[ i ] );
	}

	bspline_degree = 3;

	data_size_1d = 1024;
	long_data_size_1d = 8 * data_size_1d;

	j_1_1d = 7;
	levels_1d = 7;
	long_levels_1d = 10;


	data_size_2d = 128;
	long_data_size_2d = 2 * data_size_2d;

	j_1_2d = 6;
	levels_2d = 6;
	long_levels_2d = 7;


	p = 5;
	q = 2;
	s = 15.0;
	etha = 3.0;
	sigma = 0.0;
	lambda = 0.3;

	filter = new Wave_lib::DaubFilter< long double >();
	
	experiment_size = 1;
//	experiment_type = Experiment_V;			
//	experiment_type = Experiment_V_j;			
//	experiment_type = Experiment_Norm;			
	experiment_type = Experiment_Norm_j;			
	
	Point3D< float > pos = Point3D< float >( 0.5, 0.3, 1 );
	Vector3D< float > dir = Vector3D< float >( 0.5, 0.3, 0 );
	Vector3D< float > up = Vector3D< float >( 0, 1, 0 );

	
      _activegmw = NULL; // current window
//	  testcurve = NULL;
	  activ=NULL;
//	  mdlt=new ModelTree(this);
//	  mdlt->show();
	  myCounter=0;
}

void mainWindow::fileNew()
{
	for( int i = 0; i < number_of_windows; ++i )
	{
		cout << i << "   " << camera[ i ] -> getPos() << "  ---  " << camera[ i ] -> getUp() << "  ---  " << camera[ i ] -> getFocalLength() << endl;
	}

/*	Point3D< float > pos( 0, 0, 5 );
	Vector3D< float > dir = Vector3D< float >( 0, 0, 0 );
	Vector3D< float > up = Vector3D< float >( 0, 1, 0 );
	if( NULL == cam1 )
	{
		cam1 = new CameraIso( pos, dir - pos, up );
    
		gM_QtWindow1->insertCamera(cam1,false);
		cam1->setVisible(false);
		cam1->setCutPlane( 1.0, 6.0 );
		cam1->zoom( 1 ); 
	}

	gM_QtWindow1->setActiv(1);
//	gM_QtWindow1->insertLight(new PointLight_G(White, White, White, Point3D<GLfloat>(4.0,-11.0,4.0), 2.0), true);
	
	//Camera* cam;
	//Point3D<GLfloat>  pos4( 0, 500, -1000 );
	//Point3D<GLfloat>  tar4( 0, 0, 2.0 );
	//Vector3D<GLfloat> up4( 0, 1, 0 );
//	gM_QtWindow1->insertCamera(cam=new Camera(pos4, tar4, up4), true);

	Array< Point< float, 3 > > input;
	Array<float> knots;

	int data_size = 128;
	float t_min = - 0.2;
	float t_max = 1.2;
	float lambda = 0.5;

	knots.alwaysInsert( t_min );
	for( int i = 0; i <= data_size; ++i )
	{
		float x = t_min + ( i * ( t_max - t_min ) ) / data_size;
		float y;
		if( x <= 0.0 || x >= 1.0 )
		{
			y = 0.0;
		}
		else
		{
			y = pow( x, lambda ) * exp( - x * x / ( 1 - x * x ) );
		}
		y += random.draw() - 0.5;


		input.alwaysInsert( Point3D< float >( x, y, 0 ) );
		knots.alwaysInsert( x );
	}
	knots.alwaysInsert( t_max );
	gM_QtWindow1->remove( mycurve );
	delete mycurve;
	mycurve = new BSplineCurve< float, 3 >( input, knots, 3 );
	//mycurve->setColor(Red);
	mycurve->resetPlot(data_size,false);
	gM_QtWindow1->insert(mycurve);
	gM_QtWindow1->update();
*/}



void mainWindow::fileOpen()
{
	QString s = QFileDialog::getOpenFileName(
		".",
		"Data files (*.3ds *.txt)",
		this,
		"open file dialog",
		"Choose a file to open" );
	QFile file(s);
	file.open( IO_ReadOnly );
	if(s.contains(".pha"))
	{
		clearScene();
	    // gM_QtWindow1->insert(bb);
		
	}
	else if(s.contains(".txt"))
	{
	    clearScene();
		QTextStream stream( &file );
		// element_separator.setBinary(false);
		
		// read file, make object and insert... or whatever.
		//gM_QtWindow1->insert(tmp);
	}
	else if(s.contains((".3ds")))
	{
		clearScene();
		GM_3DsObject* tmp5=new GM_3DsObject(s.ascii());
		gM_QtWindow5->insert(tmp5);

	}

	file.close();
	
	gM_QtWindow5->update();
	
}


void mainWindow::fileSave()
{
	fileSaveAs();
}


void mainWindow::fileSaveAs()
{
	// doesn't make sense until you decide what to save and how.
	QString s = QFileDialog::getSaveFileName(
		".",
		"All files (*.txt *.*)",
		this,
		"open file dialog",
		"Choose a file to save to" );
	QFile file(s);
	if(s.contains(".myTextFormat"))
	{
		file.open( IO_WriteOnly );
		QTextStream stream( &file );
		element_separator.setBinary(false);
		element_separator=',';
		group_separator='\n';
		object_separator=';';
//		if(activ) stream << (*activ) ; // stream selected object
	    file.close();
	}
	else //binary
	{
		file.open( IO_WriteOnly );
		QDataStream stream( &file );
		element_separator.setBinary(true);
		object_separator.setBinary(true);
		group_separator.setBinary(true);
//		if(activ) stream << (*activ) ; // stream selected object
		file.close();
	}

}


void mainWindow::filePrint()
{
	// output the graphic window in a format suitable for printing, ps, eps or pdf.
	int format=GL2PS_PS;

	QString sf;       //selected filter
	QString fname=QFileDialog::getSaveFileName(QString::null,"EPS-file (*.eps);;PDF-file (*.pdf);;PS-file (*.ps)",this,"Save File","Save File Dialog",&sf);
	 
	if(fname.isEmpty()) return;
//	if(sf=="EPS-file (*.eps)")
//	{
//		if(!fname.endsWith(".eps"))  fname.append(".eps");
//		format=GL2PS_EPS;
//	}
//	else if(sf=="PDF-file (*.pdf)")
//	{
//		if(!fname.endsWith(".pdf"))  fname.append(".pdf");
//		format=GL2PS_PDF;
//	}
//	else if(sf=="PS-file (*.ps)")
//	{
//		if(!fname.endsWith(".ps"))   fname.append(".ps");
//		format=GL2PS_PS;
//	}
//
//	if ( QFile::exists( fname ) &&
//		QMessageBox::question(
//		this,
//		tr("Overwrite File? -- Application Name"),
//		tr("A file called %1 already exists."
//		"Do you want to overwrite it?")
//		.arg( fname ),
//		tr("&Yes"), tr("&No"),
//		QString::null, 0, 1 ) )
//		return;
	char wind[][ 50 ] = { "original", "noisy", "denoised", "error" };

	for( int i = 0; i < number_of_windows; ++i )
	{
		active_window = i;
		Redraw();

		{
			format=GL2PS_EPS;

			QString eps_name = fname;
			eps_name.append( wind[ i ] );
			eps_name.append( ".eps" );

			FILE *fp = fopen(eps_name.ascii(), "wb2");
			GLint buffsize = 0, state = GL2PS_OVERFLOW;
			GLint viewport[4];

			glGetIntegerv(GL_VIEWPORT, viewport);

			while( state == GL2PS_OVERFLOW ) 
			{
				buffsize += 1024*1024;
				gl2psBeginPage ( "Hgskolen i Narvik", "GM_lib", viewport,
					format, GL2PS_BSP_SORT, GL2PS_SILENT |
					GL2PS_SIMPLE_LINE_OFFSET | GL2PS_NO_BLENDING |
					GL2PS_OCCLUSION_CULL | GL2PS_BEST_ROOT | GL2PS_USE_CURRENT_VIEWPORT ,
					GL_RGBA, 0, NULL, 0, 0, 0, buffsize,
					fp, fname.ascii());	

				window[ active_window ] ->updateGL();
				state=gl2psEndPage();
			}
			fclose(fp);
		}

		{
			format=GL2PS_PDF;

			QString pdf_name = fname;
			pdf_name.append( wind[ i ] );
			pdf_name.append( ".pdf" );

			FILE *fp = fopen(pdf_name.ascii(), "wb2");
			GLint buffsize = 0, state = GL2PS_OVERFLOW;
			GLint viewport[4];

			glGetIntegerv(GL_VIEWPORT, viewport);

			while( state == GL2PS_OVERFLOW ) 
			{
				buffsize += 1024*1024;
				gl2psBeginPage ( "Hgskolen i Narvik", "GM_lib", viewport,
					format, GL2PS_BSP_SORT, GL2PS_SILENT |
					GL2PS_SIMPLE_LINE_OFFSET | GL2PS_NO_BLENDING |
					GL2PS_OCCLUSION_CULL | GL2PS_BEST_ROOT | GL2PS_USE_CURRENT_VIEWPORT ,
					GL_RGBA, 0, NULL, 0, 0, 0, buffsize,
					fp, fname.ascii());	

				window[ active_window ] ->updateGL();
				state=gl2psEndPage();
			}
			fclose(fp);
		}
	}
	
	/*	// output the graphic window in a format suitable for printing, ps, eps or pdf.
	int format=GL2PS_PS;

	QString sf;       //selected filter
	QString fname=QFileDialog::getSaveFileName(QString::null,"EPS-file (*.eps);;PDF-file (*.pdf);;PS-file (*.ps)",this,"Save File","Save File Dialog",&sf);
	 
	if(fname.isEmpty()) return;
	if(sf=="EPS-file (*.eps)")
	{
		if(!fname.endsWith(".eps"))  fname.append(".eps");
		format=GL2PS_EPS;
	}
	else if(sf=="PDF-file (*.pdf)")
	{
		if(!fname.endsWith(".pdf"))  fname.append(".pdf");
		format=GL2PS_PDF;
	}
	else if(sf=="PS-file (*.ps)")
	{
		if(!fname.endsWith(".ps"))   fname.append(".ps");
		format=GL2PS_PS;
	}

	if ( QFile::exists( fname ) &&
		QMessageBox::question(
		this,
		tr("Overwrite File? -- Application Name"),
		tr("A file called %1 already exists."
		"Do you want to overwrite it?")
		.arg( fname ),
		tr("&Yes"), tr("&No"),
		QString::null, 0, 1 ) )
		return;

	FILE *fp = fopen(fname.ascii(), "wb2");
	GLint buffsize = 0, state = GL2PS_OVERFLOW;
	GLint viewport[4];

	glGetIntegerv(GL_VIEWPORT, viewport);

	while( state == GL2PS_OVERFLOW ) 
	{
		buffsize += 1024*1024;
		gl2psBeginPage ( "Hgskolen i Narvik", "GM_lib", viewport,
			format, GL2PS_BSP_SORT, GL2PS_SILENT |
			GL2PS_SIMPLE_LINE_OFFSET | GL2PS_NO_BLENDING |
			GL2PS_OCCLUSION_CULL | GL2PS_BEST_ROOT | GL2PS_USE_CURRENT_VIEWPORT ,
			GL_RGBA, 0, NULL, 0, 0, 0, buffsize,
			fp, fname.ascii());

		window[ active_window ] ->updateGL();
		state=gl2psEndPage();
	}
	fclose(fp);
*/}




void mainWindow::fileExit()
{
	exit(0);
}


void mainWindow::editUndo()
{
	// always nice to have
}


void mainWindow::editRedo()
{
  
}


void mainWindow::editCut()
{
 // NB as it is , this is a delete operation !
 if(activ)
 {
	 gM_QtWindow5->remove(activ);
 }
}


void mainWindow::editCopy()
{
 
}


void mainWindow::editPaste()
{

}


void mainWindow::editFind()
{
	
}


void mainWindow::helpIndex()
{
	// could perhaps open an index to the thesis ?
}


void mainWindow::helpContents()
{
	demoText();
}


void mainWindow::helpAbout()
{
	QMessageBox::about( this, "About <Application>",
		"<Application> is a <one-paragraph blurb>\n\n"
		"Copyright 2005 Hgskolen i Narvik (HiN) and .....\n\n"
		"<This work is based on GM_lib, a C++ library for geometrical modelling developed at HiN >\n\n"
		"For technical support, call 1234-56789 or see\n"
		"http://www.hin.no/Application/\n" );
}

void mainWindow::clearScene()
{
	// make sensible default values for Camera and Target position here, please.
	
	if(_activegmw) delete _activegmw;	//If I have a active gmwindow delete it
	_activegmw = new GM_Window();		//Create a new gmwindow
	_activegmw->reset();				//The new gmwindow need to be reset so it will find the size of GM_QtWindow
     
	(*gM_QtWindow5) = (*_activegmw);
	// insert camera for 3D Window
	
//	Point3D< float > pos( 4, -10, 6 );
//	Vector3D< float > dir = Vector3D< float >( 0, 30, -10 );
//	Vector3D< float > up( dir ^ Vector3D< float >( -1, 0, 0 ) );

	Point3D< float > pos( 0, 0, 100 );
	Vector3D< float > dir = Vector3D< float >( 0, 0, 0 );
	Vector3D< float > up = Vector3D< float >( 0, 1, 0 );
	Camera *cam = new CameraIso( pos, dir - pos, up );
    
	gM_QtWindow5->insertCamera(cam,false);
	gM_QtWindow5->setActiv(1);
//	gM_QtWindow1->insertLight(new PointLight_G(White, White, White, Point3D<GLfloat>(4.0,-11.0,4.0), 2.0), true);
	
	//Camera* cam;
	//Point3D<GLfloat>  pos4( 0, 500, -1000 );
	//Point3D<GLfloat>  tar4( 0, 0, 2.0 );
	//Vector3D<GLfloat> up4( 0, 1, 0 );
//	gM_QtWindow1->insertCamera(cam=new Camera(pos4, tar4, up4), true);
	cam->setVisible(false);
	cam->setCutPlane( 1.0, 250.0 );
	cam->zoom( 5 ); 
//	gM_QtWindow1->setActiv(1);
	
	// insert camera and lights for 2D Window
	/*CameraIso* camXY;
	Point3D<GLfloat>  pos1(0,0,20);
	Point3D<GLfloat>  tar1(0,0,0);
	Vector3D<GLfloat> up1(0,1,0);
	gM_QtWindow1->insertCamera(camXY=new CameraIso(pos1, tar1-pos1, up1), true);
	camXY->setGrid(0.5,0.5);
	camXY->zoom(15);
	camXY->setVisible(false);
	gM_QtWindow1->setActiv(2,1,true); */

	// Let it be light
//	gM_QtWindow1->insertLight(new SpotLight_G(White, White, White, Point3D<GLfloat>(0,30,10),Vector3D<float>(0.0,-30,-10),22), true);
	gM_QtWindow5->insertSun();
	
	gM_QtWindow5->scaleDayLight(1.0);
/*	
	mdlt->SceneTree->clear();
	
	// this is for Scene graf, a list box
	Scene* sc=gM_QtWindow1;
    for(int i=0; i<gM_QtWindow1->totalSize();i++)
	{
		DisplayObject* tmp=sc->operator ()(i);
		QString nm;
		nm.setNum(tmp->getName());
		QListViewItem* li=new QListViewItem(mdlt->SceneTree,tmp->identity(),nm);
		li->setRenameEnabled(0,true);
	}
*/
}


void mainWindow::setActive( LA_DisplayObject * a)
{
	activ=a;
}


void mainWindow::updateMaterial( Material& m )
{
	if(activ)
	{
		if(activ->typeId()>=1000)
		{
			activ->setMaterial(m);
			PSurf<float,3>* tmp=dynamic_cast<PSurf<float,3>*>(activ);
			if(tmp) tmp->resetPlot(0,0,true);
		} 
	}
}


void mainWindow::editMaterial()
{
/* MaterialSelect dlg(this,"Material Select",gM_QtWindow5);
// dlg->show(); connect(dlg->updateColor,this->updateMaterial......
	if ( dlg.exec() == QDialog::Accepted ) 
		   {
		       this->setActiveWindow();
			   gM_QtWindow1->makeCurrent();
			   Material mx = dlg.current;
			   QString  s = dlg.currentTexture;
			   if(!s.isEmpty())//!s.contains("No Texture"))
			   {
				   Texture tx;
				   uint txid=tx.LoadGL(s.latin1());
				   if(txid==0) QMessageBox::information( this, "VrGFX","No Texure.\n"+s);
				   if(txid>0) mx.set(txid); 
			   }
			   updateMaterial(mx);
			   
			   gM_QtWindow1->update();
		     // int result = dlg->Material_list->currentItem();
			 // activ->setMaterial(mlist(result));
		   }*/
}




void mainWindow::editResample()
{
	if(activ)
	{
		if(activ->typeId()>=1000)
		{
			PSurf<float,3> * tmp=dynamic_cast<PSurf<float,3>* >(activ);   
			if(tmp)
			{ 
				bool ok;
				int m1 = QInputDialog::getInteger(
					"Surf resample for OpenGL", "Enter number of samples:", 64, 1, 512, 2,
					&ok, this );
				if(ok) tmp->resetPlot(m1,m1,true); else tmp->resetPlot(0,0,true);
			} else 
			{
				/* PTriangle<float,3> * tmp=dynamic_cast<PTriangle<float,3>* >(activ);   
				if(tmp)
				{ 
					bool ok;
					int m1 = QInputDialog::getInteger(
						"Surf resample for OpenGL", "Enter number of samples:", 64, 1, 512, 2,
						&ok, this );
					if(ok) tmp->resetPlot(m1,true); else tmp->resetPlot(0,true);
				} */
			}
			
		}
		if(activ->typeId()>=2000)
		{
			PCurve<float,3> * tmp=dynamic_cast<PCurve<float,3>* >(activ);   
			if(tmp)
			{ 
				bool ok;
				int m1 = QInputDialog::getInteger(
					"Curve resample for OpenGL", "Enter number of samples:", 256, 1, 512, 2,
					&ok, this );
				if(ok) tmp->resetPlot(m1,true); else tmp->resetPlot(128,true);
			}
		}
	}
}


void mainWindow::gaussCurvature()
{
	if(activ)
	{
		if(activ->typeId()>=1000)
		{ 
			PSurf<float,3>* tmp=dynamic_cast<PSurf<float,3>*>(activ);
			if(tmp)
			{
				MaterialCurvature gauss(tmp,64,64,true);
				tmp->setMaterial(gauss);
				tmp->resetPlot(0,0,true);
			}
		}
	}
}


void mainWindow::meanCurvature()
{
	if(activ)
	{
		if(activ->typeId()>=1000)
		{
			PSurf<float,3>* tmp=dynamic_cast<PSurf<float,3>*>(activ);
			if(tmp)
			{
				MaterialCurvature mean(tmp,64,64,false);
				tmp->setMaterial(mean);
				tmp->resetPlot(0,0,true);
			}
		}
	}
}


void mainWindow::demoText()
{
/*	char* tx1="GM_lib";
	char* tx2="Et programbibliotek";
	char* tx3="for simulering";
	char* tx4="og visualisering";
	//	char* tx5="simuleringer";
	//	char* tx6="beregninger";

	Text3D *txt1 = new Text3D(tx1, 0.3, 0.35);
	Text3D *txt2 = new Text3D(tx2, 0.3, 0.35);
	Text3D *txt3 = new Text3D(tx3, 0.3, 0.35);
	Text3D *txt4 = new Text3D(tx4, 0.3, 0.35);
	//	Text3D *txt5 = new Text3D(tx5, 0.3, 0.35);
	//	Text3D *txt6 = new Text3D(tx6, 0.3, 0.35);

	txt2->translate(Vector3D<float>(0,-2,0));
	txt3->translate(Vector3D<float>(0,-3.5,0));
	txt4->translate(Vector3D<float>(0,-5,0));
	//	txt5->translate(Vector3D<float>(0,-6,0));
	//	txt6->translate(Vector3D<float>(0,-7.5,0));

	txt2->scale(0.2);
	txt3->scale(0.2);
	txt4->scale(0.2);
	//	txt5->scale(0.2);
	//	txt6->scale(0.2);

	txt1->setMaterial(PolishedGold);
	txt2->setMaterial(PolishedSilver);
	txt3->setMaterial(PolishedSilver);
	txt4->setMaterial(PolishedSilver);
	//	txt5->setMaterial(BlackPlastic);
	//	txt6->setMaterial(BlackPlastic);

	if(!_activegmw || QMessageBox::question(
		this,
		tr("Insert Text?"),
		tr("A current scene exists."
		"Do you want to insert this text into it?")
		.arg( tx1 ),
		tr("&Yes"), tr("&No"),
		QString::null, 0, 1 ))
		{
			if(_activegmw) delete _activegmw;	// If I have a active gmwindow delete it
			_activegmw = new GM_Window();		// Create a new gmwindow
			_activegmw->reset();				// The new gmwindow need to be reset so it will find the size of GM_QtWindow
			(*gM_QtWindow1) = (*_activegmw);

			//*** insert camera and lights
			Camera* cam;
			Point3D<GLfloat>  pos1(0,0,25);
			Point3D<GLfloat>  tar1(0,0,0);
			Vector3D<GLfloat> up1(0,1,0);
			gM_QtWindow1->insertCamera(cam=new Camera(pos1, tar1-pos1, up1), true);
			gM_QtWindow1->setActiv(1);

			gM_QtWindow1->insertLight(new PointLight_G(White, White, White, Point3D<GLfloat>(30,0,10)), true);
			gM_QtWindow1->insertLight(new SpotLight_G(White, White, White, Point3D<GLfloat>(0,30,10),Vector3D<float>(0.0,-30,-10),120), true);
			gM_QtWindow1->insertSun();
		}
	gM_QtWindow1->insert(txt1);
	gM_QtWindow1->insert(txt2);
	gM_QtWindow1->insert(txt3);
	gM_QtWindow1->insert(txt4);
	//	gM_QtWindow1->insert(txt5);
	//	gM_QtWindow1->insert(txt6);*/
}



void mainWindow::insertSpotLight()
{
/*	getPoint* v=new getPoint(this,"Spot Light Angle and Position");
	if(v->exec() )
	{
		float xx=v->xs->text().toDouble();
		float yy=v->ys->text().toDouble();
		float zz=v->zs->text().toDouble();
		int ang=v->ang_s->text().toInt();
		gM_QtWindow1->insertLight(new SpotLight_G(White, White, White, Point3D<GLfloat>(xx,yy,zz),Vector3D<float>(0.0,0.0,-1.0),ang), true);
	}*/
}





void mainWindow::insertPointLight()
{
/*	getPoint* v=new getPoint(this,"Light Position");
	if(v->exec() )
	{
		float xx=v->xs->text().toDouble();
		float yy=v->ys->text().toDouble();
		float zz=v->zs->text().toDouble();
		gM_QtWindow1->insertLight(new PointLight_G(White, White, White, Point3D<GLfloat>(xx,yy,zz)), true);
	}*/
}


void mainWindow::insertPerspectiveCamera()
{
/*	Camera* cam;
	Point3D<GLfloat>  pos4(0,0,25);
	Point3D<GLfloat>  tar4(0,0,0);
	Vector3D<GLfloat> up4(0,1,0);
	gM_QtWindow1->insertCamera(cam=new Camera(pos4, tar4-pos4, up4), true);
	gM_QtWindow1->setActiv(1);*/
}


void mainWindow::insertIsoCameraXY()
{
/*	CameraIso* camXY;
	Point3D<GLfloat>  pos1(0,0,75);
	Point3D<GLfloat>  tar1(0,0,0);
	Vector3D<GLfloat> up1(0,1,0);
	gM_QtWindow1->insertCamera(camXY=new CameraIso(pos1, tar1-pos1, up1), true);
	camXY->setGrid(0.5,0.5);
	camXY->zoom(5);	
	gM_QtWindow1->setActiv(1);*/
}


void mainWindow::insertIsoCameraXZ()
{
/*	CameraIso* camXZ;
	Point3D<GLfloat>  pos2(0,75,0);
	Point3D<GLfloat>  tar2(0,0,0);
	Vector3D<GLfloat> up2(0,0,1);
	gM_QtWindow1->insertCamera(camXZ=new CameraIso(pos2, tar2-pos2, up2), true);
	camXZ->setGrid(0.5,0.5);
	camXZ->zoom(5);
	gM_QtWindow1->setActiv(1);*/
}


void mainWindow::insertIsoCameraZY()
{
/*	CameraIso* camYZ;
	Point3D<GLfloat>  pos3(75,0,0);
	Point3D<GLfloat>  tar3(0,0,0);
	Vector3D<GLfloat> up3(0,0,1);
	gM_QtWindow1->insertCamera(camYZ=new CameraIso(pos3, tar3-pos3, up3), true);
	camYZ->setGrid(0.5,0.5);
	camYZ->zoom(5);
	gM_QtWindow1->setActiv(1);*/
}


void mainWindow::editScaleAction_activated()
{
/*	if(activ)
	{
		getPoint* v=new getPoint(this,"Scale ");
		if(v->exec() )
		{
			float xx=v->xs->text().toDouble();
			float yy=v->ys->text().toDouble();
			float zz=v->zs->text().toDouble();
			Point3D<GLfloat> dsc(xx,yy,zz);
			activ->scale(dsc);
		}
	}*/
}


void mainWindow::EditRotateAction_activated()
{
/*	if(activ)
	{
		getPoint* v=new getPoint(this,"Rotation Angle and Axis");
		if(v->exec() )
		{
			float xx=v->xs->text().toDouble();
			float yy=v->ys->text().toDouble();
			float zz=v->zs->text().toDouble();
			int a=v->ang_s->text().toInt();
			Point3D<GLfloat> dsc(xx,yy,zz);
			activ->rotateGlobal(a,dsc);
		}
	}*/
}



void mainWindow::slider1_valueChanged( int )
{
 
}






void mainWindow::SetupCamera( const int dimension, double x_min, double x_max, double y_min, double y_max, double z_min, double z_max, bool use_curve )
{
	Vector3D< float > target;
	Vector3D< float > target_up;

	switch( dimension )
	{
		case( 1 ) :
			target = Vector3D< float >( ( x_max + x_min ) / 2.0, ( y_max + y_min ) / 2.0, 100 );
			target_up = Vector3D< float >( 0, 1, 0 );
			break;

		case( 2 ) :
			target = Vector3D< float >( x_max + ( x_max - x_min ) * 28.0, y_min - ( y_max - y_min ) * 35.0, z_max + ( z_max - z_min ) * 17.0 );
			target_up = Vector3D< float >( - 0.19526, 0.240908, 0.950703 );
			break;
	}

	for( int i = 0; i < number_of_windows; ++i )
	{
		Point< float, 3 > pos = camera[ i ] -> getPos();
		camera[ i ] -> move( target - pos );
		camera[ i ] -> zoom( 50.0 * ( 4.0 / max( x_max - x_min, y_max - y_min ) ) / camera[ i ] -> getFocalLength() );

		Vector3D< float > current_up = camera[ i ] -> getUp();
		double thetha = acos( ( current_up * target_up ) / ( sqrt( current_up * current_up ) * sqrt( target_up * target_up ) ) );
		Point3D< float > axis( current_up ^ target_up );
		camera[ i ] -> rotate( Angle( thetha ), axis );
	
		if( use_curve )
		{
			camera[ i ] -> lockAtTarget( mycurve[ i ] );
		}
		else
		{
			camera[ i ] -> lockAtTarget( mysurf[ i ] );
		}

		window[ i ] -> makeCurrent();
		window[ i ] -> reDraw();
		window[ i ] -> update();
		
		camera[ i ] -> unLockTarget();

		window[ i ] -> makeCurrent();
		window[ i ] -> reDraw();
		window[ i ] -> update();
	}
}

void mainWindow::Clear()
{
	for( int i = 0; i < number_of_windows + 1; ++i )
	{
		for( int do_i = 0; i < number_of_windows && do_i < display_objects[ i ].size(); ++do_i )
		{
			if( NULL != *display_objects[ i ][ do_i ] )
			{
				window[ i ] -> remove( *display_objects[ i ][ do_i ] );
				delete *display_objects[ i ][ do_i ];
				*display_objects[ i ][ do_i ] = NULL;
			}
		}
	}
}





void mainWindow::load_signal1DLambda_TearAction_activated()
{
	LoadSignal1D( &LambdaTear, -0.25, 1.25 );
}


void mainWindow::load_signal1DSineAction_activated()
{
	LoadSignal1D( &sin, -3.25, 3.25 );
}


void mainWindow::load_signal1DCosineAction_activated()
{
	LoadSignal1D( &cos, -1.625, 4.875 );
}


void mainWindow::load_signal1DExpAction_activated()
{
	LoadSignal1D( &exp, -3.25, 0.25 );
}


void mainWindow::load_signal1DLogAction_activated()
{
	LoadSignal1D( &log, 0.01, 3.25 );
}

void mainWindow::load_signal1DRandomAction_activated()
{
	LoadSignal1D( &Random1D, -0.25, 1.25 );
}


void mainWindow::load_signal1DFrom_File_Action_activated()
{
	int old_data_size_1d = data_size_1d;
	int old_long_data_size_1d = long_data_size_1d;

	QString qfilename = QFileDialog::getOpenFileName( ".", "Data files 1d (*.*)", this, "Load 1D data", "Choose a file to open" );

	if( NULL != qfilename.data() )
	{
		FILE* fp = fopen( qfilename.data(), "r" );
		fscanf( fp, "%d %d %lf %lf", &data_size_1d, &long_data_size_1d, &min_t_1d, &max_t_1d );	

		file_data_1d = vector< long double >( long_data_size_1d, 0.0 );
		for( int i = 0; i < long_data_size_1d; ++i )
		{
			fscanf( fp, "%lf", &file_data_1d[ i ] );
		}
		fclose(fp);
	
		LoadSignal1D( &FileData1D, min_t_1d, max_t_1d );
	}
	
	data_size_1d = old_data_size_1d;
	long_data_size_1d = old_long_data_size_1d;
}
void mainWindow::load_signal2DLambda_Tear_x_Lambda_TearAction_activated()
{
	LoadSignal2D( &LambdaTearXLambdaTear, -0.25, 1.25, -0.25, 1.25 );
}

void mainWindow::load_signal2DRandom_x_RandomAction_activated()
{
	LoadSignal2D( &Random2D, -0.25, 1.25, -0.25, 1.25 );
}
void mainWindow::load_signal2DFrom_File_Action_activated()
{
	int old_data_size_2d = data_size_2d;
	int old_long_data_size_2d = long_data_size_2d;

	QString qfilename = QFileDialog::getOpenFileName( ".", "Data files 2d (*.*)", this, "Load 2D data",	"Choose a file to open" );
	
	if( NULL != qfilename.data() )
	{
		FILE* fp = fopen( qfilename.data(), "r" );
		fscanf( fp, "%d %d %lf %lf %lf %lf", &data_size_2d, &long_data_size_2d, &min_u_2d, &max_u_2d, &min_v_2d, &max_v_2d );

		file_data_2d = std::vector< std::vector< long double > >( long_data_size_2d, std::vector< long double >( long_data_size_2d, 0.0 ) );
		for( int i = 0; i < long_data_size_2d; ++i )
		{
			for( int j = 0; j < long_data_size_2d; ++j )
			{
				fscanf( fp, "%lf", &file_data_2d[ i ][ j ] );
			}
		}
		fclose(fp);
	
		LoadSignal2D( &FileData2D, min_u_2d, max_u_2d, min_v_2d, max_v_2d );
	}
	
	data_size_2d = old_data_size_2d;
	long_data_size_2d = old_long_data_size_2d;
}



void mainWindow::load_signalImageAction_activated()
{
	QString qfilename = QFileDialog::getOpenFileName( ".", "Image files (*.jpg *.bmp *.jpeg)", this, "Load Image", "Choose a file to open" );
	if( NULL != qfilename.data() )
	{
		LoadImage( qfilename.data() );
	}
}




void mainWindow::LoadSignal1D( func1d func, double t_min, double t_max )
{
	Clear();

	for( int i = 0; i < number_of_windows; ++i )
	{
		points_1d[ i ].setSize( data_size_1d );
		knots_1d[ i ].clear();

		for( int count = 0; count < bspline_degree; ++count )
		{
			knots_1d[ i ].alwaysInsert( t_min + 0.5 * ( t_max - t_min ) / (long double) ( data_size_1d - bspline_degree + 1 ) );
		}

		for( int t = 0; t < data_size_1d - bspline_degree + 1; ++t )
		{
			knots_1d[ i ].alwaysInsert( t_min + ( t + 0.5 ) * ( t_max - t_min ) / (long double) ( data_size_1d - bspline_degree + 1 ) );
		}

		for( int count = 0; count < bspline_degree; ++count )
		{
			knots_1d[ i ].alwaysInsert( t_max - 0.5 * ( t_max - t_min ) / (long double) ( data_size_1d - bspline_degree + 1 ) );
		}
	}

	double f_min = numeric_limits< double >::infinity();
	double f_max = - numeric_limits< double >::infinity();

	data_1d.setSize( DVector< int >( 1, data_size_1d ) );
	noisy_data_1d.setSize( DVector< int >( 1, data_size_1d ) );

	for( int t = 0; t < data_size_1d; ++t )
	{
		long double x = t_min + ( t + 0.5 ) * ( t_max - t_min ) / (long double) data_size_1d;
		long double y = ( *func )( x );
		long double noisy_y = y + random();

		data_1d[ t ] = y;
		noisy_data_1d[ t ] = noisy_y;

		f_min = min( f_min, noisy_y );
		f_max = max( f_max, noisy_y );

		points_1d[ 0 ][ t ] = Point3D< float >( x, y, 0 );
		points_1d[ 1 ][ t ] = Point3D< float >( x, noisy_y, 0 );
		points_1d[ 2 ][ t ] = Point3D< float >( x, 0, 0 );
		points_1d[ 3 ][ t ] = Point3D< float >( x, 0, 0.001 );
	}

	long_data_1d.setSize( DVector< int >( 1, long_data_size_1d ) );
	for( int t = 0; t < long_data_size_1d; ++t )
	{
		long double x = t_min + ( (long double) t * ( t_max - t_min ) + 0.5 ) / ( long_data_size_1d );
		long double y = ( *func )( x );

		long_data_1d[ t ] = y;
	}

	for( int i = 0; i < number_of_windows; ++i )
	{
		window[ i ] -> makeCurrent();
		window[ i ] -> reDraw();

		ox[ i ] = new MyLine< double, 3 >( Point3D< float >( t_min - 0.05, 0, -0.001 ), Point3D< float >( t_max + 0.05, 0, -0.001 ) );
		window[ i ] -> insert( ox[ i ] );

		oy[ i ] = new MyLine< double, 3 >( Point3D< float >( 0, f_min - 0.05, -0.001 ), Point3D< float >( 0, f_max + 0.05, -0.001 ) );
		window[ i ] -> insert( oy[ i ] );
		
		window[ i ] -> update();
	}

	for( int i = 0; i < number_of_windows / 2; ++i )
	{
		window[ i ] -> makeCurrent();
		window[ i ] -> reDraw();

		mycurve[ i ] = new BSplineCurve< float, 3 >( points_1d[ i ], knots_1d[ i ], 3 );
		mycurve[ i ] -> setColor( Red );
		mycurve[ i ] -> resetPlot( data_size_1d, false );

		window[ i ]->insert( mycurve[ i ] );

		window[ i ] -> update();
	}

	Analyse1D();

	for( int i = number_of_windows / 2; i < number_of_windows; ++i )
	{
		window[ i ] -> makeCurrent();
		window[ i ] -> reDraw();

		mycurve[ i ] = new BSplineCurve< float, 3 >( points_1d[ i ], knots_1d[ i ], bspline_degree );
		mycurve[ i ] -> setColor( Red );
		mycurve[ i ] -> resetPlot( data_size_1d, false );

		window[ i ] -> insert( mycurve[ i ] );
		window[ i ] -> update();
	}

	SetupCamera( 1, t_min, t_max, f_min, f_max, 0, 0, true );



	cout << "Number of zeros: " << zero_count << endl;
	cout << "Variance:    " << random.Variance() << endl;
	cout << "Expectation: " << random.Expectation() << endl;
	cout << "Minimum:     " << random.Minimum() << endl;
	cout << "Maximum:     " << random.Maximum() << endl;
}

void mainWindow::Analyse1D()
{
	Wave_lib::WaveDWTnD< long double, 1 > dwt( filter, 8.0 );

	Array< DArrayN< long double, 1 >* > c;
	Array< DVector< int >* > l;

	Array< DArrayN< long double, 1 >* > long_c;
	Array< DVector< int >* > long_l;
	
	Array< DArrayN< long double, 1 >* > psi_c;

	dwt.decomposition( data_1d, levels_1d, c, l );
	dwt.decomposition( long_data_1d, long_levels_1d, long_c, long_l );
	
	v = std::vector< long double >( levels_1d + 1, 0.0 );
	zero_count = 0;

	long double a_j;
	long double b_jk;
	long double betha_jk;
	long double numer = 0.0;
	long double denom = 0.0;
	long double sum_of_psi_jk = 0.0;

	// Computing v_j
	switch( experiment_type )
	{
		case( Experiment_V ) :
		{
			long double left_v = 0.0;
			long double right_v = 0.0001;


			psi_c = c;
			for( int j = 0; j <= levels_1d; ++j )
			{
				psi_c[ j ] = new DArrayN< long double, 1 >( *c[ j ] );
				for( int k = 0; k < ( *l[ j ] )[ 0 ]; ++k )
				{
					( *psi_c[ j ] )[ k ] = 0.0;
				}
			}
			
			do
			{
				long double risk = 0.0;
				long double current_v = left_v + ( right_v - left_v ) / 2.0;
					
				long double left_risk = 0.0;
				long double right_risk = 0.0;
				
				long double left_quater_v = left_v + ( right_v - left_v ) / 4.0;
				long double left_quater_risk = 0.0;
				
				long double right_quater_v = left_v + 3 * ( right_v - left_v ) / 4.0;
				long double right_quater_risk = 0.0;

				for( int j = 1; j <= levels_1d; ++j )
				{
					a_j = pow( 2.0, (double) ( 2 * ( j_1_1d - levels_1d + j - 1 ) * ( s - sigma ) ) );	

					for( int k = 0; k < ( *l[ j ] )[ 0 ]; ++k )
					{
						( *psi_c[ j ] )[ k ] = 1.0;
						psi_jk_1d = dwt.reconstruction( psi_c, l );
						( *psi_c[ j ] )[ k ] = 0.0;		

						sum_of_psi_jk = 0.0;
						for( int i = 0; i < data_size_1d; ++i )
						{
							sum_of_psi_jk += psi_jk_1d[ i ] * psi_jk_1d[ i ];
						}	

						b_jk = ( *c[ j ] )[ k ] - ( *long_c[ j ] )[ k ];
						betha_jk = ( *long_c[ j ] )[ k ];	
	
						risk += ( 1.0 / ( 1 + a_j * current_v ) ) * ( b_jk * b_jk 
																	 + ( random.Variance() / (long double) data_size_1d ) * ( sum_of_psi_jk  / (long double) data_size_1d ) 
																	 - 2 * a_j * current_v * b_jk * betha_jk
																	 + a_j * a_j * current_v * current_v * betha_jk * betha_jk );

						left_risk += ( 1.0 / ( 1 + a_j * left_v ) ) * ( b_jk * b_jk 
																	  + ( random.Variance() / (long double) data_size_1d ) * ( sum_of_psi_jk  / (long double) data_size_1d ) 
																	  - 2 * a_j * left_v * b_jk * betha_jk
																	  + a_j * a_j * left_v * left_v * betha_jk * betha_jk );

						right_risk += ( 1.0 / ( 1 + a_j * right_v ) ) * ( b_jk * b_jk 
																		+ ( random.Variance() / (long double) data_size_1d ) * ( sum_of_psi_jk  / (long double) data_size_1d ) 
																		- 2 * a_j * right_v * b_jk * betha_jk
																		+ a_j * a_j * right_v * right_v * betha_jk * betha_jk );

						left_quater_risk += ( 1.0 / ( 1 + a_j * left_quater_v ) ) * ( b_jk * b_jk 
																					+ ( random.Variance() / (long double) data_size_1d ) * ( sum_of_psi_jk  / (long double) data_size_1d ) 
																					- 2 * a_j * left_quater_v * b_jk * betha_jk
																					+ a_j * a_j * left_quater_v * left_quater_v * betha_jk * betha_jk );

						right_quater_risk += ( 1.0 / ( 1 + a_j * right_quater_v ) ) * ( b_jk * b_jk 
																					  + ( random.Variance() / (long double) data_size_1d ) * ( sum_of_psi_jk  / (long double) data_size_1d ) 
																					  - 2 * a_j * right_quater_v * b_jk * betha_jk
																					  + a_j * a_j * right_quater_v * right_quater_v * betha_jk * betha_jk );
					}
				}			
				
				if( left_risk > risk && risk > right_risk )
				{
					left_v = current_v;
					right_v = right_v * 2;			
				}
				else if( left_risk < risk && risk < right_risk )
				{
					right_v = current_v;
				}
				else
				{
					if( left_quater_risk < risk )
					{
						right_v = current_v;
					}else
					{
						if( right_quater_risk < risk )
						{
							left_v = current_v;
						}
						else
						{
							left_v = left_quater_v;
							right_v = right_quater_v;
						}
					}
				}
			}while( fabs( right_v - left_v ) > 1e-15 );
			
			v = std::vector< long double >( levels_1d + 1, left_v + ( right_v - left_v ) / 2.0 );
		}
			break;

		case( Experiment_V_j ) :
			psi_c = c;
			for( int j = 0; j <= levels_1d; ++j )
			{
				psi_c[ j ] = new DArrayN< long double, 1 >( *c[ j ] );
				for( int k = 0; k < ( *l[ j ] )[ 0 ]; ++k )
				{
					( *psi_c[ j ] )[ k ] = 0.0;
				}
			}

			for( int j = 1; j <= levels_1d; ++j )
			{
				numer = 0.0;
				denom = 0.0;
				a_j = pow( 2.0, (double) ( 2 * ( j_1_1d - levels_1d + j - 1 ) * ( s - sigma ) ) );	

				for( int k = 0; k < ( *l[ j ] )[ 0 ]; ++k )
				{
					( *psi_c[ j ] )[ k ] = 1.0;
					psi_jk_1d = dwt.reconstruction( psi_c, l );
					( *psi_c[ j ] )[ k ] = 0.0;	

					sum_of_psi_jk = 0.0;
					for( int i = 0; i < data_size_1d; ++i )
					{
						sum_of_psi_jk += psi_jk_1d[ i ] * psi_jk_1d[ i ];
					}	

					b_jk = ( *c[ j ] )[ k ] - ( *long_c[ j ] )[ k ];
					betha_jk = ( *long_c[ j ] )[ k ];	

					numer += b_jk * b_jk + b_jk * betha_jk + ( random.Variance() / (long double) data_size_1d ) * ( sum_of_psi_jk  / (long double) data_size_1d );
					denom += betha_jk * betha_jk + b_jk * betha_jk;
				}

				v[ j ] = numer / ( a_j * denom );
				if( v[ j ] <= 0.0 )
				{
					++zero_count;
					v[ j ] = 0.0;
				}
			}
			break;

		case( Experiment_Norm ) :
		case( Experiment_Norm_j ) :
			for( int j = 1; j <= levels_1d; ++j )
			{
				if( p == 0.0 )
				{
					v[ j ] = 1.0;
					for( int k = 0; k < ( *l[ j ] )[ 0 ]; ++k )
					{
						v[ j ] *= ( *c[ j ] )[ k ];
					}
					v[ j ] = pow( fabs( v[ j ] ), (long double) 1.0 / ( *l[ j ] )[ 0 ] );
				}
				else if( p == numeric_limits< double >::infinity() )
				{
					v[ j ] = ( *c[ j ] )[ 0 ];
					for( int k = 0; k < ( *l[ j ] )[ 0 ]; ++k )
					{
						if( v[ j ] < ( *c[ j ] )[ k ] )
						{
							v[ j ] = ( *c[ j ] )[ k ];
						}
					}
				}
				else
				{
					v[ j ] = 0.0;
					for( int k = 0; k < ( *l[ j ] )[ 0 ]; ++k )
					{
						v[ j ] += pow( fabs( ( *c[ j ] )[ k ] ), p );
					}
				}	
			}
			break;
	}

	// Reconstruction the signal
	for( int count = 0; count < experiment_size; ++count )
	{
		Array< DArrayN< long double, 1 >* > noisy_c;
		Array< DVector< int >* > noisy_l;
		dwt.decomposition( noisy_data_1d, levels_1d, noisy_c, noisy_l );
		std::vector< long double > actual_v = v;

		for( int j = 1; j < levels_1d; ++j )
		{
			cout << j << " " << v[ j ] << endl;
		}

		switch( experiment_type )
		{
			case( Experiment_V ) :
			case( Experiment_V_j ) :
				for( int j = 1; j <= levels_1d; ++j )
				{
					a_j = pow( 2.0, (double) ( 2 * (  j_1_1d - levels_1d + j - 1 ) * ( s - sigma ) ) );
					actual_v[ j ] = 1.0 / ( 1.0 + v[ j ] * a_j );

					long double vvv  = v[ j ];


					cout << a_j << "    " << v[ j ] << "     " << actual_v[ j ] << endl;
				}
				break;
			
			case( Experiment_Norm  ) :
				{

				}

				break;

			case( Experiment_Norm_j  ) :
				for( int j = 1; j <= levels_1d; ++j )
				{
					double sum;
					if( p == 0.0 )
					{
						sum = 1.0;
						for( int k = 0; k < ( *noisy_l[ j ] )[ 0 ]; ++k )
						{
							sum *= ( *noisy_c[ j ] )[ k ];
						}
						sum = pow( fabs( sum ), 1.0 / ( *noisy_l[ j ] )[ 0 ] );	
				
						if( sum != 0.0 )
						{
							actual_v[ j ] = v[ j ] / sum;
						}
					}
					else if( p == numeric_limits< double >::infinity() )
					{
						sum = fabs( ( *noisy_c[ j ] )[ 0 ] );
						for( int k = 0; k < ( *noisy_l[ j ] )[ 0 ]; ++k )
						{
							if( sum < fabs( ( *noisy_c[ j ] )[ k ] ) )
							{
								sum = fabs( ( *noisy_c[ j ] )[ k ] );
							}
						}

						if( sum != 0.0 )
						{
							actual_v[ j ] = v[ j ] / sum;
						}
					}
					else
					{
						sum = 0.0;
						for( int k = 0; k < ( *noisy_l[ j ] )[ 0 ]; ++k )
						{
							sum += pow( fabs( ( *noisy_c[ j ] )[ k ] ), (long double) p );
						}	
						
						actual_v[ j ] = pow( v[ j ] / sum, (long double) 1.0 / p );
					}
				}
				break;
		}

		for( int j = 1; j <= levels_1d; ++j )
		{
			for( int k = 0; k < ( *noisy_l[ j ] )[ 0 ]; ++k )
			{
				( ( *noisy_c[ j ] )[ k ] ) *= actual_v[ j ];
			}
		}

		reconstructed_data_1d = dwt.reconstruction( noisy_c, noisy_l );
	
		for( int t = 0; t < data_size_1d; ++t )
		{
			points_1d[ 2 ][ t ][ 1 ] += reconstructed_data_1d[ t ];
			noisy_data_1d[ t ] = data_1d[ t ] + random();
		}

		cout << "Experiment No.  " << count << endl;
	}

	for( int t = 0; t < data_size_1d; ++t )
	{
		points_1d[ 2 ][ t ][ 1 ] /= (double) experiment_size;
		points_1d[ 3 ][ t ][ 1 ] = points_1d[ 2 ][ t ][ 1 ] - points_1d[ 0 ][ t ][ 1 ];
	}
}

void mainWindow::LoadSignal2D( func2d func, double u_min, double u_max, double v_min, double v_max )
{
	Clear();

	for( int i = 0; i < number_of_windows; ++i )
	{
		points_2d[ i ].setDim( data_size_2d, data_size_2d );
		knots_2d_u[ i ].setDim( data_size_2d + 4 );
		knots_2d_v[ i ].setDim( data_size_2d + 4 );

		int index = 0;
		for( int count = 0; count < bspline_degree; ++count, ++index )
		{
			knots_2d_u[ i ][ index ] = u_min + 0.5 * ( u_max - u_min ) / (long double) ( data_size_2d - bspline_degree + 1 );
			knots_2d_v[ i ][ index ] = v_min + 0.5 * ( v_max - v_min ) / (long double) ( data_size_2d - bspline_degree + 1 );
		}

		for( int t = 0; t < data_size_2d - bspline_degree + 1; ++t, ++index )
		{
			knots_2d_u[ i ][ index ] = u_min + ( t + 0.5 ) * ( u_max - u_min ) / (long double) ( data_size_2d - bspline_degree + 1 );
			knots_2d_v[ i ][ index ] = v_min + ( t + 0.5 ) * ( v_max - v_min ) / (long double) ( data_size_2d - bspline_degree + 1 );
		}

		for( int count = 0; count < bspline_degree; ++count, ++index )
		{
			knots_2d_u[ i ][ index ] = u_max - 0.5 * ( u_max - u_min ) / (long double) ( data_size_2d - bspline_degree + 1 );
			knots_2d_v[ i ][ index ] = v_max - 0.5 * ( v_max - v_min ) / (long double) ( data_size_2d - bspline_degree + 1 );
		}
	}

	double f_min = numeric_limits< double >::infinity();
	double f_max = - numeric_limits< double >::infinity();

	data_2d.setSize( DVector< int >( 2, data_size_2d ) );
	noisy_data_2d.setSize( DVector< int >( 2, data_size_2d ) );

	for( int u = 0; u < data_size_2d; ++u )
	{
		long double x = u_min + ( u + 0.5 ) * ( u_max - u_min ) / (long double) data_size_2d;

		for( int v = 0; v < data_size_2d; ++v )
		{
			long double y = v_min + ( v + 0.5 ) * ( v_max - v_min ) / (long double) data_size_2d;
			long double z = ( *func )( x, y );
			long double noisy_z = z + random();

			data_2d[ u ][ v ] = z;
			noisy_data_2d[ u ][ v ] = noisy_z;

			f_min = min( f_min, noisy_z );
			f_max = max( f_max, noisy_z );

			points_2d[ 0 ][ u ][ v ] = Point3D< float >( x, y, z );
			points_2d[ 1 ][ u ][ v ] = Point3D< float >( x, y, noisy_z );
			points_2d[ 2 ][ u ][ v ] = Point3D< float >( x, y, 0 );
			points_2d[ 3 ][ u ][ v ] = Point3D< float >( x, y, 0 );
		}
	}

	long_data_2d.setSize( DVector< int >( 2, long_data_size_2d ) );
	for( int u = 0; u < long_data_size_2d; ++u )
	{
		long double x = u_min + ( u + 0.5 ) * ( u_max - u_min ) / (long double) long_data_size_2d;

		for( int v = 0; v < long_data_size_2d; ++v )
		{
			long double y = v_min + ( v + 0.5 ) * ( v_max - v_min ) / (long double) long_data_size_2d;
			long double z = ( *func )( x, y );

			long_data_2d[ u ][ v ] = z;
		}
	}

	for( int i = 0; i < number_of_windows; ++i )
	{
		window[ i ] -> makeCurrent();
		window[ i ] -> reDraw();

		ox[ i ] = new MyLine< double, 3 >( Point3D< float >( u_min - 0.05, 0, 0 ), Point3D< float >( u_max + 0.05, 0, 0 ) );
		window[ i ] -> insert( ox[ i ] );

		oy[ i ] = new MyLine< double, 3 >( Point3D< float >( 0, v_min - 0.05, 0 ), Point3D< float >( 0, v_max + 0.05, 0 ) );
		window[ i ] -> insert( oy[ i ] );
		
		oz[ i ] = new MyLine< double, 3 >( Point3D< float >( 0, 0, f_min - 0.05 ), Point3D< float >( 0, 0, f_max + 0.05 ) );
		window[ i ] -> insert( oz[ i ] );
		
		window[ i ] -> update();
	}

	for( int i = 0; i < number_of_windows / 2; ++i )
	{
		window[ i ] -> makeCurrent();
		window[ i ] -> reDraw();

		mysurf[ i ] = new BSplineSurf< float, 3 >( points_2d[ i ], knots_2d_u[ i ], knots_2d_v[ i ], bspline_degree, bspline_degree );
		mysurf[ i ] -> setMaterial( Gold );
		mysurf[ i ] -> resetPlot( data_size_2d, data_size_2d, false );

		window[ i ] -> insertSun();
		window[ i ] -> insert( mysurf[ i ] );

		window[ i ] -> update();
	}

	Analyse2D();


	for( int i = number_of_windows / 2; i < number_of_windows; ++i )
	{
		window[ i ] -> makeCurrent();
		window[ i ] -> reDraw();

		mysurf[ i ] = new BSplineSurf< float, 3 >( points_2d[ i ], knots_2d_u[ i ], knots_2d_v[ i ], 3, 3 );
		mysurf[ i ] -> setMaterial( Gold );
		mysurf[ i ] -> resetPlot( data_size_2d, data_size_2d, false );

		window[ i ] -> insert( mysurf[ i ] );
		window[ i ] -> insertSun();

		window[ i ] -> update();
	}

	SetupCamera( 2, u_min, u_max, v_min, v_max, f_min, f_max, false );

	cout << "Number of zeros: " << zero_count << endl;
	cout << "Variance:    " << random.Variance() << endl;
	cout << "Expectation: " << random.Expectation() << endl;
	cout << "Minimum:     " << random.Minimum() << endl;
	cout << "Maximum:     " << random.Maximum() << endl;
}

void mainWindow::Analyse2D( bool update_points )
{
	Wave_lib::WaveDWTnD< long double, 2 > dwt( filter, 5.0 );

	Array< DArrayN< long double, 2 >* > c;
	Array< DVector< int >* > l;

	Array< DArrayN< long double, 2 >* > long_c;
	Array< DVector< int >* > long_l;
	
	Array< DArrayN< long double, 2 >* > psi_c;

	dwt.decomposition( data_2d, levels_2d, c, l );
	dwt.decomposition( long_data_2d, long_levels_2d, long_c, long_l );
	reconstructed_data_2d = dwt.reconstruction( c, l );

	v = std::vector< long double >( levels_2d + 1, 0.0 );
	zero_count = 0;

	long double a_j;
	long double b_jk;
	long double betha_jk;
	long double numer = 0.0;
	long double denom = 0.0;
	long double sum_of_psi_jk = 0.0;
	
	// Computing v_j
	int level_index = 0;
	switch( experiment_type )
	{
		case( Experiment_V ) :
		{
			long double left_v = 0.0;
			long double right_v = 0.001;

			psi_c = c;
			for( int j = 0; j <= levels_2d; ++j  )
			{
				for( int something = 0; something < ( ( j == 0 ) ? 1 : 3 ); ++something, ++level_index )
				{
					psi_c[ level_index ] = new DArrayN< long double, 2 >( *c[ level_index ] );
					for( int k1 = 0; k1 < ( *l[ j ] )[ 0 ]; ++k1 )
					{
						for( int k2 = 0; k2 < ( *l[ j ] )[ 1 ]; ++k2 )
						{
							( *psi_c[ level_index ] )[ k1 ][ k2 ] = 0.0;
						}
					}
				}
			}
			
			do
			{
				long double risk = 0.0;
				long double current_v = left_v + ( right_v - left_v ) / 2.0;
					
				long double left_risk = 0.0;
				long double right_risk = 0.0;
				
				long double left_quater_v = left_v + ( right_v - left_v ) / 4.0;
				long double left_quater_risk = 0.0;
				
				long double right_quater_v = left_v + 3 * ( right_v - left_v ) / 4.0;
				long double right_quater_risk = 0.0;

				level_index = 1;
				for( int j = 1; j <= levels_2d; ++j )
				{
					a_j = pow( 2.0, (double) ( 2 * ( j_1_2d - levels_2d + j - 1 ) * ( s - sigma ) ) );	

					for( int something = 0; something < 3; ++something, ++level_index )
					{
						for( int k1 = 0; k1 < ( *l[ j ] )[ 0 ]; ++k1 )
						{
							for( int k2 = 0; k2 < ( *l[ j ] )[ 1 ]; ++k2 )
							{
								sum_of_psi_jk = 0.0;
								( *psi_c[ level_index ] )[ k1 ][ k2 ] = 1.0;
								psi_jk_2d = dwt.reconstruction( psi_c, l );
								( *psi_c[ level_index ] )[ k1 ][ k2 ] = 0.0;	
	
								for( int x = 0; x < data_size_2d; ++x )
								{
									for( int y = 0; y < data_size_2d; ++y )
									{
										sum_of_psi_jk += psi_jk_2d[ x ][ y ] * psi_jk_2d[ x ][ y ];
									}	
								}

								b_jk = ( *c[ level_index ] )[ k1 ][ k2 ] - ( *long_c[ level_index ] )[ k1 ][ k2 ];
								betha_jk = ( *long_c[ level_index ] )[ k1 ][ k2 ];	

								risk += ( 1.0 / ( 1 + a_j * current_v ) ) * ( b_jk * b_jk 
																			 + ( random.Variance() / (long double) data_size_2d * data_size_2d ) * ( sum_of_psi_jk  / (long double) data_size_2d * data_size_2d ) 
																			 - 2 * a_j * current_v * b_jk * betha_jk
																			 + a_j * a_j * current_v * current_v * betha_jk * betha_jk );

								left_risk += ( 1.0 / ( 1 + a_j * left_v ) ) * ( b_jk * b_jk 
																			  + ( random.Variance() / (long double) data_size_2d * data_size_2d ) * ( sum_of_psi_jk  / (long double) data_size_2d * data_size_2d ) 
																			  - 2 * a_j * left_v * b_jk * betha_jk
																			  + a_j * a_j * left_v * left_v * betha_jk * betha_jk );

								right_risk += ( 1.0 / ( 1 + a_j * right_v ) ) * ( b_jk * b_jk 
																				+ ( random.Variance() / (long double) data_size_2d * data_size_2d ) * ( sum_of_psi_jk  / (long double) data_size_2d * data_size_2d ) 
																				- 2 * a_j * right_v * b_jk * betha_jk
																				+ a_j * a_j * right_v * right_v * betha_jk * betha_jk );

								left_quater_risk += ( 1.0 / ( 1 + a_j * left_quater_v ) ) * ( b_jk * b_jk 
																							+ ( random.Variance() / (long double) data_size_2d * data_size_2d ) * ( sum_of_psi_jk  / (long double) data_size_2d * data_size_2d ) 
																							- 2 * a_j * left_quater_v * b_jk * betha_jk
																							+ a_j * a_j * left_quater_v * left_quater_v * betha_jk * betha_jk );
	
								right_quater_risk += ( 1.0 / ( 1 + a_j * right_quater_v ) ) * ( b_jk * b_jk 
																							  + ( random.Variance() / (long double) data_size_2d * data_size_2d ) * ( sum_of_psi_jk  / (long double) data_size_2d * data_size_2d ) 
																							  - 2 * a_j * right_quater_v * b_jk * betha_jk
																							  + a_j * a_j * right_quater_v * right_quater_v * betha_jk * betha_jk );
							}
						}
					}
				}	
				
				if( left_risk > risk && risk > right_risk )
				{
					left_v = current_v;
					right_v = right_v * 2;			
				}
				else if( left_risk < risk && risk < right_risk )
				{
					right_v = current_v;
				}
				else
				{
					if( left_quater_risk < risk )
					{
						right_v = current_v;
					}else
					{
						if( right_quater_risk < risk )
						{
							left_v = current_v;
						}
						else
						{
							left_v = left_quater_v;
							right_v = right_quater_v;
						}
					}
				}
			}while( fabs( right_v - left_v ) > 1e-10 );
			
			v = std::vector< long double >( levels_1d + 1, left_v + ( right_v - left_v ) / 2.0 );
		}
			break;

		case( Experiment_V_j ) :
			psi_c = c;
			for( int j = 0; j <= levels_2d; ++j  )
			{
				for( int something = 0; something < ( ( j == 0 ) ? 1 : 3 ); ++something, ++level_index )
				{
					psi_c[ level_index ] = new DArrayN< long double, 2 >( *c[ level_index ] );
					for( int k1 = 0; k1 < ( *l[ j ] )[ 0 ]; ++k1 )
					{
						for( int k2 = 0; k2 < ( *l[ j ] )[ 1 ]; ++k2 )
						{
							( *psi_c[ level_index ] )[ k1 ][ k2 ] = 0.0;
						}
					}
				}
			}

			level_index = 1;
			for( int j = 1; j <= levels_2d; ++j )
			{
				numer = 0.0;
				denom = 0.0;
				a_j = pow( 2.0, (double) ( 2 * ( j_1_2d - levels_2d + j - 1 ) * ( s - sigma ) ) );	

				for( int something = 0; something < 3; ++something, ++level_index )
				{
					for( int k1 = 0; k1 < ( *l[ j ] )[ 0 ]; ++k1 )
					{
						for( int k2 = 0; k2 < ( *l[ j ] )[ 1 ]; ++k2 )
						{
							sum_of_psi_jk = 0.0;
							( *psi_c[ level_index ] )[ k1 ][ k2 ] = 1.0;
							psi_jk_2d = dwt.reconstruction( psi_c, l );
							( *psi_c[ level_index ] )[ k1 ][ k2 ] = 0.0;	

							for( int x = 0; x < data_size_2d; ++x )
							{
								for( int y = 0; y < data_size_2d; ++y )
								{
									sum_of_psi_jk += psi_jk_2d[ x ][ y ] * psi_jk_2d[ x ][ y ];
								}	
							}

							b_jk = ( *c[ level_index ] )[ k1 ][ k2 ] - ( *long_c[ level_index ] )[ k1 ][ k2 ];
							betha_jk = ( *long_c[ level_index ] )[ k1 ][ k2 ];	

							numer += b_jk * b_jk + b_jk * betha_jk + ( random.Variance() / (long double) ( data_size_2d * data_size_2d ) ) * ( sum_of_psi_jk  / (long double) ( data_size_2d * data_size_2d ) );
							denom += betha_jk * betha_jk + b_jk * betha_jk;
						}
					}
				}

				v[ j ] = numer / ( a_j * denom );
				if( v[ j ] <= 0.0 )
				{
					++zero_count;
					v[ j ] = 0.0;
				}
			}
			break;

		case( Experiment_Norm ) :
		case( Experiment_Norm_j ) :
			level_index = 1;
			for( int j = 1; j <= levels_2d; ++j )
			{
				if( p == 0.0 )
				{
					v[ j ] = 1.0;
					for( int something = 0; something < 3; ++something, ++level_index )
					{
						for( int k1 = 0; k1 < ( *l[ j ] )[ 0 ]; ++k1 )
						{
							for( int k2 = 0; k2 < ( *l[ j ] )[ 1 ]; ++k2 )
							{
								v[ j ] *= ( *c[ level_index ] )[ k1 ][ k2 ];
							}
						}
					}
					v[ j ] = pow( fabs( v[ j ] ), (long double) 1.0 / ( 3.0 * ( *l[ j ] )[ 0 ] * ( *l[ j ] )[ 1 ] ) );
				}
				else if( p == numeric_limits< double >::infinity() )
				{
					v[ j ] = ( *c[ j ] )[ 0 ][ 0 ];
					for( int something = 0; something < 3; ++something, ++level_index )
					{
						for( int k1 = 0; k1 < ( *l[ j ] )[ 0 ]; ++k1 )
						{
							for( int k2 = 0; k2 < ( *l[ j ] )[ 1 ]; ++k2 )
							{
								if( v[ j ] < ( *c[ level_index ] )[ k1 ][ k2 ] )
								{
									v[ j ] = ( *c[ level_index ] )[ k1 ][ k2 ];
								}
							}
						}
					}
				}
				else
				{
					v[ j ] = 0.0;
					for( int something = 0; something < 3; ++something, ++level_index )
					{
						for( int k1 = 0; k1 < ( *l[ j ] )[ 0 ]; ++k1 )
						{
							for( int k2 = 0; k2 < ( *l[ j ] )[ 1 ]; ++k2 )
							{
								v[ j ] += pow( fabs( ( *c[ level_index ] )[ k1 ][ k2 ] ), p );
							}
						}
					}
				}	
			}
			break;
	}

	// Reconstruction the signal
	for( int count = 0; count < experiment_size; ++count )
	{
		Array< DArrayN< long double, 2 >* > noisy_c;
		Array< DVector< int >* > noisy_l;
		dwt.decomposition( noisy_data_2d, levels_2d, noisy_c, noisy_l );
		std::vector< long double > actual_v = v;


		switch( experiment_type )
		{
			case( Experiment_V ) :
			case( Experiment_V_j ) :
				for( int j = 1; j <= levels_2d; ++j )
				{
					a_j = pow( 2.0, (double) ( 2 * (  j_1_2d - levels_2d + j - 1 ) * ( s - sigma ) ) );
					actual_v[ j ] = 1.0 / ( 1.0 + v[ j ] * a_j );
				}
				break;
			
			case( Experiment_Norm  ) :
				break;

			case( Experiment_Norm_j  ) :
				level_index = 1;
				for( int j = 1; j <= levels_2d; ++j )
				{
					double sum;
					if( p == 0.0 )
					{
						sum = 1.0;
						for( int something = 0; something < 3; ++something, ++level_index )
						{
							for( int k1 = 0; k1 < ( *l[ j ] )[ 0 ]; ++k1 )
							{
								for( int k2 = 0; k2 < ( *l[ j ] )[ 1 ]; ++k2 )
								{
									sum *= ( *noisy_c[ level_index ] )[ k1 ][ k2 ];
								}
							}
						}
						sum = pow( fabs( sum ), 1.0 / ( 3.0 * ( *noisy_l[ j ] )[ 0 ] * ( *noisy_l[ j ] )[ 1 ] ) );	
				
						if( sum != 0.0 )
						{
							actual_v[ j ] = v[ j ] / sum;
						}
					}
					else if( p == numeric_limits< double >::infinity() )
					{
						sum = fabs( ( *noisy_c[ level_index ] )[ 0 ][ 0 ] );
						for( int something = 0; something < 3; ++something, ++level_index )
						{
							for( int k1 = 0; k1 < ( *l[ j ] )[ 0 ]; ++k1 )
							{
								for( int k2 = 0; k2 < ( *l[ j ] )[ 1 ]; ++k2 )
								{
									if( sum < fabs( ( *noisy_c[ level_index ] )[ k1 ][ k2 ] ) )
									{
										sum = fabs( ( *noisy_c[ level_index ] )[ k1 ][ k2 ] );
									}
								}
							}
						}
	
						if( sum != 0.0 )
						{
							actual_v[ j ] = v[ j ] / sum;
						}
					}
					else
					{
						sum = 0.0;
						for( int something = 0; something < 3; ++something, ++level_index )
						{
							for( int k1 = 0; k1 < ( *l[ j ] )[ 0 ]; ++k1 )
							{
								for( int k2 = 0; k2 < ( *l[ j ] )[ 1 ]; ++k2 )
								{
									sum += pow( fabs( ( *noisy_c[ level_index ] )[ k1 ][ k2 ] ), (long double) p );
								}
							}
						}
						
						actual_v[ j ] = pow( v[ j ] / sum, (long double) 1.0 / p );
					}
				}
				break;
		}

		level_index = 1;
		for( int j = 1; j <= levels_2d; ++j )
		{
			for( int something = 0; something < 3; ++something, ++level_index )
			{
				for( int k1 = 0; k1 < ( *l[ j ] )[ 0 ]; ++k1 )
				{
					for( int k2 = 0; k2 < ( *l[ j ] )[ 1 ]; ++k2 )
					{
						( ( *noisy_c[ level_index ] )[ k1 ][ k2 ] ) *= actual_v[ j ];
					}
				}
			}
		}

		reconstructed_data_2d = dwt.reconstruction( noisy_c, noisy_l );
	
		for( int u = 0; u < data_size_2d; ++u )
		{
			for( int v = 0; v < data_size_2d; ++v )
			{
				if( update_points )
				{
					points_2d[ 2 ][ u ][ v ][ 2 ] += reconstructed_data_2d[ u ][ v ];
				}
				noisy_data_2d[ u ][ v ] = data_2d[ u ][ v ] + random();
			}
		}

		cout << "Experiment No.  " << count << endl;
	}
	if( update_points )
	{
		for( int u = 0; u < data_size_2d; ++u )
		{
			for( int v = 0; v < data_size_2d; ++v )
			{
				points_2d[ 2 ][ u ][ v ][ 2 ] /= (double) experiment_size;
				points_2d[ 3 ][ u ][ v ][ 2 ] = points_2d[ 2 ][ u ][ v ][ 2 ] - points_2d[ 0 ][ u ][ v ][ 2 ];
			}
		}
	}
}	




void mainWindow::LoadImage( std::string filename )
{
	Clear();

	for( int i = 0; i < number_of_windows; ++i )
	{
		image[ i ].load( filename );
	}
	
	AnalyzeImage();

	int old_data_size_2d = data_size_2d;
	data_size_2d = 5;

	double u_min = 0.0;
	double u_max = 1.0;
	double v_min = 0.0;
	double v_max = 1.0;

	
	for( int i = 0; i < number_of_windows; ++i )
	{
		points_2d[ i ].setDim( data_size_2d, data_size_2d );
		knots_2d_u[ i ].setDim( data_size_2d + bspline_degree + 1);
		knots_2d_v[ i ].setDim( data_size_2d + bspline_degree + 1 );

		int index = 0;
		for( int count = 0; count < bspline_degree; ++count, ++index )
		{
			knots_2d_u[ i ][ index ] = u_min + 0.5 * ( u_max - u_min ) / (long double) ( data_size_2d - bspline_degree + 1 );
			knots_2d_v[ i ][ index ] = v_min + 0.5 * ( v_max - v_min ) / (long double) ( data_size_2d - bspline_degree + 1 );
		}

		for( int t = 0; t < data_size_2d - bspline_degree + 1; ++t, ++index )
		{
			knots_2d_u[ i ][ index ] = u_min + ( t + 0.5 ) * ( u_max - u_min ) / (long double) ( data_size_2d - bspline_degree + 1 );
			knots_2d_v[ i ][ index ] = v_min + ( t + 0.5 ) * ( v_max - v_min ) / (long double) ( data_size_2d - bspline_degree + 1 );
		}

		for( int count = 0; count < bspline_degree; ++count, ++index )
		{
			knots_2d_u[ i ][ index ] = u_max - 0.5 * ( u_max - u_min ) / (long double) ( data_size_2d - bspline_degree + 1 );
			knots_2d_v[ i ][ index ] = v_max - 0.5 * ( v_max - v_min ) / (long double) ( data_size_2d - bspline_degree + 1 );
		}
	}

	for( int u = 0; u < data_size_2d; ++u )
	{
		long double x = u_min + ( u + 0.5 ) * ( u_max - u_min ) / (long double) data_size_2d;

		for( int v = 0; v < data_size_2d; ++v )
		{
			long double y = v_min + ( v + 0.5 ) * ( v_max - v_min ) / (long double) data_size_2d;

			points_2d[ 0 ][ u ][ v ] = Point3D< float >( x, y, 0 );
			points_2d[ 1 ][ u ][ v ] = Point3D< float >( x, y, 0 );
			points_2d[ 2 ][ u ][ v ] = Point3D< float >( x, y, 0 );
			points_2d[ 3 ][ u ][ v ] = Point3D< float >( x, y, 0 );
		}
	}

	data_size_2d = old_data_size_2d;

	for( int i = 0; i < number_of_windows; ++i )
	{
		window[ i ] -> makeCurrent();
		window[ i ] -> reDraw();

		Material mx = Snow;
		Texture tx;
//		uint itx = tx.LoadGL( filename.c_str() );
//		QImage converted_image = QGLWidget::convertToGLFormat( image[ i ] );
		uint itx = tx.LoadGL( &image[ i ] );
		mx.set( itx );
		
   /*     uint txid;
		glGenTextures(1,&txid);
		glBindTexture( GL_TEXTURE_2D, txid );
		QImage mytx=QGLWidget::convertToGLFormat(image[i]);

		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );

		glTexImage2D( GL_TEXTURE_2D, 0, GL_RGBA, mytx.width(), mytx.height(), 0, GL_RGBA, GL_UNSIGNED_BYTE, mytx.bits() );
		mx.set( txid ); //*/

		mysurf[ i ] = new BSplineSurf< float, 3 >( points_2d[ i ], knots_2d_u[ i ], knots_2d_v[ i ], bspline_degree, bspline_degree );
		mysurf[ i ] -> resetPlot( data_size_2d, data_size_2d, true );
		mysurf[ i ] -> setMaterial( mx );
		mysurf[ i ] -> resetPlot( 0, 0, true );

		window[ i ]->insert( mysurf[ i ] );
		window[ i ]->insertSun();

		window[ i ] -> update();
	}

	SetupCamera( 1, u_min, u_max, v_min, v_max, 0, 0, false );
}

void mainWindow::AnalyzeImage()
{
	int old_data_size_2d = data_size_2d;
	int old_long_data_size_2d = long_data_size_2d;

	Random old_random = random;
	random = Random( -48, 48, 0 );

	data_size_2d = image[ 0 ].width();
	data_2d.setSize( DVector< int >( 2, data_size_2d ) );
	long_data_2d.setSize( DVector< int >( 2, data_size_2d ) );
	noisy_data_2d.setSize( DVector< int >( 2, data_size_2d ) );

	QRgb color;
	QRgb noisy_color;
	QRgb reconstructed_color;
	QRgb error_color;
	long double value;
	long double noisy_value;
	long double reconstructed_value;

	//Red
	for( int x = 0; x < image[ 0 ].width(); ++x )
	{	
		for( int y = 0; y < image[ 0 ].height(); ++y )
		{
			color = image[ 0 ].pixel( x, y );

			value = qRed( color );
			noisy_value = min( 255, max( 0, value + random() ) );

			data_2d[ x ][ y ] = value;
			long_data_2d[ x ][ y ] = value;
			noisy_data_2d[ x ][ y ] = noisy_value;
		}
	}
	
	Analyse2D( false );

	for( int x = 0; x < image[ 0 ].width(); ++x )
	{	
		for( int y = 0; y < image[ 0 ].height(); ++y )
		{
			color = image[ 0 ].pixel( x, y );
			noisy_color = image[ 1 ].pixel( x, y );
			reconstructed_color = image[ 2 ].pixel( x, y );
			error_color = image[ 3 ].pixel( x, y );
	
			value = qRed( color );
			reconstructed_value = min( 255, max( 0, reconstructed_data_2d[ x ][ y ] ) );

			image[ 1 ].setPixel( x, y, qRgb( noisy_data_2d[ x ][ y ], qGreen( noisy_color ), qBlue( noisy_color ) ) );
			image[ 2 ].setPixel( x, y, qRgb( reconstructed_value, qGreen( reconstructed_color ), qBlue( reconstructed_color ) ) );
			image[ 3 ].setPixel( x, y, qRgb( abs( value - reconstructed_value ), qGreen( error_color ), qBlue( error_color ) ) );
		}
	}

	//Green
	for( int x = 0; x < image[ 0 ].width(); ++x )
	{	
		for( int y = 0; y < image[ 0 ].height(); ++y )
		{
			color = image[ 0 ].pixel( x, y );

			value = qGreen( color );
			noisy_value = min( 255, max( 0, value + random() ) );

			data_2d[ x ][ y ] = value;
			long_data_2d[ x ][ y ] = value;
			noisy_data_2d[ x ][ y ] = noisy_value;
		}
	}
	
	Analyse2D( false );

	for( int x = 0; x < image[ 0 ].width(); ++x )
	{	
		for( int y = 0; y < image[ 0 ].height(); ++y )
		{
			color = image[ 0 ].pixel( x, y );
			noisy_color = image[ 1 ].pixel( x, y );
			reconstructed_color = image[ 2 ].pixel( x, y );
			error_color = image[ 3 ].pixel( x, y );
	
			value = qGreen( color );
			reconstructed_value = min( 255, max( 0, reconstructed_data_2d[ x ][ y ] ) );

			image[ 1 ].setPixel( x, y, qRgb( qRed( noisy_color ), noisy_data_2d[ x ][ y ], qBlue( noisy_color ) ) );
			image[ 2 ].setPixel( x, y, qRgb( qRed( reconstructed_color ), reconstructed_value, qBlue( reconstructed_color ) ) );
			image[ 3 ].setPixel( x, y, qRgb( qRed( error_color ), abs( value - reconstructed_value ), qBlue( error_color ) ) );
		}
	}

	//Blue
	for( int x = 0; x < image[ 0 ].width(); ++x )
	{	
		for( int y = 0; y < image[ 0 ].height(); ++y )
		{
			color = image[ 0 ].pixel( x, y );

			value = qBlue( color );
			noisy_value = min( 255, max( 0, value + random() ) );

			data_2d[ x ][ y ] = value;
			long_data_2d[ x ][ y ] = value;
			noisy_data_2d[ x ][ y ] = noisy_value;
		}
	}
	
	Analyse2D( false );

	for( int x = 0; x < image[ 0 ].width(); ++x )
	{	
		for( int y = 0; y < image[ 0 ].height(); ++y )
		{
			color = image[ 0 ].pixel( x, y );
			noisy_color = image[ 1 ].pixel( x, y );
			reconstructed_color = image[ 2 ].pixel( x, y );
			error_color = image[ 3 ].pixel( x, y );
	
			value = qBlue( color );
			reconstructed_value = min( 255, max( 0, reconstructed_data_2d[ x ][ y ] ) );

			image[ 1 ].setPixel( x, y, qRgb( qRed( noisy_color ), qGreen( noisy_color ), noisy_data_2d[ x ][ y ] ) );
			image[ 2 ].setPixel( x, y, qRgb( qRed( reconstructed_color ), qGreen( reconstructed_color ), reconstructed_value ) );
			image[ 3 ].setPixel( x, y, qRgb( qRed( error_color ), qGreen( error_color ), abs( value - reconstructed_value ) ) );
		}
	}

	data_size_2d = old_data_size_2d;
	long_data_size_2d = old_long_data_size_2d;

	random = old_random;
}

void mainWindow::gM_QtWindow5_isActive()
{
	active_window = 0;
	Redraw();
}


void mainWindow::gM_QtWindow6_isActive()
{
	active_window = 1;
	Redraw();
}


void mainWindow::gM_QtWindow7_isActive()
{
	active_window = 2;
	Redraw();
}


void mainWindow::gM_QtWindow8_isActive()
{
	active_window = 3;
	Redraw();
}

void mainWindow::gM_QtWindow5_dblClicked()
{
	active_window = 0;
	ResizeToFullscreen();
}

void mainWindow::gM_QtWindow6_dblClicked()
{
	active_window = 1;
	ResizeToFullscreen();
}

void mainWindow::gM_QtWindow7_dblClicked()
{
	active_window = 2;
	ResizeToFullscreen();
}

void mainWindow::gM_QtWindow8_dblClicked()
{
	active_window = 3;
	ResizeToFullscreen();
}

void mainWindow::Redraw()
{
	for( int i = 0; i < number_of_windows; ++i )
	{
		window[ i ] -> makeCurrent();
		window[ i ] -> reDraw();
	}

	window[ active_window ] -> makeCurrent();
}



void mainWindow::ResizeToFullscreen()
{
	if( is_fullscreen )
	{
		for( int i = 0; i < number_of_windows; ++i )
		{	
			window[ i ] -> show();
		}
	}
	else
	{
		for( int i = 0; i < number_of_windows; ++i )
		{	
			if( i != active_window )
				window[ i ] -> hide();
		}
	}
		
	is_fullscreen = !is_fullscreen;
	Redraw();
}






long double LambdaTear( long double t )
{
	long double result = 0.0;
	if( 0.0 < t && t < 1.0 )
	{
		result = pow( t, lambda ) * exp( - t * t / ( 1 - t * t ) );
	}

	return result;
}

long double LambdaTearXLambdaTear( long double u, long double v )
{
	long double result = 0.0;
	if( ( 0.0 < u && u < 1.0 ) && ( 0.0 < v && v < 1.0 ) )
	{
		result = pow( u, lambda ) * exp( - u * u / ( 1 - u * u ) ) * pow( v, lambda ) * exp( - v * v / ( 1 - v * v ) );
	}
	return result;
}

long double Random1D( long double t )
{
	static Random random_function( 1.0 );
	long double result = random_function();
	return result;
}

long double Random2D( long double u, long double v )
{
	static Random random_function( 1.0 );
	long double result = random_function();
	return result;
}


long double FileData1D( long double t )
{
	int index = (int) ( ( t - min_t_1d ) * long_data_size_1d / (long double) ( max_t_1d - min_t_1d ) );
	index = max( min( index, long_data_size_1d ), 0 );

	return file_data_1d[ index ];
}

long double FileData2D( long double u, long double v )
{
	int index_u = (int) ( ( u - min_u_2d ) * long_data_size_2d / (long double) ( max_u_2d - min_u_2d ) );
	index_u = max( 0, min( index_u, long_data_size_2d ) );

	int index_v = (int) ( ( v - min_v_2d ) * long_data_size_2d / (long double) ( max_v_2d - min_v_2d ) );
	index_v = max( 0, min( index_v, long_data_size_2d ) );

	return file_data_2d[ index_u ][ index_v ];
}
