/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
#include <qfiledialog.h>
#include <qinputdialog.h>
#include <qcolordialog.h>
#include <qpixmap.h> 
#include <GM_DisplayObject.h>
#include <GM_PointLight_G.h>
#include <GM_Torus.h>
#include <GM_Texture.h>
#include <GM_Window.h>
#include <mainWindow.h>
	
void MaterialSelect::destroy()
{
	 gM_QtWindow2->doneCurrent();
}
void MaterialSelect::init()
{
    txid=0;
	current=Brass;
	Material_list->clear();
	Material_list->insertItem( tr( "Brass" ) );
	Material_list->insertItem( tr( "Bronze" ) );
	Material_list->insertItem( tr( "PolishedBronze" ) );
	Material_list->insertItem( tr( "Chrome" ) );
	Material_list->insertItem( tr( "Copper" ) );
	Material_list->insertItem( tr( "PolishedCopper" ) );
	Material_list->insertItem( tr( "Gold" ) );
	Material_list->insertItem( tr( "PolishedGold" ) );
	Material_list->insertItem( tr( "Pewter" ) );
	Material_list->insertItem( tr( "Silver" ) );
	Material_list->insertItem( tr( "PolishedSilver" ) );
	Material_list->insertItem( tr( "Emerald" ) );
	Material_list->insertItem( tr( "Jader" ) );
	Material_list->insertItem( tr( "Obsidian" ) );
	Material_list->insertItem( tr( "Pearl" ) );
	Material_list->insertItem( tr( "Ruby" ) );
	Material_list->insertItem( tr( "Turquoise" ) );
	Material_list->insertItem( tr( "BlackPlastic" ) );
	Material_list->insertItem( tr( "BlackRubber" ) );
	Material_list->insertItem( tr( "Snow" ) );
	diff=QColor(0.780392*255, 0.568627*255, 0.113725*255);
	amb=QColor(0.329412*255, 0.223529*255, 0.027451*255);
	spec=QColor(0.992157*255, 0.941176*255, 0.807843*255);
	mlist.alwaysInsert(Brass);		
	mlist.alwaysInsert(Bronze);			
	mlist.alwaysInsert(PolishedBronze);
	mlist.alwaysInsert(Chrome);	
	mlist.alwaysInsert(Copper);			
	mlist.alwaysInsert(PolishedCopper);
	mlist.alwaysInsert(Gold);
	mlist.alwaysInsert(PolishedGold);
	mlist.alwaysInsert(Pewter);
	mlist.alwaysInsert(Silver);			
	mlist.alwaysInsert(PolishedSilver);
	mlist.alwaysInsert(Emerald);
	mlist.alwaysInsert(Jade);	
	mlist.alwaysInsert(Obsidian);
	mlist.alwaysInsert(Pearl);	
	mlist.alwaysInsert(Ruby);			
	mlist.alwaysInsert(Turquoise);
	mlist.alwaysInsert(BlackPlastic);
	mlist.alwaysInsert(BlackRubber);
	mlist.alwaysInsert(Snow);


	//  if(_activegmw) delete _activegmw;	//If I have a active gmwindow delete it
	gM_QtWindow2->makeCurrent();
	_activegmw = new GM_Window();		//Create a new gmwindow
	_activegmw->reset();				//The new gmwindow need to be reset so it will find the size of GM_QtWindow
	Camera* cam;
	Point3D<GLfloat>  pos1(0,0,25);
	Point3D<GLfloat>  tar1(0,0,0);
	Vector3D<GLfloat> up1(0,1,0);
	_activegmw->insertCamera(cam=new Camera(pos1, tar1-pos1, up1));
	_activegmw->setActiv(1);
	_activegmw->insertLight(new PointLight_G(White, White, White, Point3D<GLfloat>(30,0,10)), true);
	_activegmw->insertLight(new PointLight_G(White, White, White, Point3D<GLfloat>(0,30,10)), true);
	// PSurf<float,3>* tmp;
	previewTorus=new Torus<float,3>(3.0,2.0,1.0); 
	previewTorus->setMaterial(mlist(0));
	previewTorus->resetPlot(32,32,true);
	_activegmw->insert(previewTorus);
	(*gM_QtWindow2) = (*_activegmw);	
}



void MaterialSelect::setCurrent(int m )
{
  current=mlist(m);
 if(!TextureFileName->text().contains("No Texture")) 
  {
      Texture tx(false);
      txid=tx.LoadGLSphereMap(TextureFileName->text().latin1());
      current.set(txid);
  }  
  previewTorus->setMaterial(current);
  previewTorus->resetPlot(32,32,true);
  gM_QtWindow2->makeCurrent();
  gM_QtWindow2->update();
}


void MaterialSelect::Browse_clicked()
{
   currentTexture = QFileDialog::getOpenFileName(
                    ".",
                    "Images (*.png *.xpm *.jpg *.bmp)",
                    this,
                    "open file dialog"
                    "Choose a Texture" );
   TextureFileName->setText(currentTexture);
   setCurrent(5);
}

uint MaterialSelect::getTexture()
{
    return txid;
}
