#pragma once

#include <GM_LA_DisplayObject.h>
#include <GM_Material.h>


namespace GM_lib {

class GO_Strip
{
	Arrow<float,3>  p[48];
	int k;
public:
	GO_Strip() {}

	GO_Strip(const Arrow<float,3>&a, const Arrow<float,3>& b, double r)
	{
		int i;
		Vector3D<float> n(0,0,1);
		Vector3D<float> v = n^a.dir();
		k = 48; p[0] = a; p[3] = b;
		for(i=1;i<42; i+=4) p[i] = a;
		for(i=2;i<43; i+=4) p[i] = b;
		p[0].setDir(UnitVector<float,3>(v-4*n));	p[45] = p[0] += ((0.75*r)*v-(0.5*r)*n);	
		p[1].setDir(UnitVector<float,3>(v-n));		p[4]  = p[1] += (r*v-(0.25*r)*n);		p[4].setDir(UnitVector<float,3>(v));
		p[5].setDir(UnitVector<float,3>(v));		p[8]  = p[5] += (r*v+(0.25*r)*n);		p[8].setDir(UnitVector<float,3>(v+n));
		p[9].setDir(UnitVector<float,3>(v+4*n));	p[12] = p[9] += ((0.75*r)*v+(0.5*r)*n);
		p[13].setDir(UnitVector<float,3>(v+4*n));	p[16] = p[13]+= ((0.25*r)*v+(0.55*r)*n);p[16].setDir(UnitVector<float,3>(n));
		p[17].setDir(UnitVector<float,3>(n));		p[20] = p[17]-= ((0.25*r)*v-(0.55*r)*n);p[20].setDir(UnitVector<float,3>(4*n-v));
		p[21].setDir(UnitVector<float,3>(4*n-v));	p[24] = p[21]-= ((0.75*r)*v-(0.5*r)*n);
		p[25].setDir(UnitVector<float,3>(n-v));		p[28] = p[25]-= (r*v-(0.25*r)*n);		p[28].setDir(UnitVector<float,3>(-v));
		p[29].setDir(UnitVector<float,3>(-v));		p[32] = p[29]-= (r*v+(0.25*r)*n);		p[32].setDir(UnitVector<float,3>(-n-v));
		p[33].setDir(UnitVector<float,3>(-4*n-v));	p[36] = p[33]-= ((0.75*r)*v+(0.5*r)*n);
		p[37].setDir(UnitVector<float,3>(-4*n-v));	p[40] = p[37]-= ((0.25*r)*v+(0.55*r)*n);p[40].setDir(UnitVector<float,3>(-n));
		p[41].setDir(UnitVector<float,3>(-n));		p[44] = p[41]+=((0.25*r)*v-(0.55*r)*n);	p[44].setDir(UnitVector<float,3>(v-4*n));
		v = n^b.dir();
		p[3].setDir(UnitVector<float,3>(v-4*n));	p[46] = p[3]+=((0.75*r)*v-(0.5*r)*n); 
		p[2].setDir(UnitVector<float,3>(v-n));		p[7]  = p[2] +=(r*v-(0.25*r)*n);		p[7].setDir(UnitVector<float,3>(v));
		p[6].setDir(UnitVector<float,3>(v));		p[11] = p[6] +=(r*v+(0.25*r)*n);		p[11].setDir(UnitVector<float,3>(v+n));
		p[10].setDir(UnitVector<float,3>(v+4*n));	p[15] = p[10] +=((0.75*r)*v+(0.5*r)*n);	
		p[14].setDir(UnitVector<float,3>(v+4*n));	p[19] = p[14] +=((0.25*r)*v+(0.55*r)*n);p[19].setDir(UnitVector<float,3>(n));
		p[18].setDir(UnitVector<float,3>(n));		p[23] = p[18]-=((0.25*r)*v-(0.55*r)*n);	p[23].setDir(UnitVector<float,3>(4*n-v));
		p[22].setDir(UnitVector<float,3>(4*n-v));	p[27] = p[22]-=((0.75*r)*v-(0.5*r)*n); 
		p[26].setDir(UnitVector<float,3>(n-v));		p[31] = p[26]-=(r*v-(0.25*r)*n);		p[31].setDir(UnitVector<float,3>(-v));
		p[30].setDir(UnitVector<float,3>(-v));		p[35] = p[30]-=(r*v+(0.25*r)*n);		p[35].setDir(UnitVector<float,3>(-n-v));
		p[34].setDir(UnitVector<float,3>(-4*n-v));	p[39] = p[34]-=((0.75*r)*v+(0.5*r)*n);
		p[38].setDir(UnitVector<float,3>(-4*n-v));	p[43] = p[38]-=((0.25*r)*v+(0.55*r)*n);	p[43].setDir(UnitVector<float,3>(-n));
		p[42].setDir(UnitVector<float,3>(-n));		p[47] = p[42]+=((0.25*r)*v-(0.55*r)*n);	p[47].setDir(UnitVector<float,3>(v-4*n));
	}

	GO_Strip(const Arrow<float,3>&a, double r)
	{
		Vector3D<float> n(0,0,1);
		Vector3D<float> v = n^a.dir();
		k = 14;
		for(int i=0;i<13; i++) p[i] = a;
		p[1] += (0.75*r)*v-(0.5*r)*n;  p[2] += r*v-(0.25*r)*n;       p[3] += r*v+(0.25*r)*n; p[4] += (0.75*r)*v+(0.5*r)*n;	
		p[5] += (0.25*r)*v+(0.55*r)*n; p[6] -= (0.25*r)*v-(0.55*r)*n;	
		p[7] -= (0.75*r)*v-(0.5*r)*n;  p[8] -= r*v-(0.25*r)*n;       p[9] -= r*v+(0.25*r)*n; p[10]-= (0.75*r)*v+(0.5*r)*n;
		p[11]-= (0.25*r)*v+(0.55*r)*n; p[12]+= (0.25*r)*v-(0.55*r)*n;
		p[13] = p[1];
	}

	void display()
	{
		if(k==48)	glBegin(GL_QUADS);
		else		glBegin(GL_TRIANGLE_FAN);
		for(int i=0; i<k; i++) glVertex(p[i]);
		glEnd();
	}

	void select()
	{
		if(k==48)	glBegin(GL_QUADS);
		else		glBegin(GL_TRIANGLE_FAN);
		for(int i=0; i<k; i++) glPoint(p[i].pos());
		glEnd();
	}

	GO_Strip& operator*=(const GL_Matrix& m)
	{
		for(int i=0; i<k; i++) p[i] *= m;
		return *this;
	}

	bool operator<(const GO_Strip&)const  { return true; }
};



class Text3D: public LA_DisplayObject
{ 
	GLuint		_display_list;
	Material	_material;

	Vector<float,3> _size;

	Arrow<float,3> eval1deg(const Point<float,3>& p1,const Point<float,3>& p2, double t,
		bool start=false, bool end=false, UnitVector3D<float> s=Vector3D<float>(0,1,0), UnitVector3D<float> e=Vector3D<float>(0,1,0)) 
	{
		Point<float,3>  p= (1-t)*p1+t*p2; 
		UnitVector<float,3> v= p2-p1;
		if(start && end) v=(1-t)*s+t*e;	// NB! only case where both are used, strange defaults
		else if(start)	v=(1-t)*s+t*v;
		else if(end)    v=(1-t)*v+t*s;
		return Arrow<float,3>(p,v);
	}

	Arrow<float,3> eval1_1deg(const Point<float,3>& p1,const Point<float,3>& p2, double t,
		bool start=false, bool end=false, UnitVector3D<float> s=Vector3D<float>(0,1,0), UnitVector3D<float> e=Vector3D<float>(0,1,0)) 
	{
		Point<float,3>  p= (1-t)*p1+t*p2; 
		UnitVector<float,3> v= p2-p1;
		Vector<float,3> u=v;
		float st,ed;
		if(start)	st = (1-t)*(s*v);
		else		st = 1-t;
		if(end)		ed = t*(e*v);
		else		ed = t;
		if(start && end) {v=(1-t)*s+t*e; u = ((st+ed)/(u*v))*v; }
		else if(start)	 {v=(1-t)*s+t*v; u = ((st+ed)/(u*v))*v; }
		else if(end)     {v=(1-t)*v+t*s; u = ((st+ed)/(u*v))*v; }
		return Arrow<float,3>(p,u);
	}




	Arrow<float,3> eval1_2deg(const Point<float,3>& p1,const Point<float,3>& p2, double t,
		bool start=false, bool end=false, UnitVector3D<float> s=Vector3D<float>(0,1,0), UnitVector3D<float> e=Vector3D<float>(0,1,0)) 
	{
		Point<float,3>  p= (1-t)*p1+t*p2; 
		Vector<float,3> b= UnitVector3D<float>(p2-p1);
		UnitVector<float,3> v;
		if(start && end){ v=(1-t)*s+t*e; b=v/(v*b);}	// NB! only case where both are used, strange defaults
		else if(start)	{ v=(1-t)*s+t*b; b=v/(v*b);}	//error
		else if(end)    { v=(1-t)*b+t*s; b=v/(v*b);}
		return Arrow<float,3>(p,b);
	}

	Arrow<float,3> eval2deg(const Point<float,3>& p1,const Point<float,3>& p2,const Point<float,3>& p3, double t,
		bool start=false, bool end=false, UnitVector3D<float> s=Vector3D<float>(0,1,0), UnitVector3D<float> e=Vector3D<float>(0,1,0)) 
	{
		double t1 = 1-t;
		double t2 = 2*t1*t;
		Point<float,3>  p= t1*t1*p1+t2*p2+t*t*p3;
		Vector<float,3> b= UnitVector3D<float>((-2*t1)*p1+(2-4*t)*p2+(2*t)*p3);
		UnitVector3D<float> v;
		if(start && end){ v=t1*s+t*e; b=v/(v*b);}
		else if(start)	{ v=t1*s+t*b; b=v/(v*b);}	//error
		else if(end)    { v=t1*b+t*s; b=v/(v*b);}
		return Arrow<float,3>(p,b);
	}


	Arrow<float,3> eval2_2deg(double dn, const Point<float,3>& p1,const Point<float,3>& p2,const Point<float,3>& p3, double t,
		bool start=false, bool end=false, UnitVector3D<float> s=Vector3D<float>(0,1,0), UnitVector3D<float> e=Vector3D<float>(0,1,0)) 
	{
		double t1  = 1-t;
		double t11 = pow(t,dn);
		double t12 = 1-t11;
		double t2  = 2*t1*t;
		Point<float,3>  p = t1*t1*p1+t2*p2+t*t*p3;
		Vector<float,3> b = UnitVector3D<float>((-2*t1)*p1+(2-4*t)*p2+(2*t)*p3);
		UnitVector3D<float> v;
		if(start && end){ v=t12*s+t11*e; b=v/(v*b);}
		else if(start)	{ v=t12*s+t11*b; b=v/(v*b);}	//error
		else if(end)    { v=t12*b+t11*s; b=v/(v*b);}
		return Arrow<float,3>(p,b);
	}

	Arrow<float,3> eval2_22deg(double dn, const Point<float,3>& p1,const Point<float,3>& p2,const Point<float,3>& p3, double t,
		bool start=false, bool end=false, UnitVector3D<float> s=Vector3D<float>(0,1,0), UnitVector3D<float> e=Vector3D<float>(0,1,0)) 
	{
		double t1  = 1-t;
		double t11 = pow(t,dn);
		double t12 = 1-t11;
		double t2  = 2*t1*t;
		Point<float,3>  p= t1*t1*p1+t2*p2+t*t*p3;
		Vector<float,3> b= UnitVector3D<float>((-2*t1)*p1+(2-4*t)*p2+(2*t)*p3);
		UnitVector3D<float> v;
		if(start && end){ v=t12*s+t11*e; b=v;}
		else if(start)	{ v=t12*s+t11*b; b=v;}	//error
		else if(end)    { v=t12*b+t11*s; b=v;}
		return Arrow<float,3>(p,b);
	}
	
	Arrow<float,3> eval2_2Mdeg(double dn, const Point<float,3>& p1,const Point<float,3>& p2,const Point<float,3>& p3, double t,
								UnitVector3D<float> s, UnitVector3D<float> e)
	{
		double t1 = 1-t;
		double t11;
		if (t<0.5) t11=pow(2*t,dn);
		else	   t11=pow(2-2*t,dn);
		double t12=1-t11;
		double t2 = 2*t1*t;
		Point<float,3>  p= t1*t1*p1+t2*p2+t*t*p3;
		Vector<float,3> b= UnitVector3D<float>((-2*t1)*p1+(2-4*t)*p2+(2*t)*p3);
		Vector<float,3> bn= UnitVector3D<float>(p3-p1);
		UnitVector3D<float> v;
		if(t<0.5)	{v=t12*s+t11*bn; b=v/(v*b);}
		else		{v=t11*bn+t12*e; b=v/(v*b);}
		return Arrow<float,3>(p,b);
	}


	Arrow<float,3> eval2_1deg(const Point<float,3>& p1,const Point<float,3>& p2,const Point<float,3>& p3, double t,
		bool start=false, bool end=false, UnitVector3D<float> s=Vector3D<float>(0,1,0), UnitVector3D<float> e=Vector3D<float>(0,1,0)) 
	{
		double t1 = 1-t;
		double t2 = 2*t1*t;
		Point<float,3>  p= t1*t1*p1+t2*p2+t*t*p3;
		Vector<float,3> b= UnitVector3D<float>((-2*t1)*p1+(2-4*t)*p2+(2*t)*p3);
		return Arrow<float,3>(p,b);
	}


	void localDisplay()
	{
		_material.glSet();
		glCallList(_display_list);
	}

	void localSelect()
	{
		glCallList(_display_list+1);
	}

	void localSimulate(double dt)
	{ 
		if(_object.size()>0) _object[0]->rotate(Angle(dt*M_PI),Point3D<float>(10,2.5,1.5),Vector3D<float>(0.2,1,0));
	}

public:
	Text3D(char* txt, double k=0.0, double r=0.35, int res=32):LA_DisplayObject()
	{ 
		int i,size=10;
		GL_Matrix m;
		for(i=0; txt[i] != 0; i++)
			switch(txt[i])
			{
			case 'A': size += size_A(); break;
			case 'B': size += size_B(); break;
			case 'C': size += size_C(); break;
			case 'D': size += size_D(); break;
			case 'E': size += size_E(); break;
			case 'F': size += size_F(); break;
			case 'G': size += size_G(); break;
			case 'H': size += size_H(); break;
			case 'I': size += size_l(); break;
			case 'J': size += size_J(); break;
			case 'K': size += size_K(); break;
			case 'L': size += size_L(); break;
			case 'M': size += size_M(); break;
			case 'N': size += size_N(); break;
			case 'O': size += size_O(); break;
			case 'P': size += size_P(); break;
			case 'Q': size += size_Q(); break;
			case 'R': size += size_R(); break;
			case 'S': size += size_S(); break;
			case 'T': size += size_T(); break;
			case 'U': size += size_U(); break;
			case 'V': size += size_V(); break;
			case 'W': size += size_W(); break;
			case 'X': size += size_X(); break;
			case 'Y': size += size_Y(); break;
			case 'Z': size += size_Z(); break;
			case 'a': size += size_a(); break;
			case 'b': size += size_b(); break;
			case 'c': size += size_c(); break;
			case 'd': size += size_d(); break;
			case 'e': size += size_e(); break;
			case 'f': size += size_f(); break;
			case 'g': size += size_g(); break;
			case 'h': size += size_h(); break;
			case 'i': size += size_i(); break;
			case 'j': size += size_j(); break;
			case 'k': size += size_k(); break;
			case 'l': size += size_l(); break;
			case 'm': size += size_m(); break;
			case 'n': size += size_n(); break;
			case 'o': size += size_o(); break;
			case 'p': size += size_p(); break;
			case 'q': size += size_q(); break;
			case 'r': size += size_r(); break;
			case 's': size += size_s(); break;
			case 't': size += size_t(); break;
			case 'u': size += size_u(); break;
			case 'v': size += size_v(); break;
			case 'w': size += size_w(); break;
			case 'x': size += size_x(); break;
			case 'y': size += size_y(); break;
			case 'z': size += size_z(); break;
			case '1': size += size_1(); break;
			case '2': size += size_2(); break;
			case '3': size += size_3(); break;
			case '4': size += size_4(); break;
			case '5': size += size_5(); break;
			case '6': size += size_6(); break;
			case '7': size += size_7(); break;
			case '8': size += size_8(); break;
			case '9': size += size_91(); break;
			case '0': size += size_O(); break;
			case '_': size += size__(); break;
			default: break;
			}

		Array<GO_Strip> a(size);
		Vector3D<float> d , dt(0.0);

		for(i=0; txt[i] != 0; i++)
			switch(txt[i])
			{
			case 'A':
				make_A(a,m,r,k,res);
				dt += d = Vector3D<float>(length_A()+2*r,0,0);
				m.translate(d);
				break;
			case 'B':
				make_B(a,m,r,k,res);
				dt += d = Vector3D<float>(length_B()+2*r,0,0);
				m.translate(d);
				break;
			case 'C':
				make_C(a,m,r,k,res);
				dt += d = Vector3D<float>(length_C()+2*r,0,0);
				m.translate(d);
				break;
			case 'D':
				make_D(a,m,r,k,res);
				dt += d = Vector3D<float>(length_D()+2*r,0,0);
				m.translate(d);
				break;
			case 'E':
				make_E(a,m,r,k,res);
				dt += d = Vector3D<float>(length_E()+2*r,0,0);
				m.translate(d);
				break;
			case 'F':
				make_F(a,m,r,k,res);
				dt += d = Vector3D<float>(length_F()+2*r,0,0);
				m.translate(d);
				break;
			case 'G':
				make_G(a,m,r,k,res);
				dt += d = Vector3D<float>(length_G()+2*r,0,0);
				m.translate(d);
				break;
			case 'H':
				make_H(a,m,r,k,res);
				dt += d = Vector3D<float>(length_H()+2*r,0,0);
				m.translate(d);
				break;
			case 'I':
				make_l(a,m,r,k,res);
				dt += d = Vector3D<float>(length_l()+2*r,0,0);
				m.translate(d);
				break;
			case 'J':
				make_J(a,m,r,k,res);
				dt += d = Vector3D<float>(length_J()+2*r,0,0);
				m.translate(d);
				break;
			case 'K':
				make_K(a,m,r,k,res);
				dt += d = Vector3D<float>(length_K()+2*r,0,0);
				m.translate(d);
				break;
			case 'L':
				make_L(a,m,r,k,res);
				dt += d = Vector3D<float>(length_L()+2*r,0,0);
				m.translate(d);
				break;
			case 'M':
				make_M(a,m,r,k,res);
				dt += d = Vector3D<float>(length_M()+2*r,0,0);
				m.translate(d);
				break;
			case 'N':
				make_N(a,m,r,k,res);
				dt += d = Vector3D<float>(length_N()+2*r,0,0);
				m.translate(d);
				break;
			case 'O':
				make_O(a,m,r,k,res);
				dt += d = Vector3D<float>(length_O()+2*r,0,0);
				m.translate(d);
				break;
			case 'P':
				make_P(a,m,r,k,res);
				dt += d = Vector3D<float>(length_P()+2*r,0,0);
				m.translate(d);
				break;
			case 'Q':
				make_Q(a,m,r,k,res);
				dt += d = Vector3D<float>(length_Q()+2*r,0,0);
				m.translate(d);
				break;
			case 'R':
				make_R(a,m,r,k,res);
				dt += d = Vector3D<float>(length_R()+2*r,0,0);
				m.translate(d);
				break;
			case 'S':
				make_S(a,m,r,k,res);
				dt += d = Vector3D<float>(length_S()+2*r,0,0);
				m.translate(d);
				break;
			case 'T':
				make_T(a,m,r,k,res);
				dt += d = Vector3D<float>(length_T()+2*r,0,0);
				m.translate(d);
				break;
			case 'U':
				make_U(a,m,r,k,res);
				dt += d = Vector3D<float>(length_U()+2*r,0,0);
				m.translate(d);
				break;
			case 'V':
				make_V(a,m,r,k,res);
				dt += d = Vector3D<float>(length_V()+2*r,0,0);
				m.translate(d);
				break;
			case 'W':
				make_W(a,m,r,k,res);
				dt += d = Vector3D<float>(length_W()+2*r,0,0);
				m.translate(d);
				break;
			case 'X':
				make_X(a,m,r,k,res);
				dt += d = Vector3D<float>(length_X()+2*r,0,0);
				m.translate(d);
				break;
			case 'Y':
				make_Y(a,m,r,k,res);
				dt += d = Vector3D<float>(length_Y()+2*r,0,0);
				m.translate(d);
				break;
			case 'Z':
				make_Z(a,m,r,k,res);
				dt += d = Vector3D<float>(length_Z()+2*r,0,0);
				m.translate(d);
				break;
			case 'a':
				make_a(a,m,r,k,res);
				dt += d = Vector3D<float>(length_a()+2*r,0,0);
				m.translate(d);
				break;
			case 'b':
				make_b(a,m,r,k,res);
				dt += d = Vector3D<float>(length_b()+2*r,0,0);
				m.translate(d);
				break;
			case 'c':
				make_c(a,m,r,k,res);
				dt += d = Vector3D<float>(length_c()+2*r,0,0);
				m.translate(d);
				break;
			case 'd':
				make_d(a,m,r,k,res);
				dt += d = Vector3D<float>(length_d()+2*r,0,0);
				m.translate(d);
				break;
			case 'e':
				make_e(a,m,r,k,res);
				dt += d = Vector3D<float>(length_e()+2*r,0,0);
				m.translate(d);
				break;
			case 'f':
				make_f(a,m,r,k,res);
				dt += d = Vector3D<float>(length_f()+2*r,0,0);
				m.translate(d);
				break;
			case 'g':
				make_g(a,m,r,k,res);
				dt += d = Vector3D<float>(length_g()+2*r,0,0);
				m.translate(d);
				break;
			case 'h':
				make_h(a,m,r,k,res);
				dt += d = Vector3D<float>(length_h()+2*r,0,0);
				m.translate(d);
				break;
			case 'i':
				make_i(a,m,r,k,res);
				dt += d = Vector3D<float>(length_i()+2*r,0,0);
				m.translate(d);
				break;
			case 'j':
				make_j(a,m,r,k,res);
				dt += d = Vector3D<float>(length_j()+2*r,0,0);
				m.translate(d);
				break;
			case 'k':
				make_k(a,m,r,k,res);
				dt += d = Vector3D<float>(length_k()+2*r,0,0);
				m.translate(d);
				break;
			case 'l':
				make_l(a,m,r,k,res);
				dt += d = Vector3D<float>(length_l()+2*r,0,0);
				m.translate(d);
				break;
			case 'm':
				make_m(a,m,r,k,res);
				dt += d = Vector3D<float>(length_m()+2*r,0,0);
				m.translate(d);
				break;
			case 'n':
				make_n(a,m,r,k,res);
				dt += d = Vector3D<float>(length_n()+2*r,0,0);
				m.translate(d);
				break;
			case 'o':
				make_o(a,m,r,k,res);
				dt += d = Vector3D<float>(length_o()+2*r,0,0);
				m.translate(d);
				break;
			case 'p':
				make_p(a,m,r,k,res);
				dt += d = Vector3D<float>(length_p()+2*r,0,0);
				m.translate(d);
				break;
			case 'q':
				make_q(a,m,r,k,res);
				dt += d = Vector3D<float>(length_q()+2*r,0,0);
				m.translate(d);
				break;
			case 'r':
				make_r(a,m,r,k,res);
				dt += d = Vector3D<float>(length_r()+2*r,0,0);
				m.translate(d);
				break;
			case 's':
				make_s(a,m,r,k,res);
				dt += d = Vector3D<float>(length_s()+2*r,0,0);
				m.translate(d);
				break;
			case 't':
				make_t(a,m,r,k,res);
				dt += d = Vector3D<float>(length_t()+2*r,0,0);
				m.translate(d);
				break;
			case 'u':
				make_u(a,m,r,k,res);
				dt += d = Vector3D<float>(length_u()+2*r,0,0);
				m.translate(d);
				break;
			case 'v':
				make_v(a,m,r,k,res);
				dt += d = Vector3D<float>(length_v()+2*r,0,0);
				m.translate(d);
				break;
			case 'w':
				make_w(a,m,r,k,res);
				dt += d = Vector3D<float>(length_w()+2*r,0,0);
				m.translate(d);
				break;
			case 'x':
				make_x(a,m,r,k,res);
				dt += d = Vector3D<float>(length_x()+2*r,0,0);
				m.translate(d);
				break;
			case 'y':
				make_y(a,m,r,k,res);
				dt += d = Vector3D<float>(length_y()+2*r,0,0);
				m.translate(d);
				break;
			case 'z':
				make_z(a,m,r,k,res);
				dt += d = Vector3D<float>(length_z()+2*r,0,0);
				m.translate(d);
				break;
			case '1':
				make_1(a,m,r,k,res);
				dt += d = Vector3D<float>(length_1()+2*r,0,0);
				m.translate(d);
				break;
			case '2':
				make_2(a,m,r,k,res);
				dt += d = Vector3D<float>(length_2()+2*r,0,0);
				m.translate(d);
				break;
			case '3':
				make_3(a,m,r,k,res);
				dt += d = Vector3D<float>(length_3()+2*r,0,0);
				m.translate(d);
				break;
			case '4':
				make_4(a,m,r,k,res);
				dt += d = Vector3D<float>(length_4()+2*r,0,0);
				m.translate(d);
				break;
			case '5':
				make_5(a,m,r,k,res);
				dt += d = Vector3D<float>(length_5()+2*r,0,0);
				m.translate(d);
				break;
			case '6':
				make_6(a,m,r,k,res);
				dt += d = Vector3D<float>(length_6()+2*r,0,0);
				m.translate(d);
				break;
			case '7':
				make_7(a,m,r,k,res);
				dt += d = Vector3D<float>(length_7()+2*r,0,0);
				m.translate(d);
				break;
			case '8':
				make_8(a,m,r,k,res);
				dt += d = Vector3D<float>(length_8()+2*r,0,0);
				m.translate(d);
				break;
			case '9':
				make_91(a,m,r,k,res);
				dt += d = Vector3D<float>(length_91()+2*r,0,0);
				m.translate(d);
				break;
			case '0':
				make_O(a,m,r,k,res);
				dt += d = Vector3D<float>(length_O()+2*r,0,0);
				m.translate(d);
				break;
			case '_':
				make__(a,m,r,k,res);
				dt += d = Vector3D<float>(length__()+2*r,0,0);
				m.translate(d);
				break;
			case ' ':
				dt += d = Vector3D<float>(length__()+2*r,0,0);
				m.translate(d);
				break;
			default:
				break;
			}


		// Make displaylists!!
		_display_list = glGenLists(2);

		// for display
		glNewList(_display_list, GL_COMPILE);
		for(i=0;i<a.size();i++) a[i].display();
		glEndList();

		// for select
		glNewList(_display_list+1, GL_COMPILE);
		for(i=0;i<a.size();i++) a[i].select();
		glEndList();

		setSurroundingSphere(Sphere<float,3>(dt/2, dt.length()/2));
		_size = dt;
		_material = PolishedBronze;
	}

	Vector<float,3> getSize() { return _present*_size; }
	void	setMaterial(const Material& m) { _material = m; }

private:
	int		size_G(int res=32) { int res6 = res*6/10.0; int res3 = res*3/10.0; return 4*res+res6+res3+4; }
	float	length_G(double r=0.35) {return 3+2*r;}

	void	make_G(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> g[9], iu[2], gv[2];
		double dt;
		int i,j;
		int res6 = res*6/10.0;
		int res3 = res*3/10.0;

		g[0]  = Point3D<float>(3+4*k,4,0);			g[1]  = Point3D<float>(3+5*k,5,0);
		g[3]  = Point3D<float>(5*k,5,0);
		g[5]  = Point3D<float>(0,0,0);
		g[7]  = Point3D<float>(3,0,0);				g[8]  = Point3D<float>(3+(2+r)*k,2+r,0);
		g[2]  = (g[1]+g[3])/2.0;		g[4] = (g[3]+g[5])/2.0;		g[6] = (g[5]+g[7])/2.0;
		gv[0] = Point3D<float>(3+2*k,2,0);			gv[1] = Point3D<float>(2+2*k,2,0);
		iu[0] = Point3D<float>(3-r*k,-r,0);		iu[1] = Point3D<float>(3+(2+r)*k,2+r,0);

		dt=1.0/res;				// Make G
		for(i=0; i< res; i++)
			a += GO_Strip(eval2deg(g[0],g[1],g[2],i*dt,true,false,Vector3D<float>(0,1,0)),
			eval2deg(g[0],g[1],g[2],(i+1)*dt,true,false,Vector3D<float>(0,1,0)),r)*=ma;
		for(j=1; j<3; j++)
			for(i=0; i<res;i++)
				a += GO_Strip(eval2deg(g[2*j],g[2*j+1],g[2*j+2],i*dt,false,false),
				eval2deg(g[2*j],g[2*j+1],g[2*j+2],(i+1)*dt,false,false),r)*=ma;
		for(i=0; i<res;i++)
			a += GO_Strip(eval2deg(g[2*j],g[2*j+1],g[2*j+2],i*dt,false,true,Vector3D<float>(0,1,0)),
			eval2deg(g[2*j],g[2*j+1],g[2*j+2],(i+1)*dt,false,true,Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(g[0],Vector3D<float>(0,1,0)),r)*=ma;

		dt=1.0/res6;
		for(i=0; i< res6; i++)
			a += GO_Strip(eval1_2deg(iu[0],iu[1],i*dt,true,true),eval1_2deg(iu[0],iu[1],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(iu[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(iu[1],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res3;
		for(i=0; i< res3; i++)
			a += GO_Strip(eval1_2deg(gv[0],gv[1],i*dt,true,true,Vector3D<float>(-1,k,0),Vector3D<float>(-1,k,0)),
			eval1_2deg(gv[0],gv[1],(i+1)*dt,true,true,Vector3D<float>(-1,k,0),Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(gv[1],Vector3D<float>(-1,k,0)),r)*=ma;
	}

	int		size_M(int res=32) { int res15 = res*15/10.0; return 2*(res+res15)+5; }
	float	length_M(double r=0.35) {return 3+2*r;}

	void	make_M(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> m[5];
		double dt;
		int i;
		int res15 = res*15/10.0;

		m[0] = Point3D<float>(-r*k,-r,0);			m[1] = Point3D<float>((5+r)*k,5+r,0);
		m[2] = Point3D<float>(1.5+(2+r)*k,2+r,0);
		m[3] = Point3D<float>(3+(5+r)*k,5+r,0);		m[4] = Point3D<float>(3-r*k,-r,0);

		dt=1.0/res15;			// Make M
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1deg(m[0],m[1],i*dt,true,true),eval1deg(m[0],m[1],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[1],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res;
		for(i=0; i<res;i++)
			a += GO_Strip(eval1deg(m[2],m[1],i*dt,true,true),eval1deg(m[2],m[1],(i+1)*dt,true,true),r)*=ma;
		for(i=0; i<res;i++)
			a += GO_Strip(eval1deg(m[2],m[3],i*dt,true,true),eval1deg(m[2],m[3],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[2],Vector3D<float>(0,1,0)),r)*=ma;

		dt=1.0/res15;
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1_2deg(m[3],m[4],i*dt,true,true),eval1_2deg(m[3],m[4],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[4],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[3],Vector3D<float>(0,-1,0)),r)*=ma;
	}

	int		size__(int res=32) { int res6 = res*6/10.0; return res6+2; }
	float	length__(double r=0.35) {return 2;}

	void	make__(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> u[2];
		double dt;
		int i;
		int res6 = res*6/10.0;

		u[0] = Point3D<float>(0-r,0,0);			u[1] = Point3D<float>(2-r,0,0);

		dt=1.0/res6;		// Make underscore
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(u[0],u[1],i*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),
			eval1_2deg(u[0],u[1],(i+1)*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(u[0],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(u[1],Vector3D<float>(1,-k,0)),r)*=ma;
	}

	int		size_l(int res=32) {  int res15 = res*15/10.0;return res15+2; }
	float	length_l(double r=0.35) {return 2*r;}

	void	make_l(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> lo[2];
		double dt;
		int i;
		int res15 = res*15/10.0;
		//	Array<GO_Strip> a(res15+2);

		lo[0] = Point3D<float>(-r*k,-r,0);		lo[1] = Point3D<float>((5+r)*k,5+r,0);

		dt=1.0/res15;	// Make l
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1_2deg(lo[0],lo[1],i*dt,true,true),eval1_2deg(lo[0],lo[1],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[0],Vector3D<float>(0,sqrt(1+k*k),0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[1],Vector3D<float>(0,-sqrt(1+k*k),0)),r)*=ma;
	}

	int		size_i(int res=32) { int res6 = res*6/10.0; int res2 = res*2/10.0; return res6+res2+4; }
	float	length_i(double r=0.35) {return 2*r;}

	void	make_i(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> iu[2], io[2];
		double dt;
		int i;
		int res6 = res*6/10.0;
		int res2 = res*2/10.0;

		iu[0] = Point3D<float>(-r*k,-r,0);		iu[1] = Point3D<float>((2+r)*k,2+r,0);
		io[0] = Point3D<float>((3-r)*k,3-r,0);	io[1] = Point3D<float>((3+r)*k,3+r,0);

		dt=1.0/res6;		// Make i
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(iu[0],iu[1],i*dt,true,true),eval1_2deg(iu[0],iu[1],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(iu[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(iu[1],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res2;
		for(i=0; i<res2; i++)
			a += GO_Strip(eval1_2deg(io[0],io[1],i*dt,true,true),eval1_2deg(io[0],io[1],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(io[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(io[1],Vector3D<float>(0,-1,0)),r)*=ma;
	}

	int		size_b(int res=32) { int res15 = res*15/10.0; int res5 = res*5/10.0; return res15+4*res5+2; }
	float	length_b(double r=0.35) {return 2+2*r;}

	void	make_b(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> b[9], lo[2];
		double dt;
		int i,j;
		int res15 = res*15/10.0;
		int res5 = res*5/10.0;

		lo[0] = Point3D<float>(-r*k,-r,0);		lo[1] = Point3D<float>((5+r)*k,5+r,0);

		b[0] = b[8] = Point3D<float>(k,1,0);
		b[1] = Point3D<float>(0,0,0);			b[3] = Point3D<float>(2,0,0);
		b[7] = Point3D<float>(0+2*k,2,0);		b[5] = Point3D<float>(2+2*k,2,0);
		b[2] = (b[1]+b[3])/2.0;	b[4] = (b[3]+b[5])/2.0;	b[6] = (b[5]+b[7])/2.0;

		dt=1.0/res15;	// Make b
		for(i=0; i<(int)(res*15/10.0);i++)
			a += GO_Strip(eval1_2deg(lo[0],lo[1],i*dt,true,true),eval1_2deg(lo[0],lo[1],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[1],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(b[2*j],b[2*j+1],b[2*j+2],i*dt),eval2deg(b[2*j],b[2*j+1],b[2*j+2],(i+1)*dt),r)*=ma;
	}

	int		size_d(int res=32) { int res15 = res*15/10.0; int res5 = res*5/10.0; return res15+4*res5+2; }
	float	length_d(double r=0.35) {return 2+2*r;}

	void	make_d(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[9], lo[2];
		double dt;
		int i,j;
		int res15 = res*15/10.0;
		int res5 = res*5/10.0;

		lo[0] = Point3D<float>(2-r*k,-r,0);		lo[1] = Point3D<float>(2+(5+r)*k,5+r,0);

		p[0] = p[8] = Point3D<float>(2+k,1,0);
		p[1] = Point3D<float>(2,0,0);			p[3] = Point3D<float>(0,0,0);
		p[5] = Point3D<float>(0+2*k,2,0);		p[7] = Point3D<float>(2+2*k,2,0);
		p[2] = (p[1]+p[3])/2.0;	p[4] = (p[3]+p[5])/2.0;	p[6] = (p[5]+p[7])/2.0;

		dt=1.0/res15;	// Make d
		for(i=0; i<(int)(res*15/10.0);i++)
			a += GO_Strip(eval1_2deg(lo[0],lo[1],i*dt,true,true),eval1_2deg(lo[0],lo[1],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[1],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(p[2*j],p[2*j+1],p[2*j+2],i*dt),eval2deg(p[2*j],p[2*j+1],p[2*j+2],(i+1)*dt),r)*=ma;
	}

	int		size_H(int res=32) { int res15 = res*15/10.0; return res+2*res15+4; }
	float	length_H(double r=0.35) {return 3+2*r;}

	void	make_H(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> m[6];
		double dt;
		int i;
		int res15 = res*15/10.0;

		m[0] = Point3D<float>(-r*k,-r,0);			m[1] = Point3D<float>((5+r)*k,5+r,0);
		m[2] = Point3D<float>((2+r)*k,2+r,0);		m[3] = Point3D<float>(3+(2+r)*k,2+r,0);
		m[4] = Point3D<float>(3-r*k,-r,0);			m[5] = Point3D<float>(3+(5+r)*k,5+r,0);

		dt=1.0/res15;			// Make H
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1_2deg(m[0],m[1],i*dt,true,true),eval1_2deg(m[0],m[1],(i+1)*dt,true,true),r)*=ma;
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1_2deg(m[4],m[5],i*dt,true,true),eval1_2deg(m[4],m[5],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[1],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[4],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[5],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res;
		for(i=0; i<res;i++)
			a += GO_Strip(eval1_2deg(m[2],m[3],i*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),
			eval1_2deg(m[2],m[3],(i+1)*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),r)*=ma;
	}

	int		size_N(int res=32) { int res15 = res*15/10.0; return 3*res15+4; }
	float	length_N(double r=0.35) {return 3+2*r;}

	void	make_N(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> m[4];
		double dt;
		int i;
		int res15 = res*15/10.0;

		m[0] = Point3D<float>(-r*k,-r,0);			m[1] = Point3D<float>((5+r)*k,5+r,0);
		m[2] = Point3D<float>(3-r*k,-r,0);			m[3] = Point3D<float>(3+(5+r)*k,5+r,0);

		dt=1.0/res15;			// Make H
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1deg(m[0],m[1],i*dt,true,true),eval1deg(m[0],m[1],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[1],Vector3D<float>(0,-1,0)),r)*=ma;

		for(i=0; i<res15;i++)
			a += GO_Strip(eval1deg(m[1],m[2],i*dt,true,true),eval1deg(m[1],m[2],(i+1)*dt,true,true),r)*=ma;

		for(i=0; i<res15; i++)
			a += GO_Strip(eval1deg(m[2],m[3],i*dt,true,true),eval1deg(m[2],m[3],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[2],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[3],Vector3D<float>(0,-1,0)),r)*=ma;
	}

	int		size_A(int res=32) { int res15 = res*15/10.0, res6 = res*6/10.0; return res6+2*res15+3; }
	float	length_A(double r=0.35) {return 3+2*r;}

	void	make_A(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> m[5];
		double dt;
		int i;
		int res15 = res*15/10.0;
		int res6 = res*6/10.0;

		m[0] = Point3D<float>(-r*k,-r,0);			m[1] = Point3D<float>(1.5+(5+r)*k,5+r,0);
		m[2] = Point3D<float>(3-r*k,-r,0);
		m[3] = Point3D<float>(0.6+2*k,2,0);			m[4] = Point3D<float>(2.4+2*k,2,0);

		dt=1.0/res15;			// Make A
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1deg(m[0],m[1],i*dt,true,true),eval1deg(m[0],m[1],(i+1)*dt,true,true),r)*=ma;
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1deg(m[2],m[1],i*dt,true,true),eval1deg(m[2],m[1],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[1],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[2],Vector3D<float>(0,1,0)),r)*=ma;

		dt=1.0/res6;
		for(i=0; i<res6;i++)
			a += GO_Strip(eval1_2deg(m[3],m[4],i*dt,true,true,Vector3D<float>(1,-0.3-k,0),Vector3D<float>(1,0.3-k,0)),
			eval1_2deg(m[3],m[4],(i+1)*dt,true,true,Vector3D<float>(1,-0.3-k,0),Vector3D<float>(1,0.3-k,0)),r)*=ma;
	}

	int		size_L(int res=32) { int res15 = res*15/10.0; return res+res15+2; }
	float	length_L(double r=0.35) {return 3+2*r;}

	void	make_L(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> m[4];
		double dt;
		int i;
		int res15 = res*15/10.0;

		m[0] = Point3D<float>((5+r)*k,5+r,0);		m[1] = Point3D<float>(0,0,0);
		m[2] = Point3D<float>(0,0,0);				m[3] = Point3D<float>(3,0,0);

		dt=1.0/res15;			// Make H
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1_2deg(m[0],m[1],i*dt,true,true,Vector3D<float>(0,-1,0),Vector3D<float>(1,-1-k,0)),
			eval1_2deg(m[0],m[1],(i+1)*dt,true,true,Vector3D<float>(0,-1,0),Vector3D<float>(1,-1-k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[0],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res;
		for(i=0; i<res;i++)
			a += GO_Strip(eval1_2deg(m[2],m[3],i*dt,true,true,Vector3D<float>(1,-1-k,0),Vector3D<float>(1,-k,0)),
			eval1_2deg(m[2],m[3],(i+1)*dt,true,true,Vector3D<float>(1,-1-k,0),Vector3D<float>(1,-k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[3],Vector3D<float>(1,-k,0)),r)*=ma;
	}

	int		size_o(int res=32) { int res5 = res*5/10.0; return 4*res5; }
	float	length_o(double r=0.35) {return 2+2*r;}

	void	make_o(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[9];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = p[8] = Point3D<float>(2+k,1,0);
		p[1] = Point3D<float>(2,0,0);			p[3] = Point3D<float>(0,0,0);
		p[5] = Point3D<float>(0+2*k,2,0);		p[7] = Point3D<float>(2+2*k,2,0);
		p[2] = (p[1]+p[3])/2.0;	p[4] = (p[3]+p[5])/2.0;	p[6] = (p[5]+p[7])/2.0;

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(p[2*j],p[2*j+1],p[2*j+2],i*dt),eval2deg(p[2*j],p[2*j+1],p[2*j+2],(i+1)*dt),r)*=ma;
	}

	int		size_a(int res=32) { int res5 = res*5/10.0, res6 = res*6/10.0; return 4*res5+res6+2; }
	float	length_a(double r=0.35) {return 2+2*r;}

	void	make_a(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[9];
		double dt;
		int i,j;
		int res5 = res*5/10.0;
		int res6 = res*6/10.0;

		p[0] = p[8] = Point3D<float>(2+k,1,0);
		p[1] = Point3D<float>(2,0,0);			p[3] = Point3D<float>(0,0,0);
		p[5] = Point3D<float>(0+2*k,2,0);		p[7] = Point3D<float>(2+2*k,2,0);
		p[2] = (p[1]+p[3])/2.0;	p[4] = (p[3]+p[5])/2.0;	p[6] = (p[5]+p[7])/2.0;

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(p[2*j],p[2*j+1],p[2*j+2],i*dt),eval2deg(p[2*j],p[2*j+1],p[2*j+2],(i+1)*dt),r)*=ma;

		p[1] -= Vector3D<float>(0+r*k,r,0);
		p[7] += Vector3D<float>(0+r*k,r,0);
		dt=1.0/res6;		// Make i
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[1],p[7],i*dt,true,true),eval1_2deg(p[1],p[7],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[7],Vector3D<float>(0,-1,0)),r)*=ma;

	}

	int		size_e(int res=32) { int res3 = res*3/10.0, res5 = res*5/10.0, res6 = res*6/10.0; return res3+3*res5+res6+1; }
	float	length_e(double r=0.35) {return 2+2*r;}

	void	make_e(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[9];
		double dt;
		int i;
		int res3 = res*3/10.0;
		int res5 = res*5/10.0;
		int res6 = res*6/10.0;

		p[8] = Point3D<float>(2+k,1,0);
		p[1] = Point3D<float>(1.5,0,0);			p[3] = Point3D<float>(0,0,0);
		p[5] = Point3D<float>(0+2*k,2,0);		p[7] = Point3D<float>(2+2*k,2,0);
		p[2] = (p[1]+p[3])/2.0;	p[4] = (p[3]+p[5])/2.0;	p[6] = (p[5]+p[7])/2.0;
		//	p[0] = Point3D<float>(1.75+0.25*k,0.25,0);
		p[0] = Point3D<float>(2+0.5*r,0,0);

		dt=1.0/res3;
		for(i=0; i<res3;i++)
			a += GO_Strip(eval2deg(p[0],p[1],p[2],i*dt,true,false,Vector3D<float>(-1,k,0)),
			eval2deg(p[0],p[1],p[2],(i+1)*dt,true,false,Vector3D<float>(-1,k,0)),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[2],p[3],p[4],i*dt),eval2deg(p[2],p[3],p[4],(i+1)*dt),r)*=ma;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[4],p[5],p[6],i*dt),eval2deg(p[4],p[5],p[6],(i+1)*dt),r)*=ma;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2_2deg(6.0,p[6],p[7],p[8],i*dt,false,true,Vector3D<float>(-1,k-1,0)),
			eval2_2deg(6.0,p[6],p[7],p[8],(i+1)*dt,false,true,Vector3D<float>(-1,k-1,0)),r)*=ma;

		dt=1.0/res6;		// Make e
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[4],p[8],i*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,1-k,0)),
			eval1_2deg(p[4],p[8],(i+1)*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,1-k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[0],UnitVector3D<float>(1,-k,0)),r)*=ma;
	}

	int		size_n(int res=32) { int res5=res*5/10.0, res6=res*6/10.0, res3=res*3/10.0; return 2*res5+res6+res3+3; }
	float	length_n(double r=0.35) {return 2+2*r;}

	void	make_n(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[7];
		double dt;
		int i;
		int res6 = res*6/10.0;
		int res5 = res*5/10.0;
		int res3 = res*3/10.0;

		p[0] = Point3D<float>(-r*k,-r,0);	p[2] = Point3D<float>(0+2*k,2,0);
		p[4] = Point3D<float>(2+2*k,2,0);	p[6] = Point3D<float>(2-r*k,-r,0);
		p[1] = (p[0]+p[2])/2.0;	p[3] = (p[2]+p[4])/2.0;	p[5] = (p[4]+p[6])/2.0;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[1],p[2],p[3],i*dt,true,false,Vector3D<float>(0,1,0)),
			eval2deg(p[1],p[2],p[3],(i+1)*dt,true,false,Vector3D<float>(0,1,0)),r)*=ma;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[3],p[4],p[5],i*dt),eval2deg(p[3],p[4],p[5],(i+1)*dt),r)*=ma;

		p[2] += Vector3D<float>(0+r*k,r,0);;
		dt=1.0/res6;		// Make i
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[0],p[2],i*dt,true,true),eval1_2deg(p[0],p[2],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[2],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res3;		// Make n
		for(i=0; i<res3; i++)
			a += GO_Strip(eval1_2deg(p[6],p[5],i*dt,true,false),eval1_2deg(p[6],p[5],(i+1)*dt,true,false),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[6],Vector3D<float>(0,1,0)),r)*=ma;
	}

	int		size_u(int res=32) { int res5 = res*5/10.0, res6 = res*6/10.0, res3 = res*3/10.0; return 2*res5+res6+res3+3; }
	float	length_u(double r=0.35) {return 2+2*r;}

	void	make_u(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[7];
		double dt;
		int i;
		int res6 = res*6/10.0;
		int res5 = res*5/10.0;
		int res3 = res*3/10.0;

		p[0] = Point3D<float>(0+(2+r)*k,2+r,0);	p[2] = Point3D<float>(0,0,0);	
		p[4] = Point3D<float>(2,0,0);			p[6] = Point3D<float>(2+(2+r)*k,2+r,0);	
		p[1] = (p[0]+p[2])/2.0;	p[3] = (p[2]+p[4])/2.0;	p[5] = (p[4]+p[6])/2.0;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[1],p[2],p[3],i*dt),
			eval2deg(p[1],p[2],p[3],(i+1)*dt),r)*=ma;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[3],p[4],p[5],i*dt,false,true,Vector3D<float>(0,1,0)),
			eval2deg(p[3],p[4],p[5],(i+1)*dt,false,true,Vector3D<float>(0,1,0)),r)*=ma;

		p[4] -= Vector3D<float>(0+r*k,r,0);
		dt=1.0/res6;		// Make i
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[4],p[6],i*dt,true,true),eval1_2deg(p[4],p[6],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[4],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[6],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res3;		// Make u
		for(i=0; i<res3; i++)
			a += GO_Strip(eval1_2deg(p[1],p[0],i*dt,false,true),eval1_2deg(p[1],p[0],(i+1)*dt,false,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,1,0)),r)*=ma;
	}

	int		size_r(int res=32) { int res5=res*5/10.0, res6=res*6/10.0, res3=res*3/10.0; return 2*res5+res6+res3+3; }
	float	length_r(double r=0.35) {return 2-r+2*r;}

	void	make_r(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[5];
		double dt;
		int i;
		int res6 = res*6/10.0;
		int res5 = res*5/10.0;
		int res3 = res*3/10.0;

		p[0] = Point3D<float>(-r*k,-r,0);	p[2] = Point3D<float>(0+2*k,2,0);
		p[4] = Point3D<float>(2+2*k,2,0);
		p[1] = (p[0]+p[2])/2.0;	p[3] = (p[2]+p[4])/2.0;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[1],p[2],p[3],i*dt,true,false,Vector3D<float>(0,1,0)),
			eval2deg(p[1],p[2],p[3],(i+1)*dt,true,false,Vector3D<float>(0,1,0)),r)*=ma;

		p[2] += Vector3D<float>(0+r*k,r,0);;
		dt=1.0/res6;		// Make i
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[0],p[2],i*dt,true,true),eval1_2deg(p[0],p[2],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[2],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res3;		// Make r
		for(i=0; i<res3; i++)
			a += GO_Strip(eval1_2deg(p[3],p[4],i*dt,false,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),
			eval1_2deg(p[3],p[4],(i+1)*dt,false,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[4],Vector3D<float>(1,-k,0)),r)*=ma;
	}

	int		size_T(int res=32) { int res15 = res*15/10.0; return res+res15+3; }
	float	length_T(double r=0.35) {return 3+2*r;}

	void	make_T(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> m[4];
		double dt;
		int i;
		int res15 = res*15/10.0;

		m[0] = Point3D<float>(-r+5*k,5,0);			m[1] = Point3D<float>(r+3+5*k,5,0);
		m[2] = Point3D<float>(1.5-r*k,-r,0);		m[3] = (m[0]+m[1])/2.0;

		dt=1.0/res15;			// Make T
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1_2deg(m[2],m[3],i*dt,true,true),eval1_2deg(m[2],m[3],(i+1)*dt,true,true),r)*=ma;

		a += GO_Strip(Arrow<float,3>(m[0],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[1],Vector3D<float>(1,-k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[2],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res;
		for(i=0; i<res;i++)
			a += GO_Strip(eval1_2deg(m[0],m[1],i*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),
			eval1_2deg(m[0],m[1],(i+1)*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),r)*=ma;
	}



	int		size_p(int res=32) { int res15 = res*15/10.0; int res5 = res*5/10.0; return res15+4*res5+2; }
	float	length_p(double r=0.35) {return 2+2*r;}

	void	make_p(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> b[9], lo[2];
		double dt;
		int i,j;
		int res15 = res*15/10.0;
		int res5 = res*5/10.0;

		lo[0] = Point3D<float>(-2*k,-2,0);		lo[1] = Point3D<float>((2+r)*k,2+r,0);

		b[0] = b[8] = Point3D<float>(k,1,0);
		b[1] = Point3D<float>(0,0,0);			b[3] = Point3D<float>(2,0,0);
		b[7] = Point3D<float>(0+2*k,2,0);		b[5] = Point3D<float>(2+2*k,2,0);
		b[2] = (b[1]+b[3])/2.0;	b[4] = (b[3]+b[5])/2.0;	b[6] = (b[5]+b[7])/2.0;

		dt=1.0/res15;	// Make p
		for(i=0; i<(int)(res*15/10.0);i++)
			a += GO_Strip(eval1_2deg(lo[0],lo[1],i*dt,true,true),eval1_2deg(lo[0],lo[1],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[1],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(b[2*j],b[2*j+1],b[2*j+2],i*dt),eval2deg(b[2*j],b[2*j+1],b[2*j+2],(i+1)*dt),r)*=ma;
	}


	int		size_C(int res=32) { int res6 = res*6/10.0; int res3 = res*3/10.0; return 3*res+2*res6+2; }
	float	length_C(double r=0.35) {return 3+2*r;}

	void	make_C(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> g[9];
		double dt;
		int i,j;
		int res6 = res*6/10.0;

		g[0]  = Point3D<float>(3+4*k,4,0);			g[1]  = Point3D<float>(3+5*k,5,0);
		g[3]  = Point3D<float>(5*k,5,0);
		g[5]  = Point3D<float>(0,0,0);
		g[7]  = Point3D<float>(3,0,0);				g[8]  = Point3D<float>(3+(1+r)*k,1+r,0);
		g[2]  = (g[1]+g[3])/2.0;		g[4] = (g[3]+g[5])/2.0;		g[6] = (g[5]+g[7])/2.0;

		dt=1.0/res;				// Make G
		for(j=1; j<3; j++)
			for(i=0; i<res;i++)
				a += GO_Strip(eval2deg(g[2*j],g[2*j+1],g[2*j+2],i*dt,false,false),
				eval2deg(g[2*j],g[2*j+1],g[2*j+2],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res6;				
		for(i=0; i< res6; i++)
			a += GO_Strip(eval2deg(g[0],g[1],g[2],i*dt,true,false,Vector3D<float>(0,1,0)),
			eval2deg(g[0],g[1],g[2],(i+1)*dt,true,false,Vector3D<float>(0,1,0)),r)*=ma;

		for(i=0; i<res6;i++)
			a += GO_Strip(eval2deg(g[2*j],g[2*j+1],g[2*j+2],i*dt,false,true,Vector3D<float>(0,1,0)),
			eval2deg(g[2*j],g[2*j+1],g[2*j+2],(i+1)*dt,false,true,Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(g[0],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(g[8],Vector3D<float>(0,1,0)),r)*=ma;	
	}


	/*

	int		size_2(int res=32) { int res6 = res*6/10.0; int res3 = res*3/10.0; return 3*res+2*res6+2; }
	float	length_2(double r=0.35) {return 3+2*r;}

	void	make_2(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
	Point<float,3> g[8];
	double dt;
	int i,j;
	int res6 = res*6/10.0;
	float tan_alpha = tan(atan2(2.5+2.7*r,3+r+(2.5+2.7*r)*k)/2.0);
	float x6 = r/tan_alpha-r;

	g[0]  = Point3D<float>(0+4*k,4,0);			g[1]  = Point3D<float>(0+5*k,5,0);
	g[3]  = Point3D<float>(3+5*k,5,0);			g[4]  = Point3D<float>(3+3.5*k,3.5,0);
	g[5]  = Point3D<float>(3+2.5*k,2.5,0);
	g[6]  = Point3D<float>(x6,0,0);				g[7]  = Point3D<float>(3+r,0,0);
	g[2]  = (g[1]+g[3])/2.0;				

	dt=1.0/res;					// Make 2
	for(i=0; i<res;i++)		
	a += GO_Strip(eval2deg(g[0],g[1],g[2],i*dt,true,false,Vector3D<float>(0,1,0)),
	eval2deg(g[0],g[1],g[2],(i+1)*dt,true,false,Vector3D<float>(0,1,0)),r)*=ma;			
	for(i=0; i<res;i++)
	a += GO_Strip(eval2deg(g[2],g[3],g[4],i*dt,false,false),
	eval2deg(g[2],g[3],g[4],(i+1)*dt,false,false),r)*=ma;
	for(i=0; i<res;i++)
	a += GO_Strip(eval2deg(g[4],g[5],g[6],i*dt,false,true,Vector3D<float>(tan_alpha,-1,0)),
	eval2deg(g[4],g[5],g[6],(i+1)*dt,false,true,Vector3D<float>(tan_alpha,-1,0)),r)*=ma;
	dt=1.0/res6;				
	for(i=0; i< res6; i++)
	a += GO_Strip(eval1_2deg(g[6],g[7],i*dt,true,true,Vector3D<float>(tan_alpha,-1,0),Vector3D<float>(1,-k,0)),
	eval1_2deg(g[6],g[7],(i+1)*dt,true,true,Vector3D<float>(tan_alpha,-1,0),Vector3D<float>(1,-k,0)),r)*=ma;

	a += GO_Strip(Arrow<float,3>(g[0],Vector3D<float>(0,-1,0)),r)*=ma;
	a += GO_Strip(Arrow<float,3>(g[7],Vector3D<float>(1,-k,0)),r)*=ma;	
	}*/

	int		size_2(int res=32) { int res6 = res*6/10.0; int res3 = res*3/10.0; return 5*res6+2; }
	float	length_2(double r=0.35) {return 3+2*r;}

	void	make_2(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> g[10];
		double dt;
		int i;
		int res6 = res*6/10.0;

		g[0]  = Point3D<float>(0+4*k,4,0);			g[1]  = Point3D<float>(0+5*k,5,0);
		g[3]  = Point3D<float>(3+5*k,5,0);			g[8]  = Point3D<float>(0,0,0);
		g[4]  = Point3D<float>(3+3.5*k,3.5,0);		
		g[5]  = Point3D<float>(3+2.5*k,2.5,0);
		g[9]  = Point3D<float>(3+r,0,0);			g[7]  = Point3D<float>(1*k,1,0);
		g[2]  = (g[1]+g[3])/2.0;					g[6]  = (g[5]+g[7])/2.0;

		UnitVector3D<float> v = UnitVector<float,3>(g[9]-g[8])+UnitVector<float,3>(g[7]-g[8]);
		Vector3D<float> vn = v^Vector3D<float>(0,0,1);


		dt=1.0/res6;					// Make 2
		for(i=0; i<res6;i++)		
			a += GO_Strip(eval2deg(g[0],g[1],g[2],i*dt,true,false,Vector3D<float>(0,1,0)),
			eval2deg(g[0],g[1],g[2],(i+1)*dt,true,false,Vector3D<float>(0,1,0)),r)*=ma;			
		for(i=0; i<res6;i++)
			a += GO_Strip(eval2deg(g[2],g[3],g[4],i*dt,false,false),
			eval2deg(g[2],g[3],g[4],(i+1)*dt,false,false),r)*=ma;
		for(i=0; i<res6;i++)
			a += GO_Strip(eval2deg(g[4],g[5],g[6],i*dt,false,false),
			eval2deg(g[4],g[5],g[6],(i+1)*dt,false,false),r)*=ma;


		for(i=0; i< res6; i++)
			a += GO_Strip(eval1_2deg(g[8],g[9],i*dt,true,true,vn,Vector3D<float>(1,-k,0)),
			eval1_2deg(g[8],g[9],(i+1)*dt,true,true,vn,Vector3D<float>(1,-k,0)),r)*=ma;
		for(i=0; i<res6;i++)
			a += GO_Strip(eval2_2deg(5,g[6],g[7],g[8],i*dt,false,true,vn),
			eval2_2deg(5,g[6],g[7],g[8],(i+1)*dt,false,true,vn),r)*=ma;


		a += GO_Strip(Arrow<float,3>(g[0],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(g[9],Vector3D<float>(1,-k,0)),r)*=ma;	

	}

	int		size_h(int res=32) { int res5=res*5/10.0, res6=res*6/10.0, res3=res*3/10.0; return 2*res5+res6+res3+3; }
	float	length_h(double r=0.35) {return 2+2*r;}

	void	make_h(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[8];
		double dt;
		int i;
		int res6 = res*6/10.0;
		int res5 = res*5/10.0;
		int res3 = res*3/10.0;

		p[0] = Point3D<float>(-r*k,-r,0);	p[2] = Point3D<float>(0+2*k,2,0);	p[7] = Point3D<float>((5+r)*k,5+r,0);
		p[4] = Point3D<float>(2+2*k,2,0);	p[6] = Point3D<float>(2-r*k,-r,0);
		p[1] = (p[0]+p[2])/2.0;	p[3] = (p[2]+p[4])/2.0;	p[5] = (p[4]+p[6])/2.0;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[1],p[2],p[3],i*dt,true,false,Vector3D<float>(0,1,0)),
			eval2deg(p[1],p[2],p[3],(i+1)*dt,true,false,Vector3D<float>(0,1,0)),r)*=ma;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[3],p[4],p[5],i*dt),eval2deg(p[3],p[4],p[5],(i+1)*dt),r)*=ma;

		p[2] += Vector3D<float>(0+r*k,r,0);;
		dt=1.0/res6;		// Make i
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[0],p[7],i*dt,true,false),eval1_2deg(p[0],p[7],(i+1)*dt,true,false),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[7],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res3;		// Make n
		for(i=0; i<res3; i++)
			a += GO_Strip(eval1_2deg(p[6],p[5],i*dt,true,false),eval1_2deg(p[6],p[5],(i+1)*dt,true,false),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[6],Vector3D<float>(0,1,0)),r)*=ma;
	}

	int		size_B(int res=32) { int res15 = res*15/10.0; int res5 = res*5/10.0; return res15+4*res5+2; }
	float	length_B(double r=0.35) {return 3+2*r;}

	void	make_B(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> b[9], lo[2];
		double dt;
		int i;
		int res15 = res*15/10.0;
		int res5 = res*5/10.0;

		lo[0] = Point3D<float>(0,0,0);			lo[1] = Point3D<float>(5*k,5,0);

		b[1] = Point3D<float>(3+5*k,5,0);		b[2] = Point3D<float>(3+3.75*k,3.75,0);
		b[3] = Point3D<float>(2.5*k,2.5,0);		b[4] = Point3D<float>(3+2.5*k,2.5,0);
		b[5] = Point3D<float>(3+1.25*k,1.25,0);	b[0] = Point3D<float>(3,0,0);
		b[6] = (0.6*lo[1]+0.4*b[1]);	b[7] = (0.6*b[3]+0.4*b[4]);		b[8] = (0.6*lo[0]+0.4*b[0]);	

		UnitVector3D<float> v = UnitVector<float,3>(lo[0]-lo[1])+UnitVector<float,3>(b[6]-lo[1]);
		Vector3D<float> vnt = v^Vector3D<float>(0,0,-1);

		v = UnitVector<float,3>(lo[1]-lo[0])+UnitVector<float,3>(b[8]-lo[0]);
		Vector3D<float> vnb = v^Vector3D<float>(0,0,-1);


		dt=1.0/res15;	// Make B
		for(i=0; i<(int)(res*15/10.0);i++)
			a += GO_Strip(eval1_2deg(lo[0],lo[1],i*dt,true,true,vnb,vnt),
			eval1_2deg(lo[0],lo[1],(i+1)*dt,true,true,vnb,vnt),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(b[8],lo[0],i*dt,false,true,vnb),
			eval1_2deg(b[8],lo[0],(i+1)*dt,false,true,vnb),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(lo[1],b[6],i*dt,true,false,vnt),
			eval1_2deg(lo[1],b[6],(i+1)*dt,true,false,vnt),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[6],b[1],b[2],i*dt,false,false),
			eval2deg(b[6],b[1],b[2],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[2],b[4],b[7],i*dt,false,false),
			eval2deg(b[2],b[4],b[7],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[5],b[0],b[8],i*dt,false,false),
			eval2deg(b[5],b[0],b[8],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[7],b[4],b[5],i*dt,false,false),
			eval2deg(b[7],b[4],b[5],(i+1)*dt,false,false),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(b[7],b[3],i*dt,false,false),
			eval1_2deg(b[7],b[3],(i+1)*dt,false,false),r)*=ma;
	}

	int		size_3(int res=32) { int res15 = res*15/10.0; int res5 = res*5/10.0; return 6*res5+3; }
	float	length_3(double r=0.35) {return 3+2*r;}

	void	make_3(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> b[11], lo[2];
		double dt;
		int i;
		int res5 = res*5/10.0;

		lo[0] = Point3D<float>(0,0,0);			lo[1] = Point3D<float>(5*k,5,0);

		b[1] = Point3D<float>(3+5*k,5,0);		b[2] = Point3D<float>(3+3.75*k,3.75,0);
		b[3] = Point3D<float>(2.5*k,2.5,0);		b[4] = Point3D<float>(3+2.5*k,2.5,0);
		b[5] = Point3D<float>(3+1.25*k,1.25,0);	b[0] = Point3D<float>(3,0,0);
		b[6] = (0.5*lo[1]+0.5*b[1]);	b[7] = (0.5*b[3]+0.5*b[4]);		b[8] = (0.5*lo[0]+0.5*b[0]);
		b[9] = Point3D<float>(1*k,1,0);			b[10]= Point3D<float>(4*k,4,0);

		/*	dt=1.0/res15;	// Make B
		for(i=0; i<(int)(res*15/10.0);i++)
		a += GO_Strip(eval1_2deg(lo[0],lo[1],i*dt,true,true,Vector3D<float>(-1+k,1,0),Vector3D<float>(1+k,1,0)),
		eval1_2deg(lo[0],lo[1],(i+1)*dt,true,true,Vector3D<float>(-1+k,1,0),Vector3D<float>(1+k,1,0)),r)*=ma;

		/*	dt=1.0/res5;
		for(i=0; i<res5;i++)
		a += GO_Strip(eval2_2deg(1,lo[1],b[1],b[2],i*dt,true,false,Vector3D<float>(1+k,1,0)),
		eval2_2deg(1,lo[1],b[1],b[2],(i+1)*dt,true,false,Vector3D<float>(1+k,1,0)),r)*=ma;
		*/	
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[6],b[1],b[2],i*dt,false,false),
			eval2deg(b[6],b[1],b[2],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[2],b[4],b[7],i*dt,false,true,Vector3D<float>(-1,k,0)),
			eval2deg(b[2],b[4],b[7],(i+1)*dt,false,true,Vector3D<float>(-1,k,0)),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[5],b[0],b[8],i*dt,false,false),
			eval2deg(b[5],b[0],b[8],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[7],b[4],b[5],i*dt,true,false,Vector3D<float>(1,-k,0)),
			eval2deg(b[7],b[4],b[5],(i+1)*dt,true,false,Vector3D<float>(1,-k,0)),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[10],lo[1],b[6],i*dt,true,false,Vector3D<float>(0,1,0)),
			eval2deg(b[10],lo[1],b[6],(i+1)*dt,true,false,Vector3D<float>(0,1,0)),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[9],lo[0],b[8],i*dt,true,false,Vector3D<float>(0,-1,0)),
			eval2deg(b[9],lo[0],b[8],(i+1)*dt,true,false,Vector3D<float>(0,-1,0)),r)*=ma;

		a += GO_Strip(Arrow<float,3>(b[9],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(b[10],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(b[7],Vector3D<float>(1,-k,0)),r)*=ma;
	}

	int		size_c(int res=32) { int res5 = res*5/10.0; return 4*res5+2; }
	float	length_c(double r=0.35) {return 2+2*r;}

	void	make_c(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[9];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = Point3D<float>(2+2*k,2,0);		p[8] = Point3D<float>(2,0,0);
		p[1] = Point3D<float>(2,0,0);			p[3] = Point3D<float>(0,0,0);
		p[5] = Point3D<float>(0+2*k,2,0);		p[7] = Point3D<float>(2+2*k,2,0);
		p[2] = (p[1]+p[3])/2.0;	p[4] = (p[3]+p[5])/2.0;	p[6] = (p[5]+p[7])/2.0;

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1_2deg(p[0]/*,p[7]*/,p[6],i*dt,true,false,Vector3D<float>(-1,k,0)),
				eval1_2deg(p[0]/*,p[7]*/,p[6],(i+1)*dt,true,false,Vector3D<float>(-1,k,0)),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(p[6],p[5],p[4],i*dt,false,false),
				eval2deg(p[6],p[5],p[4],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(p[4],p[3],p[2],i*dt,false,false),
				eval2deg(p[4],p[3],p[2],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1_2deg(p[2]/*,p[1]*/,p[8],i*dt,false,true,Vector3D<float>(1,-k,0)),
				eval1_2deg(p[2]/*,p[1]*/,p[8],(i+1)*dt,false,true,Vector3D<float>(1,-k,0)),r)*=ma; 

		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[8],Vector3D<float>(1,-k,0)),r)*=ma;
	}

	int		size_f(int res=32) {  int res15 = res*15/10.0;return res15+2; }
	float	length_f(double r=0.35) {return 0.5+2*r;}

	void	make_f(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> lo[7];
		double dt;
		int i;
		int res15 = res*15/10.0;
		//	Array<GO_Strip> a(res15+2);

		lo[0] = Point3D<float>(0-r*k,-r,0);		lo[1] = Point3D<float>(0+5*k,5,0);
		lo[2] = Point3D<float>(1+5*k,5,0);		lo[3] = Point3D<float>(-0.75+(3)*k,3,0);
		lo[4] = Point3D<float>(1+3*k,3,0);		lo[5] = Point3D<float>(0+4*k,4,0);		lo[6] = Point3D<float>(0+3*k,3,0);	

		// Make f
		dt=1.0/res15;	
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1_2deg(lo[0],lo[5],i*dt,true,false),eval1_2deg(lo[0],lo[5],(i+1)*dt,true,false),r)*=ma;  

		dt=1.0/res15;
		for(i=0; i<res15;i++)
			a += GO_Strip(eval2deg(lo[5],lo[1],lo[2],i*dt,false,true,Vector3D<float>(1,-k,0)),
			eval2deg(lo[5],lo[1],lo[2],(i+1)*dt,false,true,Vector3D<float>(1,-k,0)),r)*=ma;

		dt=1.0/res15;	
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1_2deg(lo[6],lo[3],i*dt,false,true,Vector3D<float>(-1,k,0)),
			eval1_2deg(lo[6],lo[3],(i+1)*dt,false,true,Vector3D<float>(-1,k,0)),r)*=ma;	
		dt=1.0/res15;	
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1_2deg(lo[6],lo[4],i*dt,false,true,Vector3D<float>(1,-k,0)),
			eval1_2deg(lo[6],lo[4],(i+1)*dt,false,true,Vector3D<float>(1,-k,0)),r)*=ma;	

		a += GO_Strip(Arrow<float,3>(lo[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[2],Vector3D<float>(1,-k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[3],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[4],Vector3D<float>(1,-k,0)),r)*=ma;

	}

	int		size_g(int res=32) { int res5 = res*5/10.0; return 7*res5; }
	float	length_g(double r=0.35) {return 2+2*r;}

	void	make_g(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[9], g[7];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = p[8] = Point3D<float>(2+k,1,0);
		p[1] = Point3D<float>(2,0,0);			p[3] = Point3D<float>(0,0,0);
		p[5] = Point3D<float>(0+2*k,2,0);		p[7] = Point3D<float>(2+2*k,2,0);
		p[2] = (p[1]+p[3])/2.0;	p[4] = (p[3]+p[5])/2.0;	p[6] = (p[5]+p[7])/2.0;

		g[0] = Point3D<float>(2+(r+2)*k,2+r,0);		g[1] = Point3D<float>(2-1*k,-1,0);
		g[2] = Point3D<float>(2-2*k,-2,0);		g[3] = Point3D<float>(1-2*k,-2,0);
		g[4] = Point3D<float>(0-2*k,-2,0);		g[5] = Point3D<float>(0-1*k,-1,0);		g[6] = Point3D<float>(2,0,0);



		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(p[2*j],p[2*j+1],p[2*j+2],i*dt),eval2deg(p[2*j],p[2*j+1],p[2*j+2],(i+1)*dt),r)*=ma;

		dt=1.0/res5;							// Make g
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(g[0],g[6],i*dt,true,true),
			eval1_2deg(g[0],g[6],(i+1)*dt,true,true),r)*=ma;
		dt=1.0/res5;							
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(g[1],g[6],i*dt,false,true),
			eval1_2deg(g[1],g[6],(i+1)*dt,false,true),r)*=ma;

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(g[1],g[2],g[3],i*dt,false,false),
				eval2deg(g[1],g[2],g[3],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(g[3],g[4],g[5],i*dt,false,true,Vector3D<float>(0,1,0)),
				eval2deg(g[3],g[4],g[5],(i+1)*dt,false,true,Vector3D<float>(0,1,0)),r)*=ma;



		a += GO_Strip(Arrow<float,3>(g[5],Vector3D<float>(0,1,0)),r)*=ma;  
		a += GO_Strip(Arrow<float,3>(g[0],Vector3D<float>(0,1,0)),r)*=ma;  
	}

	int		size_q(int res=32) { int res5 = res*5/10.0; return 7*res5; }
	float	length_q(double r=0.35) {return 2+2*r;}

	void	make_q(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[9], g[5];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = p[8] = Point3D<float>(2+k,1,0);
		p[1] = Point3D<float>(2,0,0);			p[3] = Point3D<float>(0,0,0);
		p[5] = Point3D<float>(0+2*k,2,0);		p[7] = Point3D<float>(2+2*k,2,0);
		p[2] = (p[1]+p[3])/2.0;	p[4] = (p[3]+p[5])/2.0;	p[6] = (p[5]+p[7])/2.0;

		g[0] = Point3D<float>(2+(r+2)*k,2+r,0);		g[1] = Point3D<float>(2-1.5*k,-1.5,0);
		g[2] = Point3D<float>(2-(2+r)*k,-(2+r),0);	g[3] = Point3D<float>(1.25-1.5*k,-1.5,0);
		g[4] = Point3D<float>(2.75-1.5*k,-1.5,0);		



		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(p[2*j],p[2*j+1],p[2*j+2],i*dt),eval2deg(p[2*j],p[2*j+1],p[2*j+2],(i+1)*dt),r)*=ma;

		dt=1.0/res5;							// Make q
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(g[0],g[1],i*dt,true,true,Vector3D<float>(0,1,0),Vector3D<float>(0,1,0)),
			eval1_2deg(g[0],g[1],(i+1)*dt,true,true,Vector3D<float>(0,1,0),Vector3D<float>(0,1,0)),r)*=ma;
		dt=1.0/res5;							
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(g[1],g[2],i*dt,true,true,Vector3D<float>(0,1,0),Vector3D<float>(0,1,0)),
			eval1_2deg(g[1],g[2],(i+1)*dt,true,true,Vector3D<float>(0,1,0),Vector3D<float>(0,1,0)),r)*=ma;
		dt=1.0/res5;							
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(g[1],g[3],i*dt,false,true,Vector3D<float>(-1,k,0)),
			eval1_2deg(g[1],g[3],(i+1)*dt,false,true,Vector3D<float>(-1,k,0)),r)*=ma;
		dt=1.0/res5;							
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(g[1],g[4],i*dt,false,true,Vector3D<float>(1,-k,0)),
			eval1_2deg(g[1],g[4],(i+1)*dt,false,true,Vector3D<float>(1,-k,0)),r)*=ma;	





		a += GO_Strip(Arrow<float,3>(g[0],Vector3D<float>(0,-1,0)),r)*=ma;  
		a += GO_Strip(Arrow<float,3>(g[2],Vector3D<float>(0,1,0)),r)*=ma; 
		a += GO_Strip(Arrow<float,3>(g[3],Vector3D<float>(-1,k,0)),r)*=ma;  
		a += GO_Strip(Arrow<float,3>(g[4],Vector3D<float>(1,-k,0)),r)*=ma;  
	}
	int		size_j(int res=32) { int res6 = res*6/10.0; int res2 = res*2/10.0; return res6+res2+4; }
	float	length_j(double r=0.35) {return 2*r;}

	void	make_j(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> iu[4], io[2];
		double dt;
		int i;
		int res6 = res*6/10.0;
		int res2 = res*2/10.0;

		iu[0] = Point3D<float>(-1*k,-1,0);		iu[1] = Point3D<float>((2+r)*k,2+r,0);
		io[0] = Point3D<float>((3-r)*k,3-r,0);	io[1] = Point3D<float>((3+r)*k,3+r,0);
		iu[2] = Point3D<float>(-2*k,-2,0);		iu[3] = Point3D<float>(-0.75-2*k,-2,0);

		dt=1.0/res6;		// Make i
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(iu[0],iu[1],i*dt,false,true),eval1_2deg(iu[0],iu[1],(i+1)*dt,false,true),r)*=ma;
		dt=1.0/res6;
		for(i=0; i<4; i++)
			for(i=0; i<res6;i++)
				a += GO_Strip(eval2deg(iu[0],iu[2],iu[3],i*dt,false,true,Vector3D<float>(-1,k,0)),
				eval2deg(iu[0],iu[2],iu[3],(i+1)*dt,false,true,Vector3D<float>(-1,k,0)),r)*=ma;	




		a += GO_Strip(Arrow<float,3>(iu[3],Vector3D<float>(1,-k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(iu[1],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res2;
		for(i=0; i<res2; i++)
			a += GO_Strip(eval1_2deg(io[0],io[1],i*dt,true,true),eval1_2deg(io[0],io[1],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(io[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(io[1],Vector3D<float>(0,-1,0)),r)*=ma;
	}
	int		size_k(int res=32) { int res5=res*5/10.0, res6=res*6/10.0; return 2*res5+res6+4; }
	float	length_k(double r=0.35) {return 2+2*r;}

	void	make_k(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[5];
		double dt;
		int i;
		int res6 = res*6/10.0;
		int res5 = res*5/10.0;


		p[0] = Point3D<float>(-r*k,-r,0);	p[1] = Point3D<float>(0+1.25*k,1.25,0);		p[2] = Point3D<float>((5+r)*k,5+r,0);
		p[4] = Point3D<float>(2+(2+r)*k,2+r,0);		p[3] = Point3D<float>(2-r*k,-r,0);



		dt=1.0/res6;		// Make l
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1deg(p[0],p[2],i*dt,true,true),
			eval1deg(p[0],p[2],(i+1)*dt,true,true),r)*=ma;

		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[2],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res5;		// Make n
		for(i=0; i<res5; i++)
			a += GO_Strip(eval1deg(p[1],p[4],i*dt,true,true/*,Vector3D<float>(0,-1,0)*/),
			eval1deg(p[1],p[4],(i+1)*dt,true,true/*,Vector3D<float>(0,-1,0)*/),r)*=ma;

		a += GO_Strip(Arrow<float,3>(p[4],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res5;		// Make n
		for(i=0; i<res5; i++)
			a += GO_Strip(eval1deg(p[3],p[1],i*dt,true,true),/*Vector3D<float>(0,k,0)*/
			eval1deg(p[3],p[1],(i+1)*dt,true,true),r)*=ma;/*Vector3D<float>(0,k,0)*/

		a += GO_Strip(Arrow<float,3>(p[3],Vector3D<float>(0,1,0)),r)*=ma;
	}
	int		size_x(int res=32) { int res5 = res*5/10.0; return 2*res5+4; }
	float	length_x(double r=0.35) {return 2+2*r;}

	void	make_x(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[4];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = Point3D<float>((2+r)*k,2+r,0);		p[1] = Point3D<float>(2+(2+r)*k,2+r,0);
		p[2] = Point3D<float>(-r*k,-r,0);			p[3] = Point3D<float>(2-r*k,-r,0);

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[0],p[3],i*dt,true,true),
				eval1deg(p[0],p[3],(i+1)*dt,true,true),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[1],p[2],i*dt,true,true),
				eval1deg(p[1],p[2],(i+1)*dt,true,true),r)*=ma; 

		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[2],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[3],Vector3D<float>(0,1,0)),r)*=ma;
	}
	int		size_m(int res=32) { int res5=res*5/10.0, res6=res*6/10.0, res3=res*3/10.0; return 2*res5+res6+res3+3; }
	float	length_m(double r=0.35) {return 3+2*r;}

	void	make_m(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[7],m[4];
		double dt;
		int i;
		int res6 = res*6/10.0;
		int res5 = res*5/10.0;
		int res3 = res*3/10.0;

		p[0] = Point3D<float>(-r*k,-r,0);	p[2] = Point3D<float>(0+2*k,2,0);
		p[4] = Point3D<float>(1.5+2*k,2,0);	p[6] = Point3D<float>(1.5-r*k,-r,0);
		p[1] = (p[0]+p[2])/2.0;	p[3] = (p[2]+p[4])/2.0;	p[5] = (p[4]+p[6])/2.0;

		m[0] = Point3D<float>(3+2*k,2,0);	m[1] = Point3D<float>(3-r*k,-r,0);
		m[2] = (m[0]+m[1])/2.0;				m[3] = (m[0]+p[4])/2.0;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[1],p[2],p[3],i*dt,true,false,Vector3D<float>(0,1,0)),
			eval2deg(p[1],p[2],p[3],(i+1)*dt,true,false,Vector3D<float>(0,1,0)),r)*=ma;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[3],p[4],p[5],i*dt),eval2deg(p[3],p[4],p[5],(i+1)*dt),r)*=ma;

		p[2] += Vector3D<float>(0+r*k,r,0);;
		dt=1.0/res6;		// Make i
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[0],p[2],i*dt,true,true),eval1_2deg(p[0],p[2],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[2],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res3;		// Make n
		for(i=0; i<res3; i++)
			a += GO_Strip(eval1_2deg(p[6],p[5],i*dt,true,false),eval1_2deg(p[6],p[5],(i+1)*dt,true,false),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[6],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(m[1],Vector3D<float>(0,1,0)),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(m[1],m[2],i*dt,true,false,Vector3D<float>(0,1,0)),
			eval1_2deg(m[1],m[2],(i+1)*dt,true,false,Vector3D<float>(0,1,0)),r)*=ma;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[5],p[4],m[3],i*dt),eval2deg(p[5],p[4],m[3],(i+1)*dt),r)*=ma;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(m[3],m[0],m[2],i*dt),eval2deg(m[3],m[0],m[2],(i+1)*dt),r)*=ma;
	}

	int		size_s(int res=32) { int res5=res*5/10.0; return 6*res5+2; }
	float	length_s(double r=0.35) {return 2+2*r;}

	void	make_s(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[11];
		double dt;
		int i;
		int res5 = res*5/10.0;


		p[0] = Point3D<float>(2+r+2*k,2,0);		p[2] = Point3D<float>(2*k,2,0);	
		p[1] = (p[0]+p[2])/2.0;					p[4] = Point3D<float>(1*k,1,0);
		p[3] = (p[2]+p[4])/2.0;					p[6] = Point3D<float>(2+1*k,1,0);
		p[5] = (p[4]+p[6])/2.0;					p[8] = Point3D<float>(2,0,0);
		p[7] = (p[6]+p[8])/2.0;					p[10] = Point3D<float>(-r,0,0);	
		p[9] = (p[8]+p[10])/2.0;		


		dt=1.0/res5;		
		for(i=0; i<res5; i++)
			a += GO_Strip(eval1_2deg(p[0],p[1],i*dt,true,false,Vector3D<float>(-1,k,0)),
			eval1_2deg(p[0],p[1],(i+1)*dt,true,false,Vector3D<float>(-1,k,0)),r)*=ma;		

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[1],p[2],p[3],i*dt),
			eval2deg(p[1],p[2],p[3],(i+1)*dt),r)*=ma;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[3],p[4],p[5],i*dt),
			eval2deg(p[3],p[4],p[5],(i+1)*dt),r)*=ma;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[5],p[6],p[7],i*dt),
			eval2deg(p[5],p[6],p[7],(i+1)*dt),r)*=ma;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[7],p[8],p[9],i*dt),
			eval2deg(p[7],p[8],p[9],(i+1)*dt),r)*=ma;

		dt=1.0/res5;		
		for(i=0; i<res5; i++)
			a += GO_Strip(eval1_2deg(p[10],p[9],i*dt,true,false,Vector3D<float>(1,-k,0)),
			eval1_2deg(p[10],p[9],(i+1)*dt,true,false,Vector3D<float>(1,-k,0)),r)*=ma;	


		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[10],Vector3D<float>(1,-k,0)),r)*=ma;
	}

	int		size_t(int res=32) {  int res15 = res*15/10.0;return res15+2; }
	float	length_t(double r=0.35) {return 0.5+2*r;}

	void	make_t(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> lo[7];
		double dt;
		int i;
		int res15 = res*15/10.0;
		//	Array<GO_Strip> a(res15+2);

		lo[1] = Point3D<float>(0-r*k,-r,0);		lo[0] = Point3D<float>(0+(5+r)*k,5+r,0);
		lo[2] = Point3D<float>(1,0,0);			lo[3] = Point3D<float>(-0.75+(3)*k,3,0);
		lo[4] = Point3D<float>(1+3*k,3,0);	lo[5] = Point3D<float>(0+1*k,1,0);		lo[6] = Point3D<float>(0+3*k,3,0);	

		// Make f
		dt=1.0/res15;	
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1_2deg(lo[0],lo[5],i*dt,true,false,Vector3D<float>(0,-1,0)),
			eval1_2deg(lo[0],lo[5],(i+1)*dt,true,false,Vector3D<float>(0,-1,0)),r)*=ma;  

		dt=1.0/res15;
		for(i=0; i<res15;i++)
			a += GO_Strip(eval2_2deg(5,lo[5],lo[1],lo[2],i*dt,false,true,Vector3D<float>(1,-k,0)),
			eval2_2deg(5,lo[5],lo[1],lo[2],(i+1)*dt,false,true,Vector3D<float>(1,-k,0)),r)*=ma;
		dt=1.0/res15;	
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1_2deg(lo[6],lo[3],i*dt,false,true,Vector3D<float>(-1,k,0)),
			eval1_2deg(lo[6],lo[3],(i+1)*dt,false,true,Vector3D<float>(-1,k,0)),r)*=ma;	
		dt=1.0/res15;	
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1_2deg(lo[6],lo[4],i*dt,false,true,Vector3D<float>(1,-k,0)),
			eval1_2deg(lo[6],lo[4],(i+1)*dt,false,true,Vector3D<float>(1,-k,0)),r)*=ma;	

		a += GO_Strip(Arrow<float,3>(lo[0],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[2],Vector3D<float>(-1.1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[3],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[4],Vector3D<float>(1,-k,0)),r)*=ma;
	}

	int		size_v(int res=32) { int res5 = res*5/10.0; return 2*res5+3; }
	float	length_v(double r=0.35) {return 2+2*r;}

	void	make_v(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[3];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = Point3D<float>((2+r)*k,2+r,0);		p[1] = Point3D<float>(2+(2+r)*k,2+r,0);
		p[2] = Point3D<float>(1-r*k,-r,0);			

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[2],p[0],i*dt,true,true),
				eval1deg(p[2],p[0],(i+1)*dt,true,true),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[2],p[1],i*dt,true,true),
				eval1deg(p[2],p[1],(i+1)*dt,true,true),r)*=ma; 

		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[2],Vector3D<float>(0,1,0)),r)*=ma;
	}

	int		size_w(int res=32) { int res5 = res*5/10.0; return 4*res5+5; }
	float	length_w(double r=0.35) {return 3+2*r;}

	void	make_w(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[5];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = Point3D<float>((2+r)*k,2+r,0);		p[1] = Point3D<float>(1.5+(2+r)*k,2+r,0);
		p[2] = Point3D<float>(0.75-r*k,-r,0);		p[3] = Point3D<float>(3+(2+r)*k,2+r,0);		
		p[4] = Point3D<float>(2.25-r*k,-r,0);

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[0],p[2],i*dt,true,true),
				eval1deg(p[0],p[2],(i+1)*dt,true,true),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[1],p[2],i*dt,true,true),
				eval1deg(p[1],p[2],(i+1)*dt,true,true),r)*=ma; 
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[1],p[4],i*dt,true,true),
				eval1deg(p[1],p[4],(i+1)*dt,true,true),r)*=ma; 
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[4],p[3],i*dt,true,true),
				eval1deg(p[4],p[3],(i+1)*dt,true,true),r)*=ma; 



		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[2],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[3],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[4],Vector3D<float>(0,1,0)),r)*=ma;
	}

	int		size_z(int res=32) { int res5 = res*5/10.0; return 3*res5+4; }
	float	length_z(double r=0.35) {return 2+2*r;}

	void	make_z(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[4];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = Point3D<float>(-r+2*k,2,0);		p[1] = Point3D<float>(2+r+2*k,2,0);
		p[2] = Point3D<float>(-r,0,0);			p[3] = Point3D<float>(2+r,0,0);

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[0],p[1],i*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),
				eval1deg(p[0],p[1],(i+1)*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[1],p[2],i*dt,true,true,Vector3D<float>(-1,k,0),Vector3D<float>(-1,k,0)),
				eval1deg(p[1],p[2],(i+1)*dt,true,true,Vector3D<float>(-1,k,0),Vector3D<float>(-1,k,0)),r)*=ma; 
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[2],p[3],i*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),
				eval1deg(p[2],p[3],(i+1)*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),r)*=ma; 



		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(1,-k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[2],Vector3D<float>(1,-k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[3],Vector3D<float>(-1,k,0)),r)*=ma;
	}

	int		size_oe(int res=32) { int res5 = res*5/10.0; return 5*res5; }
	float	length_oe(double r=0.35) {return 2+2*r;}

	void	make_oe(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[9];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = p[8] = Point3D<float>(2+k,1,0);
		p[1] = Point3D<float>(2,0,0);			p[3] = Point3D<float>(0,0,0);
		p[5] = Point3D<float>(0+2*k,2,0);		p[7] = Point3D<float>(2+2*k,2,0);
		p[2] = (p[1]+p[3])/2.0;	p[4] = (p[3]+p[5])/2.0;	p[6] = (p[5]+p[7])/2.0;

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(p[2*j],p[2*j+1],p[2*j+2],i*dt),eval2deg(p[2*j],p[2*j+1],p[2*j+2],(i+1)*dt),r)*=ma;
		
		p[3] -= Vector3D<float>(0+r*k,r,0);
		p[7] += Vector3D<float>(0+r*k,r,0);
		
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[7],p[3],i*dt,true,true,Vector3D<float>(0,1,0),Vector3D<float>(0,1,0)),
							  eval1deg(p[7],p[3],(i+1)*dt,true,true,Vector3D<float>(0,1,0),Vector3D<float>(0,1,0)),r)*=ma; 

		a += GO_Strip(Arrow<float,3>(p[7],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[3],Vector3D<float>(0,1,0)),r)*=ma;
	}



/*	int		size_ae(int res=32) { int res3 = res*3/10.0,res5 = res*5/10.0, res6 = res*6/10.0; return 4*res5+res6+2; }
	float	length_ae(double r=0.35) {return 3+2*r;}

	void	make_ae(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[13];
		double dt;
		int i,j;
		int res3 = res*3/10.0;
		int res5 = res*5/10.0;
		int res6 = res*6/10.0;

		p[0] = p[8] = Point3D<float>(1.5+k,1,0);
		p[1] = Point3D<float>(1.5,0,0);			p[3] = Point3D<float>(0,0,0);
		p[5] = Point3D<float>(0+2*k,2,0);		p[7] = Point3D<float>(1.5+2*k,2,0);
		p[2] = (p[1]+p[3])/2.0;	p[4] = (p[3]+p[5])/2.0;	p[6] = (p[5]+p[7])/2.0;

		p[9] = Point3D<float>(3+(2+0.2*r)*k,2+0.2*r,0);	p[10] = Point3D<float>(3+1*k,1,0);	p[11] = Point3D<float>(3+r,0,0);
		p[12] = Point3D<float>(2.25+2*k,2,0);

		UnitVector3D<float> v   = UnitVector<float,3>(p[1]-p[7])+UnitVector<float,3>(p[9]-p[7]);
		Vector3D<float>		vnt = v^Vector3D<float>(0,0,-1);

		v	= UnitVector<float,3>(p[8]-p[10])+UnitVector<float,3>(p[9]-p[10]);
		Vector3D<float>		vnb = v^Vector3D<float>(0,0,1);



		dt=1.0/res5;//res5
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2_2Mdeg(0.6,p[10],p[9],p[7],i*dt,vnb,-vnt),
						  eval2_2Mdeg(0.6,p[10],p[9],p[7],(i+1)*dt,vnb,-vnt),r)*=ma;

	/*	dt=1.0/res3;//res3
		for(i=0; i<res3;i++)
			a += GO_Strip(eval2_2deg(0.5,p[12],p[7],p[0],i*dt,false,false),
						  eval2_2deg(0.5,p[12],p[7],p[0],(i+1)*dt,false,false),r)*=ma;		

		dt=1.0/res6;		
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[0],p[10],i*dt,false,true,vnb),
						  eval1_2deg(p[0],p[10],(i+1)*dt,false,true,vnb),r)*=ma;


		
		
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(p[2*j],p[2*j+1],p[2*j+2],i*dt),eval2deg(p[2*j],p[2*j+1],p[2*j+2],(i+1)*dt),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1deg(p[1],p[11],i*dt,false,true,Vector3D<float>(1,-k,0)),
						  eval1deg(p[1],p[11],(i+1)*dt,false,true,Vector3D<float>(1,-k,0)),r)*=ma;



		p[1] -= Vector3D<float>(0+r*k,r,0);
/*		p[7] += Vector3D<float>(0+r*k,r,0);

		dt=1.0/res6;		// Make i
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[1],p[7],i*dt,true,true,Vector3D<float>(0,1,0),vnt),
			eval1_2deg(p[1],p[7],(i+1)*dt,true,true,Vector3D<float>(0,1,0),vnt),r)*=ma;		

		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(0,1,0)),r)*=ma;			
		a += GO_Strip(Arrow<float,3>(p[11],Vector3D<float>(-1,k,0)),r)*=ma;

	}*/

	int		size_ae(int res=32) { int res3 = res*3/10.0,res5 = res*5/10.0, res6 = res*6/10.0; return 4*res5+res6+2; }
	float	length_ae(double r=0.35) {return 3+2*r;}

	void	make_ae(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[13];
		double dt;
		int i,j;
		int res3 = res*3/10.0;
		int res5 = res*5/10.0;
		int res6 = res*6/10.0;

		p[0] = p[8] = Point3D<float>(2+1*k,1,0);
		p[1] = Point3D<float>(2,0,0);			p[3] = Point3D<float>(0,0,0);
		p[5] = Point3D<float>(0+2*k,2,0);		p[7] = Point3D<float>(2+2*k,2,0);
		p[2] = (p[1]+p[3])/2.0;	p[4] = (p[3]+p[5])/2.0;	p[6] = (p[5]+p[7])/2.0;

		p[9] = Point3D<float>(3+2*k,2,0);	p[10] = Point3D<float>(3+1*k,1,0);	p[11] = Point3D<float>(3+r,0,0);
		p[12] = Point3D<float>(1+1*k,1,0);

		UnitVector3D<float> v   = UnitVector<float,3>(p[1]-p[7])+UnitVector<float,3>(p[9]-p[7]);
		Vector3D<float>		vnt = v^Vector3D<float>(0,0,-1);

		v	= UnitVector<float,3>(p[8]-p[10])+UnitVector<float,3>(p[9]-p[10]);
		Vector3D<float>		vnb = v^Vector3D<float>(0,0,1);



		dt=1.0/res5;//res5
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2_2deg(1,p[10],p[9],p[7],i*dt,true,false,vnb),
						  eval2_2deg(1,p[10],p[9],p[7],(i+1)*dt,true,false,vnb),r)*=ma;

		dt=1.0/res5;//res5
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2_2deg(1,p[7],p[6],p[12],i*dt,false,false),
						  eval2_2deg(1,p[7],p[6],p[12],(i+1)*dt,false,false),r)*=ma;		

		dt=1.0/res6;		
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[12],p[10],i*dt,false,true,vnb),
						  eval1_2deg(p[12],p[10],(i+1)*dt,false,true,vnb),r)*=ma;

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(p[2*j],p[2*j+1],p[2*j+2],i*dt),eval2deg(p[2*j],p[2*j+1],p[2*j+2],(i+1)*dt),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2_2deg(1,p[12],p[2],p[1],i*dt,false,false,Vector3D<float>(1,-k,0)),
						  eval2_2deg(1,p[12],p[2],p[1],(i+1)*dt,false,false,Vector3D<float>(1,-k,0)),r)*=ma;

		dt=1.0/res6;		
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[1],p[11],i*dt,false,true,Vector3D<float>(1,-k,0)),
						  eval1_2deg(p[1],p[11],(i+1)*dt,false,true,Vector3D<float>(1,-k,0)),r)*=ma;	

/*		p[1] -= Vector3D<float>(0+r*k,r,0);
		p[7] += Vector3D<float>(0+r*k,r,0);

		dt=1.0/res6;		// Make i
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[1],p[7],i*dt,true,true,Vector3D<float>(0,1,0),vnt),
			eval1_2deg(p[1],p[7],(i+1)*dt,true,true,Vector3D<float>(0,1,0),vnt),r)*=ma;		*/

		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(0,1,0)),r)*=ma;			
		a += GO_Strip(Arrow<float,3>(p[11],Vector3D<float>(-1,k,0)),r)*=ma;

	}

	int		size_aa(int res=32) { int res5 = res*5/10.0, res6 = res*6/10.0; return 4*res5+res6+2; }
	float	length_aa(double r=0.35) {return 2+2*r;}

	void	make_aa(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[18];
		double dt;
		int i,j;
		int res5 = res*5/10.0;
		int res6 = res*6/10.0;

		p[0] = p[8] = Point3D<float>(2+k,1,0);
		p[1] = Point3D<float>(2,0,0);			p[3] = Point3D<float>(0,0,0);
		p[5] = Point3D<float>(0+2*k,2,0);		p[7] = Point3D<float>(2+2*k,2,0);
		p[2] = (p[1]+p[3])/2.0;	p[4] = (p[3]+p[5])/2.0;	p[6] = (p[5]+p[7])/2.0;

		p[9] = p[17] = Point3D<float>(1.25+3*k,3,0);
		p[10] = Point3D<float>(1.25+2.75*k,2.75,0);			p[12] = Point3D<float>(0.75+2.75*k,2.75,0);
		p[14] = Point3D<float>(0.75+3.25*k,3.25,0);			p[16] = Point3D<float>(1.25+3.25*k,3.25,0);
		p[11] = (p[10]+p[12])/2.0;	p[13] = (p[12]+p[14])/2.0;	p[15] = (p[14]+p[16])/2.0;


		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(p[2*j],p[2*j+1],p[2*j+2],i*dt),eval2deg(p[2*j],p[2*j+1],p[2*j+2],(i+1)*dt),r)*=ma;

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(p[2*j+9],p[2*j+10],p[2*j+11],i*dt),eval2deg(p[2*j+9],p[2*j+10],p[2*j+11],(i+1)*dt),0.6*r)*=ma;





		p[1] -= Vector3D<float>(0+r*k,r,0);
		p[7] += Vector3D<float>(0+r*k,r,0);
		dt=1.0/res6;		// Make i
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[1],p[7],i*dt,true,true),eval1_2deg(p[1],p[7],(i+1)*dt,true,true),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[7],Vector3D<float>(0,-1,0)),r)*=ma;

	}


	int		size_D(int res=32) { int res6 = res*6/10.0,res15 = res*15/10.0; int res3 = res*3/10.0; return res15+2*res6; }
	float	length_D(double r=0.35) {return 3+2*r;}

	void	make_D(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> g[5];
		double dt;
		int i;
		int res6 = res*6/10.0;
		int res15 = res*15/10.0;

		g[0]  = Point3D<float>(5*k,5,0);				g[1]  = Point3D<float>(3+5*k,5,0);
		g[2]  = Point3D<float>(3+2.5*k,2.5,0);			g[3]  = Point3D<float>(3,0,0);
		g[4]  = Point3D<float>(0,0,0);


		dt=1.0/res15;	// Make D
		for(i=0; i<(int)(res*15/10.0);i++)
			a += GO_Strip(eval1_2deg(g[0],g[4],i*dt,true,true,Vector3D<float>(1+k,1,0),Vector3D<float>(-1+k,1,0)),
			eval1_2deg(g[0],g[4],(i+1)*dt,true,true,Vector3D<float>(1+k,1,0),Vector3D<float>(-1+k,1,0)),r)*=ma;
		dt=1.0/res6;				
		for(i=0; i< res6; i++)
			a += GO_Strip(eval2deg(g[0],g[1],g[2],i*dt,true,false,Vector3D<float>(1+k,1,0)),
			eval2deg(g[0],g[1],g[2],(i+1)*dt,true,false,Vector3D<float>(1+k,1,0)),r)*=ma;

		for(i=0; i<res6;i++)
			a += GO_Strip(eval2deg(g[2],g[3],g[4],i*dt,false,true,Vector3D<float>(-1+k,1,0)),
			eval2deg(g[2],g[3],g[4],(i+1)*dt,false,true,Vector3D<float>(-1+k,1,0)),r)*=ma;

	}

	int		size_E(int res=32) { int res15 = res*15/10.0; int res5 = res*5/10.0; return res15+3*res5+3; }
	float	length_E(double r=0.35) {return 3+2*r;}

	void	make_E(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> b[4], lo[2];
		double dt;
		int i;
		int res15 = res*15/10.0;
		int res5 = res*5/10.0;

		lo[0] = Point3D<float>(0,0,0);			lo[1] = Point3D<float>(5*k,5,0);

		b[1] = Point3D<float>(3+5*k,5,0);		b[0] = Point3D<float>(3,0,0);
		b[3] = Point3D<float>(2.5*k,2.5,0);		b[2] = Point3D<float>(2+2.5*k,2.5,0);

		UnitVector3D<float> v = UnitVector<float,3>(lo[0]-lo[1])+UnitVector<float,3>(b[1]-lo[1]);
		Vector3D<float> vnt = v^Vector3D<float>(0,0,-1);

		v = UnitVector<float,3>(lo[1]-lo[0])+UnitVector<float,3>(b[0]-lo[0]);
		Vector3D<float> vnb = v^Vector3D<float>(0,0,-1);

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(b[2],b[3],i*dt,true,false,Vector3D<float>(-1,+k,0)),
			eval1_2deg(b[2],b[3],(i+1)*dt,true,false,Vector3D<float>(-1,+k,0)),r)*=ma;

		dt=1.0/res15;	// Make E
		for(i=0; i<(int)(res*15/10.0);i++)
			a += GO_Strip(eval1_2deg(lo[0],lo[1],i*dt,true,true,vnb,vnt),
			eval1_2deg(lo[0],lo[1],(i+1)*dt,true,true,vnb,vnt),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(lo[0],b[0],i*dt,true,true,vnb,Vector3D<float>(-1,k,0)),
			eval1_2deg(lo[0],b[0],(i+1)*dt,true,true,vnb,Vector3D<float>(-1,k,0)),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(lo[1],b[1],i*dt,true,true,vnt,Vector3D<float>(1,-k,0)),
			eval1_2deg(lo[1],b[1],(i+1)*dt,true,true,vnt,Vector3D<float>(1,-k,0)),r)*=ma;

		a += GO_Strip(Arrow<float,3>(b[1],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(b[2],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(b[0],Vector3D<float>(-1,k,0)),r)*=ma;
	}

	int		size_F(int res=32) { int res15 = res*15/10.0; int res5 = res*5/10.0; return res15+2*res5+3; }
	float	length_F(double r=0.35) {return 3+2*r;}

	void	make_F(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> b[4], lo[2];
		double dt;
		int i;
		int res15 = res*15/10.0;
		int res5 = res*5/10.0;

		lo[0] = Point3D<float>(-r*k,-r,0);			lo[1] = Point3D<float>(5*k,5,0);

		b[1] = Point3D<float>(3+5*k,5,0);		b[0] = Point3D<float>(3,0,0);
		b[3] = Point3D<float>(2.5*k,2.5,0);		b[2] = Point3D<float>(2+2.5*k,2.5,0);


		dt=1.0/res15;	
		for(i=0; i<(int)(res*15/10.0);i++)
			a += GO_Strip(eval1_2deg(lo[0],lo[1],i*dt,true,true,Vector3D<float>(0,1+k,0),Vector3D<float>(1+k,1,0)),
			eval1_2deg(lo[0],lo[1],(i+1)*dt,true,true,Vector3D<float>(0,1+k,0),Vector3D<float>(1+k,1,0)),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(lo[1],b[1],i*dt,true,true,Vector3D<float>(1+k,1,0),Vector3D<float>(1,-k,0)),
			eval1_2deg(lo[1],b[1],(i+1)*dt,true,true,Vector3D<float>(1+k,1,0),Vector3D<float>(1,-k,0)),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(b[2],b[3],i*dt,true,false,Vector3D<float>(-1,+k,0)),
			eval1_2deg(b[2],b[3],(i+1)*dt,true,false,Vector3D<float>(-1,+k,0)),r)*=ma;


		a += GO_Strip(Arrow<float,3>(b[1],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(b[2],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[0],Vector3D<float>(0,1,0)),r)*=ma;
	}

	int		size_J(int res=32) { int res6 = res*6/10.0; int res2 = res*2/10.0; return res6*3+2; }
	float	length_J(double r=0.35) {return 3+2*r;}

	void	make_J(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[6];
		double dt;
		int i;
		int res6 = res*6/10.0;

		p[0] = Point3D<float>(3+(5+r)*k,5+r,0);		p[1] = Point3D<float>(3+1.5*k,1.5,0);
		p[2] = Point3D<float>(3,0,0);				p[3] = Point3D<float>(1.5,0,0);
		p[4] = Point3D<float>(0,0,0);				p[5] = Point3D<float>((1.5+r)*k,1.5+r,0);


		dt=1.0/res6;		
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[0],p[1],i*dt,true,false,Vector3D<float>(0,-1,0)),
			eval1_2deg(p[0],p[1],(i+1)*dt,true,false,Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res6;
		for(i=0; i<res6;i++)
			a += GO_Strip(eval2deg(p[1],p[2],p[3],i*dt,false,false),
			eval2deg(p[1],p[2],p[3],(i+1)*dt,false,false),r)*=ma;	
		dt=1.0/res6;
		for(i=0; i<res6;i++)
			a += GO_Strip(eval2deg(p[3],p[4],p[5],i*dt,false,true,Vector3D<float>(0,1,0)),
			eval2deg(p[3],p[4],p[5],(i+1)*dt,false,true,Vector3D<float>(0,1,0)),r)*=ma;	

		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[5],Vector3D<float>(0,-1,0)),r)*=ma;
	}

	int		size_U(int res=32) { int res6 = res*6/10.0; return res6*4+2; }
	float	length_U(double r=0.35) {return 3+2*r;}

	void	make_U(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[7];
		double dt;
		int i;
		int res6 = res*6/10.0;

		p[0] = Point3D<float>(3+(5+r)*k,5+r,0);		p[1] = Point3D<float>(3+1.5*k,1.5,0);
		p[2] = Point3D<float>(3,0,0);				p[3] = Point3D<float>(1.5,0,0);
		p[4] = Point3D<float>(0,0,0);				p[5] = Point3D<float>((1.5+r)*k,1.5+r,0);
		p[6] = Point3D<float>((5+r)*k,5+r,0);


		dt=1.0/res6;		
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[0],p[1],i*dt,true,false,Vector3D<float>(0,-1,0)),
			eval1_2deg(p[0],p[1],(i+1)*dt,true,false,Vector3D<float>(0,-1,0)),r)*=ma;
		dt=1.0/res6;
		for(i=0; i<res6;i++)
			a += GO_Strip(eval2deg(p[1],p[2],p[3],i*dt,false,false),
			eval2deg(p[1],p[2],p[3],(i+1)*dt,false,false),r)*=ma;	
		dt=1.0/res6;
		for(i=0; i<res6;i++)
			a += GO_Strip(eval2deg(p[3],p[4],p[5],i*dt,false,false),
			eval2deg(p[3],p[4],p[5],(i+1)*dt,false,false),r)*=ma;	
		dt=1.0/res6;		
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1_2deg(p[5],p[6],i*dt,false,true,Vector3D<float>(0,1,0)),
			eval1_2deg(p[5],p[6],(i+1)*dt,false,true,Vector3D<float>(0,1,0)),r)*=ma;


		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[6],Vector3D<float>(0,-1,0)),r)*=ma;
	}

	int		size_K(int res=32) { int res5=res*5/10.0, res6=res*6/10.0; return 2*res5+res6+4; }
	float	length_K(double r=0.35) {return 3+2*r;}

	void	make_K(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[5];
		double dt;
		int i;
		int res6 = res*6/10.0;
		int res5 = res*5/10.0;


		p[0] = Point3D<float>(-r*k,-r,0);			p[1] = Point3D<float>(0+2.25*k,2.25,0);		
		p[2] = Point3D<float>((5+r)*k,5+r,0);		p[3] = Point3D<float>(3-r*k,-r,0);	
		p[4] = Point3D<float>(3+(5+r)*k,5+r,0);		



		dt=1.0/res6;		// Make l
		for(i=0; i<res6; i++)
			a += GO_Strip(eval1deg(p[0],p[2],i*dt,true,true),
			eval1deg(p[0],p[2],(i+1)*dt,true,true),r)*=ma;

		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[2],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res5;		// Make n
		for(i=0; i<res5; i++)
			a += GO_Strip(eval1deg(p[4],p[1],i*dt,true,true/*,Vector3D<float>(0,-1,0)*/),
			eval1deg(p[4],p[1],(i+1)*dt,true,true/*,Vector3D<float>(0,-1,0)*/),r)*=ma;

		a += GO_Strip(Arrow<float,3>(p[4],Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res5;		// Make n
		for(i=0; i<res5; i++)
			a += GO_Strip(eval1deg(p[3],p[1],i*dt,true,true),/*Vector3D<float>(0,k,0)*/
			eval1deg(p[3],p[1],(i+1)*dt,true,true),r)*=ma;/*Vector3D<float>(0,k,0)*/

		a += GO_Strip(Arrow<float,3>(p[3],Vector3D<float>(0,1,0)),r)*=ma;
	}

	int		size_O(int res=32) { int res5 = res*5/10.0; return 4*res5; }
	float	length_O(double r=0.35) {return 3+2*r;}

	void	make_O(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[9];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = p[8] = Point3D<float>(3+2.5*k,2.5,0);
		p[1] = Point3D<float>(3,0,0);			p[3] = Point3D<float>(0,0,0);
		p[5] = Point3D<float>(0+5*k,5,0);		p[7] = Point3D<float>(3+5*k,5,0);
		p[2] = (p[1]+p[3])/2.0;	p[4] = (p[3]+p[5])/2.0;	p[6] = (p[5]+p[7])/2.0;

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(p[2*j],p[2*j+1],p[2*j+2],i*dt),eval2deg(p[2*j],p[2*j+1],p[2*j+2],(i+1)*dt),r)*=ma;
	}

	int		size_P(int res=32) { int res15 = res*15/10.0; int res5 = res*5/10.0; return res15+4*res5+2; }
	float	length_P(double r=0.35) {return 3+2*r;}

	void	make_P(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> b[9], lo[2];
		double dt;
		int i;
		int res15 = res*15/10.0;
		int res5 = res*5/10.0;

		lo[0] = Point3D<float>(-r*k,-r,0);			lo[1] = Point3D<float>(5*k,5,0);

		b[1] = Point3D<float>(3+5*k,5,0);		b[2] = Point3D<float>(3+3.75*k,3.75,0);
		b[3] = Point3D<float>(2.5*k,2.5,0);		b[4] = Point3D<float>(3+2.5*k,2.5,0);
		b[5] = Point3D<float>(3+1.25*k,1.25,0);	b[0] = Point3D<float>(3,0,0);
		b[6] = (0.6*lo[1]+0.4*b[1]);	b[7] = (0.6*b[3]+0.4*b[4]);		b[8] = (0.6*lo[0]+0.4*b[0]);	

		dt=1.0/res15;	
		for(i=0; i<(int)(res*15/10.0);i++)
			a += GO_Strip(eval1_2deg(lo[0],lo[1],i*dt,true,true,Vector3D<float>(0,1,0),Vector3D<float>(1+k,1,0)),
			eval1_2deg(lo[0],lo[1],(i+1)*dt,true,true,Vector3D<float>(0,1,0),Vector3D<float>(1+k,1,0)),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[6],b[1],b[2],i*dt,false,false),
			eval2deg(b[6],b[1],b[2],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[2],b[4],b[7],i*dt,false,false),
			eval2deg(b[2],b[4],b[7],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(lo[1],b[6],i*dt,true,false,Vector3D<float>(1+k,1,0)),
			eval1_2deg(lo[1],b[6],(i+1)*dt,true,false,Vector3D<float>(1+k,1,0)),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(b[7],b[3],i*dt,false,false),
			eval1_2deg(b[7],b[3],(i+1)*dt,false,false),r)*=ma;

		a += GO_Strip(Arrow<float,3>(lo[0],Vector3D<float>(0,1,0)),r)*=ma;
	}

	int		size_R(int res=32) { int res15 = res*15/10.0; int res5 = res*5/10.0; return res15+4*res5+2; }
	float	length_R(double r=0.35) {return 3+2*r;}

	void	make_R(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> b[9], lo[2];
		double dt;
		int i;
		int res15 = res*15/10.0;
		int res5 = res*5/10.0;

		lo[0] = Point3D<float>(-r*k,-r,0);			lo[1] = Point3D<float>(5*k,5,0);

		b[1] = Point3D<float>(3+5*k,5,0);		b[2] = Point3D<float>(3+3.75*k,3.75,0);
		b[3] = Point3D<float>(2.5*k,2.5,0);		b[4] = Point3D<float>(3+2.5*k,2.5,0);
		b[5] = Point3D<float>(3+1.25*k,1.25,0);	b[0] = Point3D<float>(3+r-r*k,-r,0);
		b[6] = (0.6*lo[1]+0.4*b[1]);	b[7] = (0.6*b[3]+0.4*b[4]);		b[8] = (0.6*lo[0]+0.4*b[0]);	

		dt=1.0/res15;	
		for(i=0; i<(int)(res*15/10.0);i++)
			a += GO_Strip(eval1_2deg(lo[0],lo[1],i*dt,true,true,Vector3D<float>(0,1,0),Vector3D<float>(1+k,1,0)),
			eval1_2deg(lo[0],lo[1],(i+1)*dt,true,true,Vector3D<float>(0,1,0),Vector3D<float>(1+k,1,0)),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[6],b[1],b[2],i*dt,false,false),
			eval2deg(b[6],b[1],b[2],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[2],b[4],b[7],i*dt,false,false),
			eval2deg(b[2],b[4],b[7],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(lo[1],b[6],i*dt,true,false,Vector3D<float>(1+k,1,0)),
			eval1_2deg(lo[1],b[6],(i+1)*dt,true,false,Vector3D<float>(1+k,1,0)),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(b[7],b[3],i*dt,false,false),
			eval1_2deg(b[7],b[3],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(b[3],b[0],i*dt,false,true,Vector3D<float>(0,-1,0)),
			eval1_2deg(b[3],b[0],(i+1)*dt,false,true,Vector3D<float>(0,-1,0)),r)*=ma;

		a += GO_Strip(Arrow<float,3>(lo[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(b[0],Vector3D<float>(0,1.25,0)),r)*=ma;
	}

	int		size_Q(int res=32) { int res5 = res*5/10.0; return 4*res5; }
	float	length_Q(double r=0.35) {return 3+2*r;}

	void	make_Q(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[11];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = p[8] = Point3D<float>(3+2.5*k,2.5,0);
		p[1] = Point3D<float>(3,0,0);			p[3] = Point3D<float>(0,0,0);
		p[5] = Point3D<float>(0+5*k,5,0);		p[7] = Point3D<float>(3+5*k,5,0);
		p[2] = (p[1]+p[3])/2.0;	p[4] = (p[3]+p[5])/2.0;	p[6] = (p[5]+p[7])/2.0;
		p[9] = Point3D<float>(2-r+(0.5+r)*k,0.5+r,0);		p[10] = Point3D<float>(3-r-r*k,-r,0);

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2deg(p[2*j],p[2*j+1],p[2*j+2],i*dt),eval2deg(p[2*j],p[2*j+1],p[2*j+2],(i+1)*dt),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1_2deg(p[9],p[10],i*dt,true,true,Vector3D<float>(0,-1,0),Vector3D<float>(0,-1,0)),
			eval1_2deg(p[9],p[10],(i+1)*dt,true,true,Vector3D<float>(0,-1,0),Vector3D<float>(0,-1,0)),r)*=ma;

		a += GO_Strip(Arrow<float,3>(p[9],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[10],Vector3D<float>(0,1,0)),r)*=ma;
	}

	int		size_S(int res=32) { int res5=res*5/10.0; return 6*res5+2; }
	float	length_S(double r=0.35) {return 3+2*r;}

	void	make_S(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[11];
		double dt;
		int i;
		int res5 = res*5/10.0;


		p[0] = Point3D<float>(3+r+5*k,5,0);		p[2] = Point3D<float>(5*k,5,0);	
		p[1] = (p[0]+p[2])/2.0;					p[4] = Point3D<float>(2.5*k,2.5,0);
		p[3] = (p[2]+p[4])/2.0;					p[6] = Point3D<float>(3+2.5*k,2.5,0);
		p[5] = (p[4]+p[6])/2.0;					p[8] = Point3D<float>(3,0,0);
		p[7] = (p[6]+p[8])/2.0;					p[10] = Point3D<float>(-r,0,0);	
		p[9] = (p[8]+p[10])/2.0;		


		dt=1.0/res5;		
		for(i=0; i<res5; i++)
			a += GO_Strip(eval1_2deg(p[0],p[1],i*dt,true,false,Vector3D<float>(-1,k,0)),
			eval1_2deg(p[0],p[1],(i+1)*dt,true,false,Vector3D<float>(-1,k,0)),r)*=ma;		

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[1],p[2],p[3],i*dt),
			eval2deg(p[1],p[2],p[3],(i+1)*dt),r)*=ma;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[3],p[4],p[5],i*dt),
			eval2deg(p[3],p[4],p[5],(i+1)*dt),r)*=ma;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[5],p[6],p[7],i*dt),
			eval2deg(p[5],p[6],p[7],(i+1)*dt),r)*=ma;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(p[7],p[8],p[9],i*dt),
			eval2deg(p[7],p[8],p[9],(i+1)*dt),r)*=ma;

		dt=1.0/res5;		
		for(i=0; i<res5; i++)
			a += GO_Strip(eval1_2deg(p[10],p[9],i*dt,true,false,Vector3D<float>(1,-k,0)),
			eval1_2deg(p[10],p[9],(i+1)*dt,true,false,Vector3D<float>(1,-k,0)),r)*=ma;	


		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[10],Vector3D<float>(1,-k,0)),r)*=ma;
	}

	int		size_V(int res=32) { int res5 = res*5/10.0; return 2*res5+3; }
	float	length_V(double r=0.35) {return 3+2*r;}

	void	make_V(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[3];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = Point3D<float>((5+r)*k,5+r,0);		p[1] = Point3D<float>(3+(5+r)*k,5+r,0);
		p[2] = Point3D<float>(1.5-r*k,-r,0);			

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[0],p[2],i*dt,true,true),
				eval1deg(p[0],p[2],(i+1)*dt,true,true),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[1],p[2],i*dt,true,true),
				eval1deg(p[1],p[2],(i+1)*dt,true,true),r)*=ma; 

		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[2],Vector3D<float>(0,1,0)),r)*=ma;
	}

	int		size_W(int res=32) { int res5 = res*5/10.0; return 4*res5+5; }
	float	length_W(double r=0.35) {return 3+2*r;}

	void	make_W(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[5];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = Point3D<float>((5+r)*k,5+r,0);		p[1] = Point3D<float>(1.5+(4+r)*k,4+r,0);
		p[2] = Point3D<float>(0.75-r*k,-r,0);		p[3] = Point3D<float>(3+(5+r)*k,5+r,0);		
		p[4] = Point3D<float>(2.25-r*k,-r,0);

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[0],p[2],i*dt,true,true),
				eval1deg(p[0],p[2],(i+1)*dt,true,true),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[1],p[2],i*dt,true,true),
				eval1deg(p[1],p[2],(i+1)*dt,true,true),r)*=ma; 
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[1],p[4],i*dt,true,true),
				eval1deg(p[1],p[4],(i+1)*dt,true,true),r)*=ma; 
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[4],p[3],i*dt,true,true),
				eval1deg(p[4],p[3],(i+1)*dt,true,true),r)*=ma; 



		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[2],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[3],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[4],Vector3D<float>(0,1,0)),r)*=ma;
	}

	int		size_X(int res=32) { int res5 = res*5/10.0; return 2*res5+4; }
	float	length_X(double r=0.35) {return 3+2*r;}

	void	make_X(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[4];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = Point3D<float>((5+r)*k,5+r,0);		p[1] = Point3D<float>(3+(5+r)*k,5+r,0);
		p[2] = Point3D<float>(-r*k,-r,0);			p[3] = Point3D<float>(3-r*k,-r,0);

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[0],p[3],i*dt,true,true),
				eval1deg(p[0],p[3],(i+1)*dt,true,true),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[1],p[2],i*dt,true,true),
				eval1deg(p[1],p[2],(i+1)*dt,true,true),r)*=ma; 

		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[2],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[3],Vector3D<float>(0,1,0)),r)*=ma;
	}

	int		size_y(int res=32) { int res5 = res*5/10.0; return 2*res5+4; }
	float	length_y(double r=0.35) {return 2+2*r;}

	void	make_y(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[4];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = Point3D<float>((2+r)*k,2+r,0);		p[1] = Point3D<float>(2+(2+r)*k,2+r,0);
		p[2] = Point3D<float>((-2-r)*k,-2-r,0);			p[3] = Point3D<float>(1,0,0);

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1_2deg(p[0],p[3],i*dt,true,false,Vector3D<float>(0,-1,0)),
				eval1_2deg(p[0],p[3],(i+1)*dt,true,false,Vector3D<float>(0,-1,0)),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[1],p[2],i*dt,true,true),
				eval1deg(p[1],p[2],(i+1)*dt,true,true),r)*=ma; 

		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[2],Vector3D<float>(0,1,0)),r)*=ma;
	}

	int		size_Y(int res=32) { int res5 = res*5/10.0; return 2*res5+4; }
	float	length_Y(double r=0.35) {return 3+2*r;}

	void	make_Y(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[4];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = Point3D<float>((5+r)*k,5+r,0);		p[1] = Point3D<float>(3+(5+r)*k,5+r,0);
		p[2] = Point3D<float>(1.5+2.5*k,2.5,0);			p[3] = Point3D<float>(1.5-r*k,-r,0);

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[0],p[2],i*dt,true,true),
				eval1deg(p[0],p[2],(i+1)*dt,true,true),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[1],p[2],i*dt,true,true),
				eval1deg(p[1],p[2],(i+1)*dt,true,true),r)*=ma; 
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1deg(p[2],p[3],i*dt,true,true),
				eval1deg(p[2],p[3],(i+1)*dt,true,true),r)*=ma; 


		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[3],Vector3D<float>(0,1,0)),r)*=ma;
	}
	/*
	int		size_4(int res=32) { int res5 = res*5/10.0; return 2*res5+4; }
	float	length_4(double r=0.35) {return 3+2*r;}

	void	make_4(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
	Point<float,3> p[5];
	double dt;
	int i,j;
	int res5 = res*5/10.0;

	p[0] = Point3D<float>((5+r)*k,5+r,0);		p[1] = Point3D<float>(3+(5+r)*k,5+r,0);
	p[2] = Point3D<float>(2.5*k,2.5,0);				p[3] = Point3D<float>(3+2.5*k,2.5,0);
	p[4] = Point3D<float>(3-r*k,-r,0);

	dt=1.0/res5;
	for(j=0; j<4; j++)
	for(i=0; i<res5;i++)
	a += GO_Strip(eval1deg(p[1],p[4],i*dt,true,true),
	eval1deg(p[1],p[4],(i+1)*dt,true,true),r)*=ma;
	dt=1.0/res5;
	for(j=0; j<4; j++)
	for(i=0; i<res5;i++)
	a += GO_Strip(eval1_2deg(p[0],p[2],i*dt,true,true,Vector3D<float>(0,-1,0),Vector3D<float>(1,-1-k,0)),
	eval1_2deg(p[0],p[2],(i+1)*dt,true,true,Vector3D<float>(0,-1,0),Vector3D<float>(1,-1-k,0)),r)*=ma; 
	dt=1.0/res5;
	for(j=0; j<4; j++)
	for(i=0; i<res5;i++)
	a += GO_Strip(eval1_2deg(p[2],p[3],i*dt,true,true,Vector3D<float>(1,-1-k,0),Vector3D<float>(1,-k,0)),
	eval1_2deg(p[2],p[3],(i+1)*dt,true,true,Vector3D<float>(1,-1-k,0),Vector3D<float>(1,-k,0)),r)*=ma; 


	a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,-1,0)),r)*=ma;
	a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(0,-1,0)),r)*=ma;
	a += GO_Strip(Arrow<float,3>(p[4],Vector3D<float>(0,1,0)),r)*=ma;

	}*/

	int		size_4(int res=32) { int res5 = res*5/10.0; return 2*res5+4; }
	float	length_4(double r=0.35) {return 3+2*r;}

	void	make_4(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[5];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = Point3D<float>(3.5+2*k,2,0);		p[1] = Point3D<float>(3+(5+r)*k,5+r,0);
		p[2] = Point3D<float>(2*k,2,0);				p[3] = Point3D<float>(3+2.5*k,2.5,0);
		p[4] = Point3D<float>(3-r*k,-r,0);

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1_1deg(p[1],p[4],i*dt,true,true),
				eval1_1deg(p[1],p[4],(i+1)*dt,true,true),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1_1deg(p[1],p[2],i*dt,true,true,Vector3D<float>(0,-1,0),Vector3D<float>(-1,k,0)),
				eval1_1deg(p[1],p[2],(i+1)*dt,true,true,Vector3D<float>(0,-1,0),Vector3D<float>(-1,k,0)),r)*=ma; 
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1_1deg(p[2],p[0],i*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),
				eval1_1deg(p[2],p[0],(i+1)*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),r)*=ma; 


		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[4],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[2],Vector3D<float>(1,-k,0)),r)*=ma;

	}

	int		size_Z(int res=32) { int res5 = res*5/10.0; return 4*res5+4; }
	float	length_Z(double r=0.35) {return 3+2*r;}

	void	make_Z(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[7];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[4] = Point3D<float>(0.5,0,0);		
		p[5] = Point3D<float>(-r,0,0);			p[6] = Point3D<float>(3+r,0,0);

		p[0] = Point3D<float>(-r+5*k,5,0);		p[1] = Point3D<float>(3+r+5*k,5,0);
		p[2] = Point3D<float>(2.5+5*k,5,0);		p[3] = Point3D<float>(1.5+2.5*k,2.5,0);

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1_2deg(p[0],p[1],i*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),
				eval1_2deg(p[0],p[1],(i+1)*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1_2deg(p[6],p[5],i*dt,true,true,Vector3D<float>(-1,k,0),Vector3D<float>(-1,k,0)),
				eval1_2deg(p[6],p[5],(i+1)*dt,true,true,Vector3D<float>(-1,k,0),Vector3D<float>(-1,k,0)),r)*=ma;

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2_2deg(0.5,p[1],p[2],p[3],i*dt,true,false,Vector3D<float>(-1,k,0),Vector3D<float>(0,-1,0)),
				eval2_2deg(0.5,p[1],p[2],p[3],(i+1)*dt,true,false,Vector3D<float>(-1,k,0),Vector3D<float>(0,-1,0)),r)*=ma;

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2_2deg(0.5,p[5],p[4],p[3],i*dt,true,false,Vector3D<float>(1,-k,0),Vector3D<float>(0,1,0)),
				eval2_2deg(0.5,p[5],p[4],p[3],(i+1)*dt,true,false,Vector3D<float>(1,-k,0),Vector3D<float>(0,1,0)),r)*=ma;



		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(1,-k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[5],Vector3D<float>(1,-k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[6],Vector3D<float>(-1,k,0)),r)*=ma;
	}

	int		size_5(int res=32) { int res15 = res*15/10.0; int res5 = res*5/10.0; return 6*res5+3; }
	float	length_5(double r=0.35) {return 3+2*r;}

	void	make_5(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> b[11], lo[2];
		double dt;
		int i;
		int res5 = res*5/10.0;

		lo[0] = Point3D<float>(0,0,0);			lo[1] = Point3D<float>(0.5+5*k,5,0);

		b[1] = Point3D<float>(3+r+5*k,5,0);		b[2] = Point3D<float>(3+3.75*k,3.75,0);
		b[3] = Point3D<float>(2.25*k,2.25,0);		b[4] = Point3D<float>(3+3*k,3,0);
		b[5] = Point3D<float>(3+1.5*k,1.5,0);	b[0] = Point3D<float>(3,0,0);		b[10]= Point3D<float>(0.5+3*k,3,0);
		b[6] = Point3D<float>(0.17+2.7*k,2.7,0);		b[7] = Point3D<float>(1.5+3*k,3,0);		b[8] = (0.5*lo[0]+0.5*b[0]);
		b[9] = Point3D<float>(1*k,1,0);			

		UnitVector3D<float> v = UnitVector<float,3>(b[1]-lo[1])+UnitVector<float,3>(b[3]-lo[1]);
		Vector3D<float> vn = v^Vector3D<float>(0,0,-1);


		dt=1.0/res5;	
		for(i=0; i<(int)(res*5/10.0);i++)
			a += GO_Strip(eval1_2deg(b[3],lo[1],i*dt,true,true,Vector3D<float>(0,1,0),vn),
			eval1_2deg(b[3],lo[1],(i+1)*dt,true,true,Vector3D<float>(0,1,0),vn),r)*=ma;
		dt=1.0/res5;	
		for(i=0; i<(int)(res*5/10.0);i++)
			a += GO_Strip(eval1_2deg(lo[1],b[1],i*dt,true,true,vn,Vector3D<float>(1,-k,0)),
			eval1_2deg(lo[1],b[1],(i+1)*dt,true,true,vn,Vector3D<float>(1,-k,0)),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[6],b[10],b[7],i*dt,true,false,Vector3D<float>(1,0,0)),
			eval2deg(b[6],b[10],b[7],(i+1)*dt,true,false,Vector3D<float>(1,0,0)),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[5],b[0],b[8],i*dt,false,false),
			eval2deg(b[5],b[0],b[8],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[7],b[4],b[5],i*dt,false,false/*,Vector3D<float>(1,-k,0)*/),
			eval2deg(b[7],b[4],b[5],(i+1)*dt,false,false/*,Vector3D<float>(1,-k,0)*/),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[9],lo[0],b[8],i*dt,true,false,Vector3D<float>(0,-1,0)),
			eval2deg(b[9],lo[0],b[8],(i+1)*dt,true,false,Vector3D<float>(0,-1,0)),r)*=ma;

		a += GO_Strip(Arrow<float,3>(b[9],Vector3D<float>(0,-1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(b[1],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(b[3],Vector3D<float>(0,1,0)),r)*=ma;
	}

	int		size_6(int res=32) { int res15 = res*15/10.0; int res5 = res*5/10.0; return 6*res5+3; }
	float	length_6(double r=0.35) {return 3+2*r;}

	void	make_6(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> b[11], lo[2];
		double dt;
		int i;
		int res5 = res*5/10.0;

		lo[0] = Point3D<float>(0,0,0);			lo[1] = Point3D<float>(5*k,5,0);

		b[1] = Point3D<float>(3+5*k,5,0);		b[2] = Point3D<float>(3+4*k,4,0);
		b[3] = Point3D<float>(2.25*k,2.25,0);	b[4] = Point3D<float>(3+3*k,3,0);
		b[5] = Point3D<float>(3+1.5*k,1.5,0);	b[0] = Point3D<float>(3,0,0);		b[10]= Point3D<float>(3*k,3,0);
		b[6] = (0.5*lo[1]+0.5*b[1]);			b[7] = (0.5*b[4]+0.5*b[10]);		b[8] = (0.5*lo[0]+0.5*b[0]);
		b[9] = Point3D<float>(1.5*k,1.5,0);			


		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[9],b[10],b[7],i*dt,false,false),
			eval2deg(b[9],b[10],b[7],(i+1)*dt,false,false),r)*=ma;	
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[5],b[0],b[8],i*dt,false,false),
			eval2deg(b[5],b[0],b[8],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[7],b[4],b[5],i*dt,false,false),
			eval2deg(b[7],b[4],b[5],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[9],lo[0],b[8],i*dt,false,false),
			eval2deg(b[9],lo[0],b[8],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1deg(b[9],b[10],i*dt,false,false),
			eval1deg(b[9],b[10],(i+1)*dt,false,false),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[10],lo[1],b[6],i*dt,false,false),
			eval2deg(b[10],lo[1],b[6],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[6],b[1],b[2],i*dt,false,true,Vector3D<float>(0,-1,0)),
			eval2deg(b[6],b[1],b[2],(i+1)*dt,false,true,Vector3D<float>(0,-1,0)),r)*=ma;

		a += GO_Strip(Arrow<float,3>(b[2],Vector3D<float>(0,1,0)),r)*=ma;

	}

	int		size_7(int res=32) { int res5 = res*5/10.0; return 3*res5+4; }
	float	length_7(double r=0.35) {return 3+2*r;}

	void	make_7(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[4];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = Point3D<float>(-r+5*k,5,0);		p[1] = Point3D<float>(3+r+5*k,5,0);
		p[2] = Point3D<float>(2.5+5*k,5,0);			p[3] = Point3D<float>(1.5,-r,0);

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1_2deg(p[0],p[1],i*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),
				eval1_2deg(p[0],p[1],(i+1)*dt,true,true,Vector3D<float>(1,-k,0),Vector3D<float>(1,-k,0)),r)*=ma;

		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2_2deg(0.5,p[1],p[2],p[3],i*dt,true,true,Vector3D<float>(-1,k,0),Vector3D<float>(0,-1,0)),
				eval2_2deg(0.5,p[1],p[2],p[3],(i+1)*dt,true,true,Vector3D<float>(-1,k,0),Vector3D<float>(0,-1,0)),r)*=ma;
		/*	dt=1.0/res5;
		for(j=0; j<4; j++)
		for(i=0; i<res5;i++)
		a += GO_Strip(eval1_2deg(p[2],p[3],i*dt,,true,Vector3D<float>(-1+k,1,0),Vector3D<float>(-1,k,0)),
		eval1_2deg(p[2],p[3],(i+1)*dt,true,true,Vector3D<float>(-1+k,1,0),Vector3D<float>(-1,k,0)),r)*=ma;*/



		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(1,-k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[1],Vector3D<float>(-1,k,0)),r)*=ma;
		//	a += GO_Strip(Arrow<float,3>(p[2],Vector3D<float>(1,-k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[3],Vector3D<float>(0,1,0)),r)*=ma;
	}

	int		size_8(int res=32) { int res15 = res*15/10.0; int res5 = res*5/10.0; return 6*res5+3; }
	float	length_8(double r=0.35) {return 3+2*r;}

	void	make_8(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> b[13], lo[2];
		double dt;
		int i;
		int res5 = res*5/10.0;

		lo[0] = Point3D<float>(0,0,0);			lo[1] = Point3D<float>(0.25+5*k,5,0);

		b[1] = Point3D<float>(2.75+5*k,5,0);		b[2] = Point3D<float>(2.75+4*k,4,0);
		b[3] = Point3D<float>(0.25+4*k,4,0);			b[4] = Point3D<float>(3+3*k,3,0);
		b[5] = Point3D<float>(3+1.5*k,1.5,0);	b[0] = Point3D<float>(3,0,0);		b[10]= Point3D<float>(3*k,3,0);
		b[6] = (0.5*lo[1]+0.5*b[1]);			b[7] = (0.5*b[4]+0.5*b[10]);		b[8] = (0.5*lo[0]+0.5*b[0]);
		b[9] = Point3D<float>(1.5*k,1.5,0);			
		b[11] = Point3D<float>(0.25+3*k,3,0);		b[12] = Point3D<float>(2.75+3*k,3,0);			

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[9],b[10],b[7],i*dt,false,false),
			eval2deg(b[9],b[10],b[7],(i+1)*dt,false,false),r)*=ma;	
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[5],b[0],b[8],i*dt,false,false),
			eval2deg(b[5],b[0],b[8],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[7],b[4],b[5],i*dt,false,false),
			eval2deg(b[7],b[4],b[5],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[9],lo[0],b[8],i*dt,false,false),
			eval2deg(b[9],lo[0],b[8],(i+1)*dt,false,false),r)*=ma;	////
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[7],b[11],b[3],i*dt,false,false),
			eval2deg(b[7],b[11],b[3],(i+1)*dt,false,false),r)*=ma;		
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[3],lo[1],b[6],i*dt,false,false),
			eval2deg(b[3],lo[1],b[6],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[6],b[1],b[2],i*dt,false,false),
			eval2deg(b[6],b[1],b[2],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[2],b[12],b[7],i*dt,false,false),
			eval2deg(b[2],b[12],b[7],(i+1)*dt,false,false),r)*=ma;


	}

	int		size_91(int res=32) { int res15 = res*15/10.0; int res5 = res*5/10.0; return 6*res5+3; }
	float	length_91(double r=0.35) {return 3+2*r;}

	void	make_91(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> b[13], lo[2];
		double dt;
		int i;
		int res5 = res*5/10.0;

		lo[0] = Point3D<float>(0,0,0);			lo[1] = Point3D<float>(0+5*k,5,0);

		b[1] = Point3D<float>(3+5*k,5,0);		b[2] = Point3D<float>(3+4*k,4,0);
		b[3] = Point3D<float>(0+4*k,4,0);		b[4] = Point3D<float>(3+3*k,3,0);
		b[5] = Point3D<float>(3+1.5*k,1.5,0);	b[0] = Point3D<float>(3,0,0);		b[10]= Point3D<float>(3*k,3,0);
		b[6] = (0.5*lo[1]+0.5*b[1]);			b[7] = (0.5*b[4]+0.5*b[10]);		b[8] = (0.5*lo[0]+0.5*b[0]);
		b[9] = Point3D<float>(1*k,1,0);			
		b[11] = Point3D<float>(0+3*k,3,0);		b[12] = Point3D<float>(3+3*k,3,0);			


		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[5],b[0],b[8],i*dt,false,false),
			eval2deg(b[5],b[0],b[8],(i+1)*dt,false,false),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1deg(b[2],b[5],i*dt,false,false),
			eval1deg(b[2],b[5],(i+1)*dt,false,false),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[9],lo[0],b[8],i*dt,true,false,Vector3D<float>(0,-1,0)),
			eval2deg(b[9],lo[0],b[8],(i+1)*dt,true,false,Vector3D<float>(0,-1,0)),r)*=ma;	////
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[7],b[11],b[3],i*dt,false,false),
			eval2deg(b[7],b[11],b[3],(i+1)*dt,false,false),r)*=ma;		
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[3],lo[1],b[6],i*dt,false,false),
			eval2deg(b[3],lo[1],b[6],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[6],b[1],b[2],i*dt,false,false),
			eval2deg(b[6],b[1],b[2],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[2],b[12],b[7],i*dt,false,false),
			eval2deg(b[2],b[12],b[7],(i+1)*dt,false,false),r)*=ma;

		a += GO_Strip(Arrow<float,3>(b[9],Vector3D<float>(0,-1,0)),r)*=ma;


	}
	int		size_92(int res=32) { int res15 = res*15/10.0; int res5 = res*5/10.0; return 6*res5+3; }
	float	length_92(double r=0.35) {return 3+2*r;}

	void	make_92(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> b[13], lo[2];
		double dt;
		int i;
		int res5 = res*5/10.0;

		lo[0] = Point3D<float>(0,0,0);			lo[1] = Point3D<float>(0+5*k,5,0);

		b[1] = Point3D<float>(3+5*k,5,0);		b[2] = Point3D<float>(3+3.5*k,3.5,0);
		b[3] = Point3D<float>(0+3.5*k,3.5,0);		b[4] = Point3D<float>(3+2*k,2,0);
		b[5] = Point3D<float>(3+1.5*k,1.5,0);	b[0] = Point3D<float>(3,0,0);		b[10]= Point3D<float>(2*k,2,0);
		b[6] = (0.5*lo[1]+0.5*b[1]);			b[7] = (0.5*b[4]+0.5*b[10]);		b[8] = (0.5*lo[0]+0.5*b[0]);
		b[9] = Point3D<float>(1*k,1,0);			
		b[11] = Point3D<float>(0+3*k,3,0);		b[12] = Point3D<float>(3+3*k,3,0);			


		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[5],b[0],b[8],i*dt,false,false),
			eval2deg(b[5],b[0],b[8],(i+1)*dt,false,false),r)*=ma;


		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1deg(b[2],b[5],i*dt,false,false),
			eval1deg(b[2],b[5],(i+1)*dt,false,false),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[9],lo[0],b[8],i*dt,true,false,Vector3D<float>(0,-1,0)),
			eval2deg(b[9],lo[0],b[8],(i+1)*dt,true,false,Vector3D<float>(0,-1,0)),r)*=ma;	////
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[7],b[10],b[3],i*dt,false,false),
			eval2deg(b[7],b[10],b[3],(i+1)*dt,false,false),r)*=ma;		
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[3],lo[1],b[6],i*dt,false,false),
			eval2deg(b[3],lo[1],b[6],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[6],b[1],b[2],i*dt,false,false),
			eval2deg(b[6],b[1],b[2],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[2],b[4],b[7],i*dt,false,false),
			eval2deg(b[2],b[4],b[7],(i+1)*dt,false,false),r)*=ma;

		a += GO_Strip(Arrow<float,3>(b[9],Vector3D<float>(0,-1,0)),r)*=ma;


	}
	int		size_93(int res=32) { int res15 = res*15/10.0; int res5 = res*5/10.0; return 6*res5+3; }
	float	length_93(double r=0.35) {return 3+2*r;}

	void	make_93(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> b[13], lo[2];
		double dt;
		int i;
		int res5 = res*5/10.0;

		lo[0] = Point3D<float>(0,0,0);			lo[1] = Point3D<float>(0+5*k,5,0);

		b[1] = Point3D<float>(3+5*k,5,0);			b[2] = Point3D<float>(3+3.75*k,3.75,0);
		b[3] = Point3D<float>(0+3.75*k,3.75,0);		b[4] = Point3D<float>(3+2.5*k,2.5,0);
		b[5] = Point3D<float>(3+1.5*k,1.5,0);		b[0] = Point3D<float>(3,-r,0);				b[10]= Point3D<float>(2.5*k,2.5,0);
		b[6] = (0.5*lo[1]+0.5*b[1]);				b[7] = (0.5*b[4]+0.5*b[10]);				b[8] = (0.5*lo[0]+0.5*b[0]);
		
		b[9] = Point3D<float>(1*k,1,0);			
		b[11] = Point3D<float>(0+3*k,3,0);			b[12] = Point3D<float>(3+3*k,3,0);			


		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1deg(b[2],b[0],i*dt,false,true,Vector3D<float>(0,-1,0)),
						  eval1deg(b[2],b[0],(i+1)*dt,false,true,Vector3D<float>(0,-1,0)),r)*=ma;
		
		/*	dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[5],b[0],b[8],i*dt,false,false),
						  eval2deg(b[5],b[0],b[8],(i+1)*dt,false,false),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval1deg(b[2],b[5],i*dt,false,false),
						  eval1deg(b[2],b[5],(i+1)*dt,false,false),r)*=ma;

		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[9],lo[0],b[8],i*dt,true,false,Vector3D<float>(0,-1,0)),
						  eval2deg(b[9],lo[0],b[8],(i+1)*dt,true,false,Vector3D<float>(0,-1,0)),r)*=ma;	*/
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[7],b[10],b[3],i*dt,false,false),
						  eval2deg(b[7],b[10],b[3],(i+1)*dt,false,false),r)*=ma;		
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[3],lo[1],b[6],i*dt,false,false),
						  eval2deg(b[3],lo[1],b[6],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[6],b[1],b[2],i*dt,false,false),
						  eval2deg(b[6],b[1],b[2],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(b[2],b[4],b[7],i*dt,false,false),
						  eval2deg(b[2],b[4],b[7],(i+1)*dt,false,false),r)*=ma;

		a += GO_Strip(Arrow<float,3>(b[9],Vector3D<float>(0,-1,0)),r)*=ma;


	}

	int		size_1(int res=32) {  int res15 = res*15/10.0;return res15+2; }
	float	length_1(double r=0.35) {return 2*r;}

	void	make_1(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> lo[4];
		double dt;
		int i;
		int res15 = res*15/10.0;
		int res5 = res*5/10.0;
		//	Array<GO_Strip> a(res15+2);

		lo[0] = Point3D<float>(-r*k,-r,0);				lo[1] = Point3D<float>(5*k,5,0);
		lo[2] = Point3D<float>(-1+4.25*k,4.25,0);		lo[3] = Point3D<float>(4.25*k,4.25,0);


		dt=1.0/res15;	// Make l
		for(i=0; i<res15; i++)
			a += GO_Strip(eval1_2deg(lo[0],lo[1],i*dt,true,true,Vector3D<float>(0,1,0),Vector3D<float>(0,1,0)),
			eval1_2deg(lo[0],lo[1],(i+1)*dt,true,true,Vector3D<float>(0,1,0),Vector3D<float>(0,1,0)),r)*=ma;
		dt=1.0/res5;
		for(i=0; i<res5;i++)
			a += GO_Strip(eval2deg(lo[1],lo[3],lo[2],i*dt,true,true,Vector3D<float>(0,-1,0),Vector3D<float>(-1,k,0)),
			eval2deg(lo[1],lo[3],lo[2],(i+1)*dt,true,true,Vector3D<float>(0,-1,0),Vector3D<float>(-1,k,0)),r)*=ma;


		a += GO_Strip(Arrow<float,3>(lo[0],Vector3D<float>(0,sqrt(1+k*k),0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[1],Vector3D<float>(0,-sqrt(1+k*k),0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(lo[2],Vector3D<float>(1,-k,0)),r)*=ma;
	}


	int		size_pi(int res=32) { int res5 = res*5/10.0; return 3*res5+4; }
	float	length_pi(double r=0.35) {return 2+2*r;}

	void	make_pi(Array<GO_Strip>& a, const GL_Matrix& ma, double r=0.35, double k=0.3, int res=32)
	{
		Point<float,3> p[9];
		double dt;
		int i,j;
		int res5 = res*5/10.0;

		p[0] = Point3D<float>(1.75*k,1.75,0);		p[1] = Point3D<float>(2*k,2,0);
		p[2] = Point3D<float>(0.5+2*k,2,0);			p[3] = Point3D<float>(1.5+2*k,2,0);
		p[4] = Point3D<float>(2+r+2*k,2,0);			p[5] = Point3D<float>(-r,0,0);
		p[6] = Point3D<float>(0.5,0,0);				p[7] = Point3D<float>(1.5,0,0);
		p[8] = Point3D<float>(2+r,0,0);

		
		
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2_2deg(1,p[0],p[1],p[2],i*dt,true,false,Vector3D<float>(0,1,0)),
							  eval2_2deg(1,p[0],p[1],p[2],(i+1)*dt,true,false,Vector3D<float>(0,1,0)),r)*=ma;
		dt=1.0/res5;	
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1_2deg(p[2],p[3],i*dt,false,false),
							  eval1_2deg(p[2],p[3],(i+1)*dt,false,false),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1_2deg(p[3],p[4],i*dt,false,true,Vector3D<float>(1,-k,0)),
							  eval1_2deg(p[3],p[4],(i+1)*dt,false,true,Vector3D<float>(1,-k,0)),r)*=ma;
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2_2deg(0.2,p[5],p[6],p[2],i*dt,true,false,Vector3D<float>(1,0,0)),
							  eval2_2deg(0.2,p[5],p[6],p[2],(i+1)*dt,true,false,Vector3D<float>(1,0,0)),r)*=ma;
		
		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval2_2deg(0.2,p[8],p[7],p[3],i*dt,true,false,Vector3D<float>(-1,0,0)),
							  eval2_2deg(0.2,p[8],p[7],p[3],(i+1)*dt,true,false,Vector3D<float>(-1,0,0)),r)*=ma;

/*		dt=1.0/res5;
		for(j=0; j<4; j++)
			for(i=0; i<res5;i++)
				a += GO_Strip(eval1_2deg(p[2],p[6],i*dt,false,true,Vector3D<float>(0,-1,0)),
							  eval1_2deg(p[2],p[6],(i+1)*dt,false,true,Vector3D<float>(0,-1,0)),r)*=ma;	*/


		a += GO_Strip(Arrow<float,3>(p[0],Vector3D<float>(0,1,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[4],Vector3D<float>(-1,k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[5],Vector3D<float>(1,-k,0)),r)*=ma;
		a += GO_Strip(Arrow<float,3>(p[8],Vector3D<float>(-1,k,0)),r)*=ma;
	}
};

} // End namespace GM_lib